Sat Jul 31 20:29:17 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/OS.cpp: Moved the comment regarding *printf to where it
          belongs.

        * ace/OS.h: Removed an extra trailing semicolon following
          IPPROTO_TCP.

Sat Jul 31 19:27:50 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * examples/Shared_Malloc/test_position_independent_malloc.cpp:
          Now that position-independent malloc works, I finished
          integrating all the features in this test.

Sat Jul 31 19:06:05 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Pipe.cpp:
          The third argument to ACE_OS::setsockopt() is a "const char*" no
          sense in casting it to void*!

Sat Jul 31 18:55:34 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * ace/Asynch_IO_Impl.{h, cpp}:
          Fixed compiler errors: redefinition of destructors of the
          classes in this file. Removed inline declaration of destructors
          and defined those which hadnt been defined.

Sat Jul 31 17:54:32 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * etc/enforce_ace_try.diff:
          Apply this patch file and then compile to enforce the correct
          use of ACE_TRY macros. It renames the exception(), clear() and
          print_exception() methods in the CORBA::Environment class.

Sat Jul 31 17:39:42 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Timeprobe_T.cpp:
          Print timeprobe results with higher precision (3 decimal
          digits), this is useful for extremely fine grained analysis
          where just microseconds won't cut it.

Sat Jul 31 12:07:48 1999  Douglas C. Schmidt  <schmidt@mambo.cs.wustl.edu>

        * ace: Updated comments in all the header files so that references
          to method names like ACE_Event_Handler::handle_input() were
          changed to <ACE_Event_Handler::handle_input>.  This change
          enables the class2man scripts to use the appropriate "code" font
          for these names in the auto-generated documentation.

        * ace/Asynch_IO_Impl: Moved the
          virtual destructors for all the ACE_Asynch_*_Impl classes into
          the *.cpp file, which is where they belong.

        * ace/Functor_T.h: Moved the destructor of ACE_Command_Callback
          out of the header file and into the *.cpp file.

        * ace/Sched_Params.h: Updated the documentation a bit to mention
          the ACE_SCHED_{FIFO,RR,OTHER} policies explicitly.  Thanks to
          Peter Mueller <pmueller@decrc.abb.de> for motivating this.

        * ace/Synch_T: Moved the implementations of ACE_Read_Guard and
          ACE_Write_Guard out of the class header and into the *.i file,
          which is where they belong.

        * ace/Based_Pointer_T.i (operator *): In order to distinquish a
          "NULL" pointer we keep a value of -1 in target.

        * ace/Based_Pointer_T.i: I was forgetting to check if
          rhs == 0 for the ACE_Based_Pointer<> class.  This leads to weird
          behavior when assigning a "NULL" pointer.

        * examples/Reactor/Misc/notification.cpp: Cleaned up the program so
          that it looks better and doesn't crash and burn when signals occur.

        * ace/Pipe.cpp (open): We now set the default size of the
          ACE_Pipes that are implemented as Internet or UNIX-domain
          sockets to ACE_DEFAULT_MAX_SOCKET_BUFSIZ.  This will speed up
          the Reactor's notify() method and prevent it from deadlocking as
          quickly.  Thanks to Detlef Becker <Detlef.Becker@med.siemens.de>
          for testing this out.

        * ace/OS.h: Added a new macro called ACE_IPPROTO_TCP that factors
          out the differences between PHARLAPs and "normal" systems.

        * ace/Strategies_T.{i,cpp}: Added some additional ACE_ERROR printouts
          if open() methods fail in constructors.

        * ace/Strategies_T: The logic for creating a new Singleton wasn't
          dynamic enough.  It's now intelligent enough to create a new
          SVC_HANDLER if it's not given one.  Thanks to Hao Ruan
          <hruan@lucent.com> for reporting this.

Sat Jul 31 15:57:16 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ACE version 5.0 released.  Party on Wayne.

Sat Jul 31 12:20:59 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tests/version_tests/version_tests.dsw:
        * tests/version_tests/Hash_Map_Bucket_Iterator_Test.dsp:
        * tests/version_tests/Cached_Conn_Test.dsp:
        * tests/version_tests/Cached_Accept_Conn_Test.dsp: Added three
          missing version_tests project files.

Sat Jul 31 00:22:46 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tests/Basic_Types_Test.dsp:
        * tests/Collection_Test.dsp:
        * tests/Dynamic_Priority_Test.dsp:
        * tests/New_Fail_Test.dsp:
        * tests/Reverse_Lock_Test.dsp:
        * tests/SOCK_Connector_Test.dsp:
        * tests/SOCK_Send_Recv_Test.dsp:
        * tests/Thread_Mutex_Test.dsp:
        * tests/Timeprobe_Test.dsp:
        * tests/Upgradable_RW_Test.dsp: Rebuilt.  ACE_Init_Test.dsp is
          still broken.

Fri Jul 30 10:27:31 1999  Steve Huston  <shuston@riverace.com>

        * ace/config-hpux-10.x.h: Allow building w/o threads - set _REENTRANT
          if not set, to pick up _r functions; move
          ACE_HAS_NONCONST_SELECT_ TIMEVAL out of the threads-only
          section.

Fri Jul 30 08:36:43 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/OS.i: Commented out the ACE_TRACE calls in ACE_OS::mutex_lock()
          and ACE_OS::thread_mutex_lock() to avoid infinite recursion.  Thanks
          to Ulf Jaehrig <jaehrig@desys.com> for reporting this.

Fri Jul 30 03:33:14 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * bin/auto_compile:
        * bin/auto_compile_wrapper:
        * bin/run_all_list.pm:
          Added options to run only the tests that do not require threads
          (-single_threaded) and that do not require the full corba
          profile (-minimum_corba).  Also added options to disable the cvs
          update, to execute realclean before compiling and to print some
          debugging info.

Thu Jul 29 20:44:56 1999  Ossama Othman  <othman@cs.wustl.edu>

        * include/makeinclude/wrapper_macros.GNU:

          Override minimum_corba variable if it isn't set to 1 (i.e. if
          minimum_corba is not enabled).  This change was needed to make
          it easier to disable some TAO ORB services, examples and tests
          that rely on CORBA features that aren't supported in the minimum
          CORBA specification.

Thu Jul 29 19:04:12 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/Atomic_Op.i:
        * ace/Filecache.cpp:

          Replaced raw ACE_*_Guards with their corresponding
          ACE_GUARD_RETURN macros.  This corrects "unused variable"
          warnings when building ACE without thread support.  See David's
          ChangeLog entry from Fri May 14 16:10:29 1999 for a better
          description of why this was necessary.

Thu Jul 29 18:29:46 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * bin/run_all_list.pm: Moved the RUN_LIST definition from
          auto_compile to this file to reduce the work to maintain the
          list and allow auto_compile and run_all_win32.pl to synchronize
          the tests being run.

        * bin/auto_compile:
        * bin/run_all_win32.pl: Removed definition of RUN_LIST and use the
          run_all_list module.

Thu Jul 29 17:30:14 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Makefile[.am] (pkginclude_HEADERS): Removed Future_Node.*
          Thanks to John Tucker <jtucker@infoglide.com> and Michael Garvin
          <mgarvin@nortelnetworks.com> for reporting this.

Thu Jul 29 14:47:10 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/Select_Reactor_T.cpp (dispatch_notification_handlers):

          This code is used for picking up updates from non-owner threads.
          However, it is also useful for picking up notifications from the
          notify pipe (even though the notify is part of the I/O handle
          set in the Select_Reactor).  Therefore, we have enabled this
          code for the single-threaded case also.  Thanks to Irfan for
          this fix.

Thu Jul 29 14:32:28 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/ACE.cpp:
          Linux without returns a different errno (EOPNOTSUPP) if the
          connector or acceptor runs out of file descriptors.

        * ace/OS.i:
          The Errno_Guard constructor was not using an argument in
          platforms without exceptions.

Thu Jul 29 13:59:15 1999  Douglas C. Schmidt  <schmidt@cs.wustl.edu>

        * ACE version 4.6.47 released.

Thu Jul 29 12:32:01 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/WFMO_Reactor.cpp (ACE_WFMO_Reactor):
        * ace/Select_Reactor_T.cpp (ACE_Select_Reactor_T): I forgot to
          initialize <deactivated_> flag in one of the two ctors.  Thanks
          to Ruediger Franke <Ruediger.Franke@decrc.abb.de> for catching
          this one.

Thu Jul 29 01:04:03 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * bin/auto_compile:
        * bin/auto_compile_wrapper:
          Updated to include the latest round of changes, new tests and
          several improvements to send email and stuff.

Wed Jul 28 18:29:46 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * ace/config-win32.h:
          Removed ACE_HAS_STD_TEMPLATE_SPECIALIZATION
          definition. See below.

        * ace/config-win32-common.h:
          Added ACE_HAS_STD_TEMPLATE_SPECIALIZATION
          definition, since there is a place for MSVC 6.0 stuff like this.
          Also added ACE_HAS_BROKEN_IMPLICIT_CONST_CAST
          definition for a generated code bug fix that just didn't have one version
          that would satisfy both SunCC and MSVC.

Wed Jul 28 18:26:53 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/CDR_Stream.cpp:
        * ace/Message_Block.h:
        * ace/Message_Block.cpp:
        * ace/Message_Block_T.h:
        * ace/Message_Block_T.cpp:
          Re-implemented the clone() method without data copies in a
          backwards compatible way, a new clone_nocopy() method was added
          so classes that inherit from Data_Block and only override
          clone() will work correctly.
          Also fixed the implementation of Locked_Data_Blocked because it
          is used in TAO and we need zero-copy clone() operations in that
          case.

Wed Jul 28 16:16:27 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/OS.cpp (set): Fixed a unsigned/signed conversion problem
          that caused negative usec value in ACE_Time_Value.  Thanks to
          Jerry D. De Master <jdemaste@ipdinc.com> for reporting the bug.
          (FILETIME): Removed some unused macros for dealing with older
          Borland C++ compilers.  Thanks to Jody and Gonzo for confirming
          this.

Wed Jul 28 13:44:15 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ACE-INSTALL.html: Remind users to pick the right configurations
          when building from MSVC project files.  Thanks to Jerry D. De
          Master <jdemaste@ipdinc.com> for suggesting this.

Wed Jul 28 13:26:36 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE-INSTALL.html: for VxWorks (thru Tornado 1.0.1),
          -fno-implicit-templates is broken for x86 targets,
          not all targets.

Wed Jul 28 13:09:26 1999  David L. Levine  <levine@cs.wustl.edu>

        * docs/ACE-subsets.html: updated libACE size breakdown.

Wed Jul 28 12:08:56 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/CDR_Stream.cpp (reset_contents):

          Modified call to clone() so that it uses the newly added
          zero-copy semantics.  A data copy was already being made in
          ACE_InputCDR::steal_from(), which also calls
          ACE_InputCDR::reset_contents().  Two data copies were being
          performed.  This change reduces the number of data copies to
          one.  Thanks to Carlos for this change.

Wed Jul 28 11:23:36 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/Message_Block.h:
        * ace/Message_Block.cpp (clone):

          Added argument that allows the characteristics of an
          ACE_Data_Block to be copied without copying the data that the
          ACE_Data_Block holds.  This modification is part of a zero-copy
          optimization for TAO.  Thanks to Carlos for implementing this
          change.

Wed Jul 28 09:48:37 1999  David L. Levine  <levine@cs.wustl.edu>

        * docs/ACE-guidelines.html: added guideline about testing
          for definition of a macro before using it.  Thanks to
          Susan Liebeskind <susan.liebeskind@gtri.gatech.edu> for
          providing this guideline.

Wed Jul 28 00:06:32 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace: Added a new Makefile.bor file for BCB4.  Thanks to Christopher
          Kohlhoff <chris@kohlhoff.com> for contributing this.

Tue Jul 27 23:25:18 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * netsvcs/lib/Server_Logging_Handler_T.cpp (open): Updated a
          comment to point out that we use a thread-per-connection
          concurrency model.  Thanks to Raghu Nambiath
          <raghun@wipinfo.soft.net> for reporting this.

Tue Jul 27 21:05:23 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_tru64_cxx.GNU (ACE_DU_SUBVERSION):
          fixed typo:  -v instead of v-.  Thanks to
          Doug Anderson <dla@home.com> for reporting this.

Tue Jul 27 16:58:54 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * ace/ACE.cpp (out_of_handles): Added bug-fixes for RedHat5.2 and
          FreeBSD. Thanks to James Megquier <jmegq@bbn.com> for discovering
          and testing out the bug-fix on RedHat5.2 and Russell.L.Carter
          <rcarter@pinyon.org> for sending in a patch for FreeBSD. These
          bug fixes are for: $ACE_ROOT/tests/
          Cached_Conn_Test  and  Cached_Accept_Conn_Test.

Tue Jul 27 16:55:44 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * include/makeinclude/platform_sunos5_kcc.GNU (MATHLIB): KCC needs
          to have this defined.

Tue Jul 27 16:18:21 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE-INSTALL.html: updated note about shared libraries
          on VxWorks.  In particular, they don't provide copies
          of global (static) variables in the library.  So, "programs"
          that share a library will also share the static variables in
          the library. [Bug 86]

Tue Jul 27 14:26:37 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/SOCK_Dgram: Removed the QoS_Params from open() and
          ACE_SOCK_Dgram since they don't appear to be useful.  Thanks to
          Vidya Narayanan <CVN065@lmpsil02.comm.mot.com> for suggesting
          this.

Tue Jul 27 14:41:26 1999  Steve Huston  <shuston@riverace.com>

        * ace/Codeset_IBM1047.cpp: Added a static variable only for HP aC++
          to make it stop warning of an empty translation unit.

Tue Jul 27 14:16:55 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/Thread_Manager.cpp (cancel_thr): This method should return
          the result of thread cancel operation if async_cancel is used.
          Thanks to Peter Mueller <pmueller@decrc.abb.de> for suggesting
          the fix.

Mon Jul 26 20:50:37 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/OS: Addded a new pair of priority() fields as place
          holders for the forthcoming DiffServ QoS features.  Thanks to
          Vidya Narayanan <CVN065@lmpsil02.comm.mot.com> for suggesting
          this.

Tue Jul 27 13:28:48 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.i (getuid): removed extra ACE_TRACE with
          ACE_WIN32 or CHORUS.  Thanks to Jerry D. De Master
          <jdemaste@ipdinc.com> for reporting this.

Tue Jul 27 11:10:39 1999  David L. Levine  <levine@cs.wustl.edu>

        * examples/System_V_IPC/Makefile: on VxWorks only, fixed
          so that make all, etc., work properly (by just printing
          the message that these examples aren't used on VxWorks).

Tue Jul 27 10:25:41 1999  Steve Huston  <shuston@riverace.com>

        * ACE-INSTALL.html: Added a note about required HP-UX 10.20
          patch. Updated aC++ versions.

        * ace/Process.{h cpp} (ACE_Process_Options::command_line): Added
          'const' to make the entire array and contents const. Restores
          ability for users of pre-5.0 to still pass char **. Thanks to
          Bill Tovrea <gwtovrea@west.raytheon.com> for reporting this.

        * examples/Connection/non_blocking/Makefile: Re-added LIBS += $(ACELIB)
          (see ChangeLog, 23-Jul-1999) but did it in the section for AIX
          C Set++ and IBM C/C++ only (ifdef TEMPINCDIR). This is needed to
          generate the shared library (libConn) using those compilers.

Mon Jul 26 20:50:37 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Future.h: Moved the static methods until the bottom
          of the ACE_Future_Rep class (again) to workaround a bug with
          Borland's C++ Builder.  Thanks to Christopher Kohlhoff
          <chris@kohlhoff.com> for reporting this (again).

Mon Jul 26 20:59:23 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * websvcs/README:
          Added a brief description of the directory and its current
          contents.  Thanks to Will Skunk <willskunk@homemail.com>
          for motivating this.

Mon Jul 26 20:50:37 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Log_Msg.cpp: Added support for the 'W' (UNICODE) option for
          Win32.  Thanks to Valery Arkhangorodsky
          <valerya@servicesoft.com> for contributing this.

Mon Jul 26 20:58:35 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * ace/POSIX_Asynch_IO.cpp:
        * ace/WIN32_Asynch_IO.cpp: Fixed the double deletion problem of
          the result classes. Thanks to David Digby
          <DWD15274@glaxowellcome.co.uk> and Timothy Schimke
          <Schimke.Timothy@LittonDSD.com> for reporting this.

Mon Jul 26 18:09:09 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tests/run_tests.sh (Cached_Conn_Test and
          Cached_Accept_Conn_Test): These two tests are known to leak
          memory when compiled with old gcc (g++).  Therefore, we skip
          these tests when using purify and old gcc (g++).  A -p option
          was added to the script to indicate that we want to run with
          purify.

Mon Jul 26 17:09:09 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Object_Manager.{h,cpp},Makefile: don't create the
          ACE_TOKEN_MANAGER_CREATION_LOCK and
          ACE_TOKEN_INVARIANTS_CREATION_LOCK preallocated objects
          if the Token component isn't build.  This gets rid of
          unresolved references to the ACE_Token_Proxy compoents
          on VxWorks/g++ when Token isn't built.  Thanks to
          Stephane Chatre <schatre@oresis.com> for reporting this.

Mon Jul 26 17:02:08 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/wrapper_macros.GNU: don't override
          OBJDIRS on VxWorks with shared libs.  This allows
          make realclean to work properly on VxWorks, when shared
          lib builds are enabled.

Mon Jul 26 15:06:23 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * ace/CDR_Stream.i:
        * ace/Map_Manager.i:
          Had to cast some return values to avoid MSVC signed/unsigned
          mismatch type warnings (level 4).

        * ace/config-win32.h:
          Added ACE_HAS_STD_TEMPLATE_SPECIALIZATION define, so that
          ACE_TEMPLATE_SPECIALIZATION macro adds the necessart
          'template <>' for MSVC, and so averts many many level 4
          warnings.

Mon Jul 26 14:10:56 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * ace/DLL.cpp (get_handle): Changed the check of <become_owner>
          flag to now reset <close_on_destruction> only if the
          <become_owner> is set. Thanks to Bob McWhirter <bob@werken.com>
          for pointing this out.

Mon Jul 26 12:32:41 1999  Douglas C. Schmidt  <schmidt@cs.wustl.edu>

        * ACE version 4.6.46 released.

Fri Jul 23 18:20:11 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/config-irix6.x-sgic++-nothreads.h:
          Enabled namespaces with MIPSPro 7.2 or higher.

Fri Jul 23 16:40:15 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/ACE.cpp:
          Fixed typos in error return values for ACE::execname()

Fri Jul 23 14:51:48 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * examples/Service_Configurator/IPC-tests/Handle_L_CODgram,
          examples/Service_Configurator/IPC-tests/Handle_L_Dgram,
          examples/Service_Configurator/IPC-tests/Handle_L_Pipe:
          Cleaned this stuff up so that it builds correctly when
          ACE_LACKS_UNIX_DOMAIN_SOCKETS is enabled.  Thanks to
          David for reporting this.

        * examples/Service_Configurator/IPC-tests/server/Handle_L_Pipe:
          Made upper_case() a method in the Handle_L_Pipe class.

        * examples/Service_Configurator/IPC-tests/server/Handle_L_Pipe.cpp,
          examples/Service_Configurator/IPC-tests/server/Handle_L_CODgram.cpp:
          Removed the bizarre hacks for SunOS4.  This stuff probably
          hasn't been tested since 1992!

Fri Jul 23 14:16:22 1999  Steve Huston  <shuston@riverace.com>

        * ace/OS.i (ACE_OS::read): (only non-Win32), if call fails and
          errno is EAGAIN, change it to EWOULDBLOCK. Improve portability for
          platforms where EAGAIN and EWOULDBLOCK are different values and
          both used, like HP-UX.

        * ace/Malloc_T.cpp (ACE_Malloc<> ctor): Added missing newline in error
          message.

Fri Jul 23 12:09:18 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/OS.i: Fixed some mismatched ifdef/endif comments.

        * ace/ACE.cpp (execname): Fixed some misuses of ACE_HAS_WIN32
          macros where they should have been ACE_WIN32.  Thanks to Andy
          for noticing this.

Fri Jul 23 11:28:17 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Memory_Pool.cpp (init_acquire): shmat() returns -1 on
          failure, not 0.  Thanks to Kevin Liu
          <kliu@fitch.math.uwaterloo.ca> for reporting this.

Fri Jul 23 11:35:31 1999  David L. Levine  <levine@cs.wustl.edu>

        * examples/Connection/non_blocking/tests_lsock_{acceptor,
          connector.cpp}: disabled if ACE_LACKS_UNIX_DOMAIN_SOCKETS.
          Thanks to Alain Magloire <alain@qnx.com> for reporting this.

        * examples/Connection/non_blocking/Makefile: removed unneeded
          LIBS (=$(ACELIB)) and BUILD macro definitions.

Fri Jul 23 10:07:05 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_qnx_neutrino.GNU: added
          CROSS-COMPILE macro definition.  Thanks to
          Alain Magloire <alain@qnx.com> for reporting this.

Fri Jul 23 08:58:56 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Service_Config.h: Clarified the fact that the
          ACE_Service_Config uses the Monostate pattern, so there can only
          be one of them per-process.  Thanks to Ralf Kluthe
          <kluthe@iti.mu-luebeck.de> for reporting this.

Fri Jul 23 07:49:31 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_sunos5_sunc++.GNU: added
          comment about options for producing 64-bit binaries.
          Thanks to Jeff Franks <Jeffrey_Franks@i-o.com> for
          raising this issue.

Fri Jul 23 03:10:31 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Strategies_T.cpp (find_or_create_svc_handler_i):
        * ace/Cached_Connect_Strategy_T.cpp (cached_connect):

          I had added the new_connection() method that lets go of the lock
          for the duration of the connect(), but forgot to use it in the
          above functions ;)  It should be fine now.

        * tests/Cached_Conn_Test.cpp (cached_connect):
        * tests/Cached_Accept_Conn_Test.cpp (cached_connect):

          Host of the remote address should be ACE_LOCALHOST instead of
          ACE_DEFAULT_SERVER_HOST.

Thu Jul 22 23:23:26 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Handle_Gobbler.h (class ACE_Handle_Gobbler): Inlined
          declaration of the functions.

Thu Jul 22 20:03:54 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Acceptor.cpp: For sanity's sake, initialize all the data
          members to 0 in the ACE_Strategy_Acceptor constructor.  Thanks
          to Jody Hagins <jody@atdesk.com> for reporting this.

        * ace/Acceptor.cpp: The service_port_ data member in the
          ACE_Strategy_Acceptor wasn't being initialized to 0.  Thanks to
          Jody Hagins <jody@atdesk.com> for reporting this.

        * ace/Acceptor.cpp: Modified the dump() and info() methods so that
          don't do bad things if service_name_ and service_description_
          are NULL.  Thanks to Jody Hagins <jody@atdesk.com> for this
          suggestion.

        * ace/Message_Queue_T.h: Clarified what the errnos get set to when
          timeouts occur or queues are deactivated.  Thanks to
          John Forest <forestj@res.raytheon.com> for suggesting this.

Thu Jul 22 16:55:14 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Stats.cpp:
          Fixed message that had a %s but no argument!

Thu Jul 22 15:12:18 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Codeset_IBM1047.{h,cpp}: wrapped with #ifdef ACE_MVS
          so that the code doesn't occupy any space on platforms
          other than MVS.

Thu Jul 22 14:22:41 1999  David L. Levine  <levine@cs.wustl.edu>

        * examples/Shared_Malloc/Malloc.cpp: fixed explicit
          template instantiations so that there are no duplications
          with ACE_LACKS_SBRK and ACE_LACKS_SYSV_SHMEM.

Thu Jul 22 12:17:26 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-lynxos.h: removed ACE_LACKS_FORK on PowerPC.
          All of the ACE tests that fork now succeed.

Thu Jul 22 11:54:58 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/SV_Shared_Memory_Test.cpp (child): added a one
          second sleep to give the parent a chance to create the
          semaphore.  This allows the test to succeed on LynxOS/PPC
          (with fork ()).

        * tests/Process_Mutex_Test.cpp,Process_Strategy_Test.cpp (main):
          added a one second sleep after spawning each server, to give it
          a chance to start.  Also, wrapped some string literals with
          ASYS_TEXT.  Again, success on LynxOS/PPC with fork ().

Thu Jul 22 10:42:06 1999  Clarence M. Weaver  <clarence_m_weaver@md.northgrum.com>

        * ACE-INSTALL.html: added steps for running the ACE tests
          on VxWorks platforms that lack NFS.

Thu Jul 22 10:25:31 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Log_Record.cpp,SString.cpp: wrapped #include of
          ace/streams.h with #ifndef ACE_LACKS_IOSTREAMS_TOTALLY.
          [Bug 84]

Thu Jul 22 09:55:10 1999  David L. Levine  <levine@cs.wustl.edu>

        * docs/ACE-guidelines.html: updated commit message guideline
          to show ChangeLogTag example.

Thu Jul 22 02:15:46 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Handle_Gobbler (class ACE_Handle_Gobbler): New class that
          gobbles up handles :) This class is useful when we need to
          control the number of handles available for a process.  Mostly
          used for testing purposes.

          Note that even though the new files are in the ace directory,
          they are not part of the ace library.  The files only contain
          inline functions and Handle_Gobbler.h is only included where
          needed.

        * tests/Cached_Conn_Test.cpp:
        * tests/Cached_Accept_Conn_Test.cpp:

          Added Handle_Gobbler to the test to reduce the iterations
          required before handles run out and purging starts.

Wed Jul 21 21:45:22 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/Reactor.cpp: Applied ACE_NOTREACHED to several
          run_*_event_loop methods.

        * docs/ACE-guidelines.html: Updated ASYS_TEXT usage.

        * ace/RB_Tree.cpp:
        * tests/Cache_Map_Manager_Test.cpp: Applied ASYS_TEXT liberally.

Wed Jul 21 21:19:36 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE-INSTALL.html: added note about ACE support for
          shared libraries on VxWorks.  It's still under
          development.

Wed Jul 21 18:38:00 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Strategies_T.h (ACE_Cached_Connect_Strategy): Renamed
          <connection_cache_> to <connection_map_>.

        * ace/Hash_Cache_Map_Manager_T.cpp (find): Finding and updating
          the attributes is faster through the find() that uses an entry.
          Therefore, for find (key, value) and find (key) we go to
          find (key, entry) instead of going to the base class.

        * ace/Cached_Connect_Strategy_T.cpp:

          - ACE_Cached_Connect_Strategy_Ex::check_hint_i
          - ACE_Cached_Connect_Strategy_Ex::find

          Update the caching attributes directly since we don't do a
          find() on the cache map.

Wed Jul 21 15:54:25 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/DLL.cpp: ACE_HAS_MOSTLY_UNICODE_APIS fixes.

        * ace/OS.i (ctime):
        * ace/OS.cpp (ctime): One copy should only be available when
          ACE_HAS_MOSTLY_UNICODE_APIS is defined.  Thanks to Steve for
          reporting this.

Wed Jul 21 15:21:32 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Env_Value_Test.cpp (main): use the single-process
          version if ACE_LACKS_FORK, in addition to if
          ACE_HAS_NONSTATIC_OBJECT_MANAGER.

        * tests/Time_Service_Test.cpp (main): neuter if ACE_LACKS_FORK,
          because the test uses ACE_Process::spawn ().

          Thanks to Riaz Syed <syed@Lynx.COM> for reporting these.

Wed Jul 21 11:48:53 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_vxworks5.x_g++.GNU:
          use full path to $(CC) in egcs version check, to avoid
          warning if it is not on the user's PATH.

Wed Jul 21 11:44:19 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/OS.h:
          Simplified the definition of the ACE_THR_PRI_*_DEF macros from
          (MIN+(MAX-MIN)/2) to ((MIN+MAX)/2), the new definition is not
          only easier to read, makes less operations (and function calls)
          but it is also safer when the the priorities are "backwards" and
          PRI_MAX < PRI_MIN

Wed Jul 21 11:40:31 1999  Steve Huston  <shuston@riverace.com>

        * include/makeinclude/platform_aix4_cset++.GNU:
        * include/makeinclude/platform_hpux_aCC.GNU: Replaced lines like
          "debug=1" with ifeq (,$(debug)) debug=1 endif.

        * include/makeinclude/platform_aix4_g++.GNU:
          Above change for variables, also added -Wl,-bbigtoc when linking
          TAO_IDL, else it runs out of toc space. Don't do it for all links
          because bigtoc introduces a run-time performance penalty.

Wed Jul 21 10:25:07 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.{h,cpp} (tss_base,tss_open): with TSS emulation,
          no longer return indication of whether tss_base allocated
          the ts_storage array.  Instead, added an (optional)
          argument that tss_open can use for that purpose.  This
          allows threads that haven't been spawned by ACE to use
          ACE's TSS emulation.  Thanks to David Hauck
          <davidh@realtimeint.com> for reporting this and testing
          the fix on NT.  And, thanks to Terry Rosenbaum
          <Terry.Rosenbaum@Radiology.MSU.edu> for originally reporting it.

Wed Jul 21 09:34:09 1999  David L. Levine  <levine@cs.wustl.edu>

        * examples/Shared_Malloc/test_position_independent_malloc.cpp (main):
          removed declarations of unused argc and argv.

Wed Jul 21 04:32:20 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/Reactor.cpp:
        * ace/Reactor.h:
        * ace/Reactor.i:
        * ace/Reactor_Impl.h:
        * ace/Select_Reactor_T.cpp:
        * ace/Select_Reactor_T.h:
        * ace/Select_Reactor_T.i:
        * ace/TP_Reactor.cpp:
        * ace/WFMO_Reactor.cpp:
        * ace/WFMO_Reactor.h:
        * ace/WFMO_Reactor.i: The change was motivated by removing a race
          condition in TP_Reactor during shutdown.  There was a small time
          gap between a thread running TP_Reactor event loop checking its
          end_event_loop flag to the thread actually grabing the token in
          TP_Reactor.  Since the token return to its "normal" state after
          broadcasting, this thread has no chance to notice that the
          reactor has already been shutdowned and thus a deadlock occured.
          In order to fix the problem, we must keep a state indicating
          whether the reactor has been shutdowned or not in the reactor.

          An added benefit of adding this state is that every reactor now
          has its own run_reactor_event_loop which mimic the behavior of
          the static ACE_Reactor::run_event_loop but instead of working on
          the singleton reactor, the added function work on an instance of
          reactor object.  In fact, all event_loop control functions have
          been added.  They are named *_reactor_event_loop to
          differentiate their behavior.   These newly added function use
          the added state in the reactor to control the looping of event
          handling.  All run_reactor_event_loop methods take an extra
          argument of a function pointer.  The function will be called in
          every iteration if it is set.

          Notice that the singleton event loop control functions are still
          available.  Although these function merely forward the call to
          the singleton reactor's *_reactor_event_loop functions, you can
          still use them to control the "main" event loop.  In fact, it is
          required that you use these functions to run the main event loop
          because it facilitates Service_Configurator's "reconfigure"
          feature.

          All reactors now also have two extra functions namely
          "deactivated" which is used to query whether the reactor will
          handle more incoming event or not, and "deactivate" which is
          used to control this new feature.

          An side effect of the change is that, once a reactor get
          deactivated, calls to handle_events will return -1 immediately.
          You can use the "deactivated" method to check if there's
          actually an error in the handle_events method or it simply
          returned because the reactor has been deactivated.  This is also
          how the various "run_reactor_event_loop" handle the situation.
          Notice that this should not cause any backward compatibility
          problem becuase if a user is using his own end_event_loop flag,
          he will not (and should not) invoke any more handle_events after
          the flag has been set.  Also, if he is using the global
          run_event_loop methods (for controling singleton reactor,) they
          should still behave the same.

          To summarize the change:

          1. The run_event_loop control logic has been "pushed" down into
          each individual reactor.  The methods supporting the logic are
          defined in ACE_Reactor and are:

             run_reactor_event_loop ()
             run_alertable_reactor_event_loop ()
             end_reactor_event_loop ()
             reactor_event_loop_done ()
             reset_reactor_event_loop ()

          2. The origianl run_event_loop methods in ACE_Reactor are still
          working but they now use the run_reactor_event_loop methods in
          the implementation of the reactor.

          3. Reactors now keep a state to indicate handle_events should be
          called or not.  They can be controlled thru:

             deactivated ()
             deactivate ()

          methods.

Tue Jul 20 21:31:50 1999  Jim Rogers  jrogers@viasoft.com

        * ace/config-mvs.h: added ACE_HAS_EXCEPTIONS.

Tue Jul 20 21:23:19 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.* (next_key,total_keys):  with TSS_EMULATION,
          added guard (using preallocated ACE_TSS_KEY_LOCK)
          to access of next_key_.  Uninlined both of these
          functions because they now have the guards.  Thanks
          to Jake Hamby <jehamby@anobject.com> for reporting this.

Tue Jul 20 21:11:02 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_vxworks5.x_g++.GNU:
          fixed test of g++ for whether it's egcs.  Thanks to
          Erik Johannes <ejohannes@oresis.com> for reporting this.
          (The symptom was that TAO's IORManipulation.cpp wouldn't
          compile due to an internal compiler error.  Adding
          -fno-exceptions works around that.)

Tue Jul 20 18:30:22 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Cached_Connect_Strategy_T.h:  All functions in
          ACE_Cached_Connect_Strategy_Ex and ACE_Cached_Connect_Strategy
          that contain specific information about the map used by the
          class should not be virtual.

        * ace/Future_Set.cpp (next_readable): Removed extra code that was
          left behind from a debugging stage.  Thanks to author John
          Tucker <jtucker@infoglide.com> for helping with this.

Tue Jul 20 12:02:47 1999  David L. Levine  <levine@cs.wustl.edu>

        * examples/Threads/task_five.cpp (main): removed
          ACE_NOTREACHED wrapper around the final return statement.
          It's reachable now.

Tue Jul 20 11:46:09 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * examples/Shared_Malloc/test_position_independent_malloc.cpp:
          Completely #ifdef'd this example out until we get it working.
          Thanks to David Levine for reporting this.

Tue Jul 20 11:15:23 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE-INSTALL.html: updated memory requirements discussions.

Tue Jul 20 09:43:36 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/Future_Set.cpp (next_readable):

          Fixed unused variable warnings.

Tue Jul 20 09:33:02 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.{h,i} (sigwait): only use the DIGITAL_UNIX sigwait
          massaging with cxx, not with any other compiler.  Thanks to
          Doug Anderson <dla@home.com> for suggesting this, because
          egcs issued warnings with it.

Tue Jul 20 07:06:28 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_osf1_4.0.GNU:
          removed -ptr ptrepository.  Let the compiler use its
          default template repository.

        * include/makeinclude/rules.local.GNU (realclean): added
          cxx_repository, for DU cxx.

Tue Jul 20 07:01:57 1999  Doug Anderson  <doug@clark.net>

        * ace/OS.i (sigwait,thr_sigsetmask): added support for
          Cray UNICOS 9.

Mon Jul 19 22:46:54 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Strategies_T.cpp
          (ACE_Cached_Connect_Strategy::new_connection):: We use a reverse
          lock to let go of the lock for the duration of the actual
          connect.  This will allow other threads to hack on the
          connection cache while this thread creates the new connection.
          Thanks to James Whitledge <jwhitledge@spyglass.com> for
          suggesting this.

        * tests/Cached_Accept_Conn_Test.cpp
        * tests/Cached_Conn_Test.cpp
        * tests/Conn_Test.cpp

          Added reverse lock template instantiations.

        * ace/Synch_T: Since the reverse lock constructor that created the
          regular lock was removed, there was no need for the
          <delete_lock_> variable, and <lock_> could be changed into a
          reference (instead of pointer).

Mon Jul 19 23:04:15 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * netsvcs/lib/Logging_Strategy.cpp (init): The ACE_LOG_MSG->open()
          call at the end of the ACE_Logging_Strategy::init() method
          *must* specify the flags and logger key or an application will
          not connect to the client logger daemon automatically when the
          ACE_Log_Msg::LOGGER flag is set in a svc.conf file.  Thanks to
          Jerry De Master <jdemaste@ipdinc.com> for reporting this.

Mon Jul 19 22:11:13 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE-INSTALL.html: cleaned up instructions for building
          on NT for VxWorks target.  Thanks to Stephane Chatre
          <schatre@oresis.com> for reporting that the instructions
          were out of date.

Mon Jul 19 21:38:16 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tests/run_tests.vxworks:
          Re-enable the Cached_Conn_Test and Cached_Accept_Conn_Test, it
          works on Linux, NT, Solaris, IRIX and HP-UX so we should be
          pretty close. Thanks to Irfan for fixing the problems with this
          test.

Mon Jul 19 21:26:57 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.{h,i}: reverted sigwait () changes on Digital
          Unix.  They cause examples/Threads/process_manager.cpp
          to not compile on DU 5.0 with cxx 6.2-021.  See
          Mon Jul 19 21:13:16 1999  Doug Anderson  <doug@clark.net>.

Mon Jul 19 21:13:16 1999  Doug Anderson  <doug@clark.net>

        * ace/ACE.cpp,ace/Basic_Types.h,ace/CDR_Stream.{h,cpp},
          ace/SOCK_Dgram_Bcast.cpp,ace/config-cray.h,
          tests/Basic_Types_Test.cpp,tests/Handle_Set_Test.cpp,
          include/makeinclude/platform_cray.GNU

          I finally managed to get the latest and greatest to work on
          the Cray.  Still no CDR support, but that will be post 5.0.

        * ace/OS.{h,i}: added support for egcs on Digital Unix (4.0d & e).
          Fixe problem with legacy workarounds in OS.* for sigwait() and
          cxx/GNU that don't appear to be necessary on 4.0d/e/f with
          neither cxx nor GNU.

        * include/makeinclude/platform_tru64_g++.GNU: added.  Works
          with ace/config-tru64.h.

Mon Jul 19 19:46:50 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/OS.h: Added ACE_*_cast_*_ptr and ACE_*_cast_*_ref for const,
          static, and reinterpret casts.

        * ace/Strategies_T.cpp (find):
        * ace/Cached_Connect_Strategy_T.cpp (find):

          The comparison should be between ACE_PEER_CONNECTOR_ADDR and not
          REFCOUNTED_HASH_RECYCLABLE_ADDRESS.

        * ace/Svc_Handler: Changed <state> to <recycle_state>.  <state>
          was too generic and in some cases a <state> method was already
          present in classes deriving from Svc_Handler.

          Also, added a <recycle_state> accessor.

          The following files were effected:

          - ace/Cached_Connect_Strategy_T.cpp
          - ace/Cached_Connect_Strategy_T.h
          - ace/Caching_Utility_T.cpp
          - ace/Strategies.h
          - ace/Strategies.i
          - ace/Strategies_T.cpp
          - ace/Strategies_T.h
          - ace/Strategies_T.i
          - tests/Cached_Accept_Conn_Test.cpp
          - tests/Cached_Conn_Test.cpp

Mon Jul 19 20:08:15 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Strategies_T.cpp:
          Fixed lookup of connections in the Cached_Connect_Strategy,
          thanks to Irfan for providing this fix.

Mon Jul 19 12:26:20 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_vxworks5.x_g++.GNU,
          ace/config-g++-common.h:
          don't #define ACE_HAS_GNUG_PRE_2_8 with Tornado II's
          g++.  It's egcs, though it's version identifier says
          it's 2.7.  Thanks to Thomas Lockhart
          <Thomas.G.Lockhart@jpl.nasa.gov> for reporting this. [Bug 80]

Mon Jul 19 09:50:31 1999  Steve Huston  <shuston@riverace.com>

        * ace/Future.cpp: Added ACE_TYPENAME to template-qualified types.
        * ace/Future.cpp: Added #include "ace/Containers.h" to be sure the
          types necessary for this class is available at template link
          time.

        * apps/gperf/src/Options.h: If on PharLap ETS, clear out its definition
          of EOS to avoid compile errors. Thanks to David Hauck
          <davidh@realtimeint.com> for this fix.

Mon Jul 19 08:12:30 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_tru64_cxx.GNU: added support
          for DU 4.0E and D.

Mon Jul 19 08:08:25 1999  Steve Huston  <shuston@riverace.com>

        * ace/config-hpux-(10 11).x-hpc++.h: In the aC++ section, if __HP_aCC
          is not set, set it. Some parts of TAO rely on it, but it's not set
          until the most recent versions of the compiler. Thanks to Brian
          Wallis <Brian.Wallis@sr.com.au> for helping figure this out.

Mon Jul 19 07:53:59 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/SOCK_Dgram_Mcast.cpp (open): added unnecessary const_cast
          of mcast_addr to ACE_Addr &, so that Sun C++ 4.2 will compile
          without error.  Thanks to Andy for this fix.

Sun Jul 18 21:36:04 1999  David L. Levine  <levine@cs.wustl.edu>

        * OS.cpp (sched_params): wrapped DIGITAL_UNIX preprocessor
          symbol in parenthesis.

Sun Jul 18 14:30:54 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * tests/run_tests.sh: Reenabled the Future_Set_Test.  Hopefully,
          this will work on Solaris and the other platforms now!

        * ace/Future*: Added some fixes for Future_Set that should prevent
          it from hanging indefinitely on certain platforms.  Also,
          removed the Future_Node.h and Future_Node.cpp files since they
          are no longer used.  Thanks to John Tucker
          <jtucker@infoglide.com> for contributing these fixes.

        * ace/SOCK_Dgram_Mcast: Finished implementing the QoS-enabled APIs for
          socket datagram multicast.  This required refactoring quite a
          bit of code and adding some new methods that take the
          ACE_QoS_Params.

        * ace/SOCK_Dgram.cpp: Finished integrating the QoS support
          for SOCK dgrams.

        * ace/SOCK_Dgram.cpp: Factored out common code in the
          ACE_SOCK_Dgram constructors.

        * ace/SOCK_Connector: Finished implementing the QoS-enabled
          connect() methods.  To make this cleaner, I've created a new
          "shared_open()" method that factors out the common code.

        * ace/SOCK_Acceptor: Finished implementing the QoS-enabled open()
          method.  To make this cleaner, I've created a new
          "shared_open()" method that factors out the common code.

Sat Jul 17 13:36:03 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/High_Res_Timer.cpp (get_cpuinfo):

          Removed extra `FILE *cpuinfo' declaration.

Sat Jul 17 12:20:25 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/High_Res_Timer: Added integrated support for Alpha and
          Pentium that will eliminate the 5sec startup delay for Linux/PII
          clients using the ACE high resolution timer.  Thanks to Thomas
          Lockhart <Thomas.G.Lockhart@jpl.nasa.gov> for these fixes.

        * netsvcs/servers/main.cpp (main): Fixed a typo caused by recent
          integration of Jerry De Master's fixes.

Fri Jul 16 19:41:05 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/ACE.cpp (out_of_handles): Added a function to check if a
          process is out of handles (file descriptors).  This is required
          to avoid repeating this code in many places.  Also, note that
          all platform specific quirks can be captured in this function.

        * ace/Cached_Connect_Strategy_T.cpp (cached_connect):
        * tests/Cached_Conn_Test.cpp (out_of_sockets_handler):
        * tests/Cached_Accept_Conn_Test.cpp (out_of_sockets_handler):

          Changed the above to use the new ACE::out_of_handles() function.

        * ace/OS.h (ENFILE): Added ENFILE if missing on platform.  In that
          case, ENFILE will equal to EMFILE.

Fri Jul 16 13:55:34 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * include/makeinclude/{build_dll.bor,build_exe.bor,compiler.bor},
          ace/{Makefile.bor,ace.rc}:
          Updated these files to add version information to the DLLs so
          when you right click them in windows explorer you can see what
          version the file is (e.g., "4.6.45").  Thanks to Christopher
          Kohlhoff <chris@kohlhoff.com> for contributing this.

        * netsvcs/servers/main.cpp (main): Disable debugging messages
          if the -d option isn't given to ACE_Service_Config.  Thanks to
          Jerry De Master <jdemaste@ipdinc.com> for reporting this.

        * ace/config-win32-borland.h: Updated this file to enable some
          necessary macros.  Thanks to Christopher Kohlhoff
          <chris@kohlhoff.com> for reporting this.

        * tests/DLL_Test.cpp,
          tests/run_test.bat: Updated these to handle the appropriate
          directory where the Borland tests are built.  Thanks to
          Christopher Kohlhoff <chris@kohlhoff.com> for reporting this.

        * netsvcs/lib/Logging_Strategy.cpp (init): When the application
          program is started, none of the log output is sent to the
          Client_Logging_Service.  Further investigation shows that the
          ACE_Log_Msg::open() method is responsible for connecting to the
          client logger if the ACE_Log_Msg::LOGGER flag is set.  However,
          the connections never attempted because the ACE_Log_Msg::open()
          method is called before the Logging_Strategy flags have been
          parsed.  This problem was fixed by rearranging the point at
          which the ACE_LOG_MSG->open() method was called.  Thanks to
          Jerry De Master <jdemaste@ipdinc.com> for contributing this.

        * netsvcs/lib/Client_Logging_Handler.cpp (send),
          netsvcs/lib/Log_Message_Receiver.cpp (log_output):
          All log message output in ACE is done through one of the
          ACE_Log_Record::print() methods.  Each of the overloaded methods
          has a <flags> argument as the second argument.  However, all
          uses of the ACE_Log_Record::print() method in
          Log_Message_Receiver.cpp and Client_Logging_Handler.cpp pass
          zero for the flags argument.  To fix this, simply pass
          ACE_Log_Msg::instance()->flags() instead of 0.  Thanks to Jerry
          De Master <jdemaste@ipdinc.com> for contributing this.

        * ace/Log_Record.cpp (format_msg): Added code for the new
          ACE_Log_Record::format_msg() method that adds the date/time
          stamp to the ACE_Log_Msg::VERBOSE_LITE output.  Thanks to Jerry
          De Master <jdemaste@ipdinc.com> for contributing this.

        * netsvcs/lib/Logging_Strategy.cpp (init): Make sure the
          ACE_Log_Msg::VERBOSE_LITE flag is OR'd into the clr_flags()
          call.  Thanks to Jerry De Master <jdemaste@ipdinc.com> for
          reporting this.

        * netsvcs/lib/Logging_Strategy.cpp (tokenize): Make sure that
          the ACE_Log_Msg::VERBOSE_LITE flag is correctly parsed.  Thanks
          to Jerry De Master <jdemaste@ipdinc.com> for reporting this.

        * ace/Memory_Pool.h: Added a way to set the segment_size in
          ACE_Shared_Memory_Pool_Options and ACE_Shared_Memory_Pool.
          Thanks to Serge Kolgan <skolgan@cisco.com> for this fix.  [This
          feature was actually added a couple of beta releases ago, but
          somehow the ChangeLog entry got lost.]

Fri Jul 16 16:41:22 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/Stats.cpp (print_summary):

          Fixed format specifier that was expecting an integer argument.
          It needed an additional percent specifier.

Fri Jul 16 09:20:42 1999  Arturo Montes <mitosys@colomsat.net.co>

        * ace/OS.i: Patch the dl* family to keep ACE
          compatible in SCO OpenServer 5.0.0, 5.0.2, 5.0.4 with 5.0.5

        * ace/config-sco-5.0.0.h: Bring OpenServer up to date.

        * include/makeinclude/platform_sco5.0.0-fsu-pthread.GNU:
          Use gcc-2.95.

Fri Jul 16 11:50:24 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/Log_Msg.cpp (log):
        * tests/Basic_Types_Test.cpp (main): Reverted my previous
          change.  It was not a safe assumption.

Fri Jul 16 02:28:10 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/Log_Msg.cpp (log): Changed (*va_arg (argp,PTF))(), which
          extracts a function pointer from va_list and makes a call using
          the pointer pointer to ACE_reinterpret_cast (PTF, va_arg (argp,
          long))().  This assumes the sizeof (long) is exactly equal to
          the size of a function pointer.

        * tests/Basic_Types_Test.cpp (main): Narrow down the check to
          ensure sizeof(long) == sizeof (a function pointer) (which is
          true for all the platforms that ACE runs on.)

Fri Jul 16 00:07:23 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tests/Cached_Accept_Conn_Test.cpp (test_connection_management):
          Changed the test to allow for both one listen endpoint or
          multiple listen endpoints.

Thu Jul 15 22:42:36 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/Message_Queue.h: (ACE_MESSAGE_QUEUE_DEFAULT_TYPE):
        * ace/Future_Set.{h,cpp} (ACE_Future_Set): Typedef'ed the
          ACE_Message_Queue to ACE_MESSAGE_QUEUE_DEFAULT_TYPE and use the
          typedef'ed name in ACE_Future_Set's contstructor to get around a
          bug in vxworks' g++ compiler.

Thu Jul 15 22:14:18 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Cached_Connect_Strategy_T.cpp
        * ace/Cached_Connect_Strategy_T.h
        * ace/Strategies_T.cpp
        * ace/Strategies_T.h

          Changed find()'s signature to help g++.

        * tests/Cached_Accept_Conn_Test.cpp
        * tests/Conn_Test.cpp

          Added template instantiations.

Thu Jul 15 21:32:26 1999  David L. Levine  <levine@cs.wustl.edu>

        * bin/create_ace_build: removed # -*- perl -*- on first
          line so that t/csh users don't trip over it.  Thanks
          to Irfan for reporting this.

Thu Jul 15 20:23:39 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tests/Cached_Conn_Test.cpp (test_connection_management): Changed
          the test to allow for both one listen endpoint or multiple
          listen endpoints.

        * ace/Cached_Connect_Strategy_T.cpp:
        * ace/Strategies_T.cpp

          - find: Since the comparison of
            REFCOUNTED_HASH_RECYCLABLE_ADDRESS doesn't work very well when
            trying to find an idle connection (because there are many idle
            states), we now use the new backet iterator to find a idle
            connection.

          - check_hint_i: Explicitly checks for idleness; previously it
            was simple checking !closed.

        * ace/Strategies.h (ACE_Recyclable): Changed ACE_Recyclable::State
          to ACE_Recyclable_State.

        * ace/Strategies_T.h (ACE_Refcounted_Hash_Recyclable):

          - Added operator!=(ACE_Refcounted_Hash_Recyclable<T>)
          - Removed operator==(T)
          - Added T &subject()
          - Change operator==(ACE_Refcounted_Hash_Recyclable<T>) to check
            for equality in state and subject.

        * ace/Caching_Utility_T.cpp (minimum): Entries marked
          ACE_RECYCLABLE_PURGABLE_BUT_NOT_IDLE should also be considered
          for purging.

        * ace/Cleanup_Strategies_T.cpp (cleanup): The hash map of the
          connection cache may contain duplicates.  Therefore, we are not
          exactly sure which map entry will be removed when calling
          unbind().  Therefore, we use the other unbind() which gives us
          back the value of the entry that was removed.  This way will
          close the correct handler.

        * ace/Svc_Handler.cpp (state): Added a new method that allows the
          user to explcitly set the state of the Svc_Handler. If the
          Svc_Handler does not have a recycler, this method will have no
          effect.

Thu Jul 15 16:39:06 1999  Ossama Othman  <othman@cs.wustl.edu>

        * Makefile:
        * NEWS:

          The NEWS file is no longer a generated file so it was added to
          the list of controlled files.

Thu Jul 15 16:20:43 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/Service_Manager.cpp (init): Check to see the acceptor handle
          is ACE_INVALID_HANDLE before the actual initialization to
          prevent this service from being initialized twice.
          (fini): Must call remove_handler with
          ACE_Event_Handler::DONT_CALL since the service manager won't be
          around when the reactor is being destroyed.  Thanks to Gheorghe
          Aprotosoaie <gaprotosoaie@paragonms.com> for reporting this.

Thu Jul 15 16:26:28 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.cpp (spa): use ACE_NEEDS_HUGE_THREAD_STACKSIZE
          instead of hard-coded value.

        * ace/config-vxworks5.x.h: added default
          ACE_NEEDS_HUGE_THREAD_STACKSIZE of 64000.

Thu Jul 15 16:08:48 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/config-win32-common.h: Moved ACE_HAS_IP_MULTICAST down
          *after* ACE_HAS_WINSOCK2 is defined.  Thanks to Marina for
          reporting this.

Thu Jul 15 16:11:04 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Basic_Types.h (ACE_U_LongLong): removed user-defined
          conversion to ptr_arith_t.  Replaced with new macro,
          ACE_LONGLONG_TO_PTR.

Thu Jul 15 15:31:49 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/ACE.cpp (timestamp):
        * ace/High_Res_Timer.cpp (print_ave):
        * ace/Local_Tokens.cpp (open):
        * ace/Log_Msg.cpp (log):
        * ace/Log_Record.cpp (format_msg):
        * ace/Naming_Context.cpp (parse_args):
        * ace/OS.cpp (unique_name):

          Fixed warnings and generated by gcc 2.95; mostly due to format
          specifier mismatches and inefficient conversion operator usage.

Thu Jul 15 14:21:32 1999  David L. Levine  <levine@cs.wustl.edu>

        * docs/ACE-guidelines.html: reverted to the original
          perl magic that goes at the top of every script.  The
          fix that was supposed to work on HP/UX doesn't.  See
          Thu Jul 08 22:15:50 1999  David L. Levine  <levine@cs.wustl.edu>

Thu Jul 15 12:19:44 1999  David L. Levine  <levine@cs.wustl.edu>

        * bin/make_release: added -u option, to allow updating the
          version stamps from any directory.  Also, added suppression
          of cvs checkout warning about empty ("New") directories.

        * Makefile: added -u to make_release invocations.

Thu Jul 15 11:39:44 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE version 4.6.45 released.

Thu Jul 15 11:26:43 1999  David L. Levine  <levine@cs.wustl.edu>

        * Makefile: made NEWS a dependency of release.

Thu Jul 15 10:05:40 1999  David L. Levine  <levine@cs.wustl.edu>

        * docs/ACE-guidelines.html: removed reference to
          ACE_OS::scanf ().  No such thing.

Thu Jul 15 10:01:31 1999  Steve Huston  <shuston@riverace.com>

        * ace/OS.h: TRANSMIT_FILE_BUFFERS are not defined on PharLap ETS -
          it's a Microsoft-specific extension to Winsock 1.1.

        * ace/config-win32-common.h: ACE_HAS_IP_MULTICAST is only set for
          Winsock 2.

        Thanks to David Hauck <davidh@realtimeint.com> for these fixes.

Thu Jul 15 09:28:32 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_tru64_cxx.GNU: changed
          4.0f to 4.0F, because that's what sizer -v returns
          on DU 4.0F.  Thanks to Doug Anderson <dla@home.com>
          for reporting this.

        * ace/config-tru64.h: only #define _LIBC_POLLUTION_H_
          with DU >= 5.0.  Thanks to Doug Anderson <dla@home.com>
          for reporting that it's not necessary on DU 4.0F.

Thu Jul 15 09:15:11 1999  Steve Huston  <shuston@riverace.com>

        * ace/config-aix-4.x.h: Corrected template settings for IBM C/C++
          3.6 compiler. It does not get ACE_HAS_STD_TEMPLATE_SPECIALIZATION.

        * include/makeinclude/platform_aix4_cset++.GNU: Delete the
          testAIXCompilerVersion.cpp file after getting the compiler version.

Thu Jul 15 07:33:30 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-tru64.h,config-osf1.h,config-osf1-4.0.h,
          include/makeinclude/platform_tru64_cxx.GNU,platform_osf1_cxx.GNU,
          ACE-INSTALL.html: moved config-osf1.h to config-tru64.h,
          and platform_osf1_cxx.GNU to platform_tru64_cxx.GNU.
          Thanks to Doug Anderson <dla@home.com> for this suggestion.

Wed Jul 14 22:23:10 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-cray.h: replaced ACE_HAS_TEMPLATE_INSTANTIATION_PRAGMA
          with ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION.  The standard
          "template class" explicit instantiations work with version
          3.2.0.1 of the compiler.  Thanks to Doug Anderson <dla@home.com>
          for reporting this.

        * ace/config-ghs-common.h: use
          ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION with Green Hills 1.8.9
          and later.  Thanks to Carlos for suggesting that we give it
          whirl.  It worked :-)

Wed Jul 14 22:03:08 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-osf1-4.0.h: enable pragma message disable declbutnotref
          with Digital Unix 4.0f, as well as 5.0.  Thanks to
          Doug Anderson <dla@home.com> for reporting that
          it's necessary.

        * ACE-INSTALL.html: updated config/platform info for
          Digital UNIX 4.0f (and 5.0).

          [Bug 65]

Wed Jul 14 19:44:21 1999  Steve Huston  <shuston@riverace.com>

        * ace/Thread_Manager.cpp (spawn_i): Defer acquiring the thread
          descriptor's lock until just before attempting to start the thread
          to avoid places where the thread descriptor could be destroyed
          while holding the lock (doing that is an undefined operation in
          pthreads, and has particularly bad results on HP-UX 11). If the
          thread creation does fail, release the lock before returning
          the error indication (taking care to guard errno). Removed an
          unreachable block of code which put the thread descriptor on the
          wrong list anyway.
          Removed the #if 1, #else, #endif around the auto_ptr for
          new_thr_desc - if it's still working this close the ACE 5 release,
          it wins. Besides, the use of the auto_ptr was ingrained in the
          rest of the function, without the #if checks.

Wed Jul 14 19:03:57 1999  David L. Levine  <levine@cs.wustl.edu>

        * etc/purify.solaris2: added another UMR suppression for
          __sigprocmask in the Solaris 2.6 threads library.  Thanks
          to Andy for reporting this.

Wed Jul 14 16:30:48 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Hash_Map_Manager_T.h (class ACE_Hash_Map_Bucket_Iterator):
          Added a new class that allows the iteration over the entries of
          a of a particular bucket in a hash map.

        * tests/Hash_Map_Bucket_Iterator_Test.cpp: A test for the new
          ACE_Hash_Map_Bucket_Iterator class.

Wed Jul 14 16:37:33 1999  Ossama Othman  <othman@cs.wustl.edu>

        * Makefile:

          Added Makefile.am and NEWS to the list of controlled files.  The
          file `NEWS' will get generated when a release is made.

        * TODO:
        * acconfig.h:
        * configure.in:
        * configure:

          Minor ACE Configuration Project related updates and fixes.

Wed Jul 14 13:38:12 1999  Steve Huston  <shuston@riverace.com>

        * tests/Cached_Accept_Conn_Test.cpp: Moved defs of Client_Svc_Handler
          and Server_Svc_Handler classes to new file, Cached_Accept_Conn_Test.h
          to make AIX xlC happy.

        * tests/Cached_Conn_Test.cpp: Moved definition of Svc_Handler class
          new file, Cached_Conn_Test.h to make AIX xlC happy.

        * tests/Cached_Accept_Conn_Test.cpp, Cached_Conn_Test.cpp: Don't
          even try to build these on AIX C Set++ 3.1. It can't hack the
          auto template instantiation - overwrites a template generator
          file and tosses its cookies. ACE is still the best C++ compiler
          test on the planet.

Wed Jul 14 16:24:38 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/CDR_Stream.h:
        * ace/CDR_Stream.cpp:
          Added new method to efficiently steal the contents of a CDR
          stream and store them in another.

Wed Jul 14 12:05:13 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/rules.local.GNU (LN_S): on WIN32
          hosts, use cp -p instead of ln -s, because symbolic
          links aren't supported.

Wed Jul 14 11:22:31 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_vxworks5.x_g++.GNU,
          ACE_INSTALL.html: with egcs (Tornado II) and without
          exception handling, add -Wno-uninitialized to CCFLAGS.
          The version of egcs that is provided with Tornado II
          produces some spurious warnings about uninitialized
          variables (including "this" :-).  This was a problem
          in older versions of egcs, but has since been fixed.
          To avoid the warning, we always disable the warning
          with VxWorks' egcs.

Wed Jul 14 11:20:31 1999  Steve Huston  <shuston@riverace.com>

        * ace/config-aix-4.x.h: Add ACE_LACKS_SETSCHED for pre-4.3 AIX.

Wed Jul 14 11:15:24 1999  David L. Levine  <levine@cs.wustl.edu>

        * examples/Shared_Malloc/Malloc.cpp: only explicitly
          instantiate ACE_Read_Guard<ACE_SYNCH_MUTEX> and
          ACE_Write_Guard<ACE_SYNCH_MUTEX> ifndef ACE_HAS_THREADS.
          With threads, they're explicitly instantiated in
          ace/Synch.cpp.

Wed Jul 14 10:58:30 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/CDR_Stream.h:
        * ace/CDR_Stream.cpp:
          Clarified the relationship between this implementation and the
          original SunSoft version.

Wed Jul 14 10:47:45 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_qnx_neutrino.GNU:
          added ACE_HAS_GNUG_PRE_2_8 := 0, so that exception
          handling will be disabled by default.

Wed Jul 14 10:34:37 1999  David L. Levine  <levine@cs.wustl.edu>

        * examples/IPC_SAP/SOCK_SAP/FD-unclient.cpp: fixed typo,
          ACE_LACKS_UNIX_DOMAIN_SOCKETS instead of
          ACE_HAS_UNIX_DOMAIN_SOCKETS.

Wed Jul 14 10:22:29 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Singleton.*: added ACE_Unmanaged_Singleton and
          ACE_Unmanaged_TSS_Singleton template class.  They're
          identical to ACE_Singleton and ACE_TSS_Singleton,
          respectively, except that they don't register for
          cleanup with the ACE_Object_Manager.  Therefore,
          the application is responsible for explicitly destroying
          the instance after it is no longer needed (if it wants to
          avoid memory leaks, at least).  The close () static member
          function must be used to explicitly destroy the Singleton.
          Thanks to Valery Arkhangorodsky <valerya@servicesoft.com>
          for suggesting this and providing the code.

Wed Jul 14 10:01:47 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.h (ACE_{,U_}ONE_SECOND_IN*): made the trailing
          L or U upper case, for readability.  Thanks to Chris
          for noticing this.

Wed Jul 14 09:40:37 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/wrapper_macros.GNU: when setting
          ACE_HAS_GNUG_PRE_2_8, if not g++:  don't override
          the value to null if it was non-null.  Also, clarified
          use of ACE_HAS_GNUG_PRE_2_8:  1 for g++ < 2.8.0,
          0 for g++ >= 2.8.0, undefined for non-g++.

Wed Jul 14 09:29:57 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Makefile (realclean): remove log/compilations.log*.

Tue Jul 13 22:25:18 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * include/makeinclude/wrapper_macros.GNU:
          Disable the "unitialized" warnings with EGCS+exceptions, it
          gives too many bogus warnings to take care of them.

Tue Jul 13 22:16:17 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * bin/ACEutils.pm:
          Wait for non empty files, sometimes the process creates the
          files but does not have enough time to fill its contents.

Tue Jul 13 21:32:44 1999  Ossama Othman  <othman@cs.wustl.edu>

        * acconfig.h:
        * ltconfig:
        * ltmain.sh:
        * ace/Makefile.am:
        * tests/Makefile.am:

          ACE Configuration Project updates.  Synchronized with current
          version of ACE in CVS repository.

Tue Jul 13 15:22:51 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_vxworks5.x_g++.GNU:
          set ACE_HAS_GNUG_PRE_2_8 to 0 with egcs (Tornado II).

Tue Jul 13 15:15:43 1999  Steve Huston  <shuston@riverace.com>

        * ace/ace-dll.icc, ace-lib.icc: Corrected source file set; now builds
          (still with some warnings) on AIX, Visual Age C++ 4.

Tue Jul 13 15:11:28 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * bin/run_all_win32.pl: Fixed program output redirection problem.
          Unfortunately, the fix requires one to have either 'sh' or '4nt'
          to redirect output from another perl script correctly.

Tue Jul 13 15:04:35 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_qnx_neutrino.GNU:
          removed full paths from commands, because they're
          prefixed with i386-nto-.

        * ace/config-qnx-neutrino.h: updated to build with egcs.

Tue Jul 13 15:03:01 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Pipe.cpp (open): moved declaration of local variable
          "one" inside the ACE_LACKS_TCP_NODELAY #ifndef block.

Tue Jul 13 14:57:56 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/SV_Semaphore_Simple.{h,cpp} (init,open,name_2_key):
          added static cast of ACE_INVALID_SEM_KEY to key_t.  key_t
          is unsigned on QNX Neutrino, but we want to keep
          ACE_INVALID_SEM_KEY as -1.

Tue Jul 13 11:57:53 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/config-win32.h: Changed CApplication to CWinApp.  Thanks to
          John Morey <jmorey@tbi.com> for pointing this out.

Tue Jul 13 11:13:52 1999  Steve Huston  <shuston@riverace.com>

        * ACE_INSTALL.html: Added some info for building on AIX with
          Visual Age C++.

        * ace/config-aix-4.3.x.h: New file - these version-specific configs
          are particularly useful with Visual Age C++, which has its own
          funky make system that doesn't use the platform_macros.GNU files,
          and so doesn't pick up the ACE_AIX_MAJOR/MINOR_VERS settings which
          are used in config-aix-4.x.h.

        * ace/config-aix-4.x.h: Corrected template settings for Visual Age C++
          and added ACE_HAS_TYPENAME for VAC++ also.

Tue Jul 13 10:40:31 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Cached_Connect_Strategy_T.cpp (purge_connections): There is
          no need to set the purge percentage again.

Tue Jul 13 10:39:57 1999  Matthew J Braun  <mjb2@cs.wustl.edu>

        * ace/Containers_T.h,i: Altered private member list_ of
          DLList_Iterator to be a pointer rather than a reference. This
          allows the reset method to work because it was overwriting the
          contents of list_ rather than iterating over a different list

Tue Jul 13 09:14:31 1999  Steve Huston  <shuston@riverace.com>

        * ace/Cached_Connect_Strategy_T.cpp (dtor): Added ACE_TYPENAME
          to 'iter' declaration since its type depends on template parameters.

Tue Jul 13 09:11:24 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_vxworks5.x_ghs.GNU:
          moved LIBS setting for Green Hills 1.8.9 from
          x86-only to all targets.  Thanks to Dale Wood
          <dale_wood@Mitel.com> for confirming that this
          is necessary for PowerPC targets.

Tue Jul 13 08:18:56 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-osf1.h,config-osf1-4.0.h,
          include/makeinclude/platform_osf1_cxx.GNU:
          added another significant figure to the version identifer,
          e.g., 0x40F and 0x500. [Bug 65]

Tue Jul 13 06:45:53 1999  Steve Huston  <shuston@riverace.com>

        * examples/Shared_Malloc/test_position_independent_malloc.cpp: Moved
          definition of Dummy_Data to test_position_independent_malloc.h, a
          new file, to satisfy AIX IBM C++ template instantiation.

        * include/makeinclude/platform_aix4_cset++.GNU: Turn on/off warnings
          based on compiler version, not OS version. Thanks to Craig
          Rodrigues <rodrigc@mediaone.net> for sending the code in!

        * THANKS: Added Craig Rodrigues to the hall of fame.

        * ace/config-aix-4.1.x.h, config-aix-4.2.x.h: Added setting for
          ACE_AIX_MAJOR_VERS and ACE_AIX_MINOR_VERS if they weren't set
          already. Eases backwards compatibility for those who don't use
          the ACE build macros (horrors! :-). Thanks to Jeff Donner
          <jdonner@schedsys.com> for this suggestion.

Mon Jul 12 18:24:34 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * tests/Cached_Accept_Conn_Test.cpp:
          This tests explicit purging from the server's point of view.
          When the acceptor in either its accept_svc_handler () or open ()
          runs out of descriptors, purging of unused svc_handlers from the
          connecton cache is requested.

        * tests/Cached_Conn_Test.cpp:
          Defined ACE_HAS_BROKEN_EXTENDED_TEMPLATES for the
          Caching_Strategy_Adapter. If this condition is true, then only
          Least Recently Used Caching Strategy is available. This was
          necessary for compilers which dont accept long template lists,
          for example GNUC version < 8.0. Total credit for this hack
          to get through the old GNUC compiler goes to Irfan
          <irfan@cs.wustl.edu> of the DOC group.

        * tests/Makefile:
          Added Cached_Accept_Conn_Test.cpp.

        * tests/Makefile:
        * tests/run_tests.sh:
        * tests/run_pharlap_tests.bat:
        * tests/run_tests.bat:
        * tests/run_tests.psosim:
        * tests/run_tests.vxworks:
          Added Cached_Conn_Test, Map_Manager_Test and
          Cache_Map_Manager_Test to the above.

Mon Jul 12 17:31:28 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * bin/run_all_win32.pl: Fixed the missing execution output problem
          and simplified how the script gets invoked.  See comments for
          more details.

        * ace/config-win32.h:
        * ace/Object_Manager.h: Updated some unclear comments regarding
          the use and instantiation of non-static object manager.  Thanks
          to John Morey and David for pointing this out.

        * ace/ace_dll.dsp: Merged additional MFC configuration.  Thanks to
          John Morey <jmorey@tbi.com> for submitting the patch.

Mon Jul 12 15:27:37 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-osf1.h,config-osf1-4.0.h,
          include/makeinclude/platform_osf1_cxx.GNU,
          ACE-INSTALL.html: added support for DU 4.0f.  It needs the
          same #defines that we use on DU 5.0. [Bug 65]

Mon Jul 12 14:41:14 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-win32.h,Object_Manager.h: cleaned up comments
          about the non-static ACE_Object_Manager.  Thanks to
          John Morey <jmorey@tbi.com> for reporting this.

Mon Jul 12 13:54:34 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * ace/Cache_Map_Manager_T.{h,i,cpp}:
          Defined ACE_T1 and ACE_T2 which contain the template parameter
          list and added ACE_HAS_BROKEN_EXTENDED_TEMPLATES macro where
          needed. This takes care of the template list for compilers which
          cant accept a long template list, for example: GCC 2.7.2.
          Also changed the purge() to now call the <caching_utility> for
          purging entries form the cache.

        * ace/Hash_Cache_Map_Manager_T.h:
          Added ACE_HAS_BROKEN_EXTENDED_TEMPLATES to complement the
          Cache_Map_Manager class changes.

        * ace/Cached_Connect_Strategy_T.cpp:
          Changed dtor to take care of the
          ACE_HAS_BROKEN_EXTENDED_TEMPLATES definition.

        * ace/Cached_Connect_Strategy_T.h:
          Removed CONNECTION_CACHE_ITERATOR typedef.

        * ace/Caching_Strategies_T.{h,i,cpp}:
          Changed template parameter list and removed dependency on the
          CONTAINER. Removed clear_cache() method.

        * ace/Caching_Utility_T.{h,i,cpp}:
          Added default cleanup strategies to every kind of
          caching_utiltity. ACE_Recyclable_Hanlder_Caching_Utility no
          longer derives form ACE_Pair_Caching_Utility.

        * ace/Cleanup_Strategies_T.{h,i,cpp}:
          Changed ACE_Svc_Cleanup_Strategy to
          ACE_Recyclable_Handler_Cleanup_Strategy.

        * tests/Cache_Map_Manager_Test.cpp:
        * tests/Map_Manager_Test.cpp:
          Made changes to template instantiations.

        * tests/Cached_Conn_Test.cpp:
          Added out_of_sockets_handler() which will do the purging.
          Added a check for ENOBUFS which arose on NT and ENOENT which
          arose on Linux + Solaris. Defined
          ACE_HAS_BROKEN_EXTENDED_TEMPLATES for GCC versions < GCC 2.8.

Mon Jul 12 12:14:45 1999  David L. Levine  <levine@cs.wustl.edu>

        * docs/ACE-development-process.html: added this page, as
          a start towards a less chaotic development process.

Mon Jul 12 10:05:31 1999  Steve Huston  <shuston@riverace.com>

        * ace/Event_Handler_T.i: Added ACE_TYPENAME on template-dependent types
          in function signatures. Quiets HP-UX aC++.

        * ace/Based_Pointer_Repository.h:
        * ace/Based_Pointer_T.h: Added #include "ace/OS.h" to pick up def. of
          ACE_Export when instantiating templates with AIX IBM C++.

        * include/makeinclude/platform_hpux_aCC.GNU: Removed definition for
          CPP_LOCATION - use aCC - cpp has too many problems, and a fix for
          the pragma warnings was checked into TAO_IDL.

Mon Jul 12 09:26:29 1999  David L. Levine  <levine@cs.wustl.edu>

        * testsr/Makefile: don't build libDLL_Test.so if not building
          shared libraries.  This simplifies the build on static-libs
          only platforms, and can be used by run_tests.sh, below.
          [Bug 62]

        * tests/run_tests.sh: don't run DLL_Test if libDLL_Test.so
          was not built.

Mon Jul 12 07:48:04 1999  David L. Levine  <levine@cs.wustl.edu>

        * docs/ACE-guidelines.html: updated guideline under CVS
          section to match the other one about always testing
          on egcs.

Sun Jul 11 23:59:52 1999  nanbor  <nanbor@cs.wustl.edu>

        * ACE version 4.6.44 released.

Sat Jul 10 18:05:41 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/config-kcc-common.h: Added ACE_NEW_THROWS_EXCEPTIONS.
          Thanks to David for pointing this out.

Sat Jul 10 16:22:00 1999  Chris Gill  <cdgill@tango.cs.wustl.edu>

        * ace/config-win32-common.h: wrapped ACE_HAS_TYPENAME_KEYWORD so it is
          only set for MSVC++ 6.0 or higher.  This is to work around a compiler
          bug in MSVC++ 5.0 when trying to compile certain forms with the
          typename keyword in a template method argument list.

Sat Jul 10 13:16:50 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Malloc: Changed the type of pointer used by ACE_Name_Node
          from void * to char * so that we can integrate this cleanly with
          ACE_Based_Pointer<>, which will fail if we use void since we
          can't return from a "void" function!

        * tests/Thread_Pool_Test.cpp (open): Fixed another somewhat bogus
          warning from EGCS related to initialization of loop variables.

        * tests/New_Fail_Test.cpp (main): Make sure to initialize pointers
          so that EGCS doesn't complain.

        * tests/MT_Reactor_Timer_Test.cpp (main): Fixed a signed/unsigned
          mismatch.

        * tests: Added appropriate header comments for all the *.h files.

        * tests/Cache_Map_Manager_Test.cpp: Capitlized the hash_key
          class to be Hash_Key, which is standard ACE programming style.

        * ace/Service_Config.cpp: Added yet another set of
          changes to open_i() so that the -d option is handled
          appropriately.  Thanks to Jonathan Reis
          <reis@minniemouse.cemax.com> for this fix.

        * ace/SOCK_Acceptor.h: Clarified the parameters for
          ACE_SOCK_Acceptor's constructor and open() methods.  Thanks to
          Ron MacKenzie <ronm@SLAC.Stanford.EDU> for motivating this.

Sat Jul 10 13:56:30 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tests/MT_Reactor_Timer_Test.cpp (main): Fixed signed/unsigned
          comparison.

Sat Jul 10 08:01:36 1999  David L. Levine  <levine@cs.wustl.edu>

        * docs/ACE-guidelines.html: THANKS instead of README.

Fri Jul  9 20:54:30 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/UNIX_Addr.{h,i} (hash):

          Implemented a hash function for ACE_UNIX_Addr instead of relying
          on the base class no-op hash function.  Thanks to Irfan for
          explaining the best way to do this.

Fri Jul  9 20:39:47 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * tests/Cached_Conn_Test.cpp: Added an Svc_Handler class which
          helped in verifying the course of the program execution.

        * ace/Caching_Utility_T.cpp (minimum): Cleaned up code by removing
          redundant else if statement.

        * tests/Cache_Map_Manager_Test.cpp: Resolved some template typos
          which surfaced on compiling with VxWorks.

Fri Jul 09 20:14:13 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tests/MT_Reactor_Timer_Test.cpp (main): Added fixes so that test
          can work with WFMO_Reactor (WFMO_Reactor needs an extra
          handle_events() to get started).

        * tests/Conn_Test.cpp (spawn_processes): Only printing reaping
          message when result is not -1.

        * ace/Strategies_T.i (ACE_Refcounted_Hash_Recyclable<T>::operator==):
          The check should be for "and", not "or".

        * tests/Conn_Test.cpp: Since timed accept is implemented using
          select(), and we use timed accepts with threads, we need a real
          lock when using timed accepts even if the OS has thread-safe
          accept.

          Also changed the default number of clients to 5.  Hopefully,
          this won't overrun the backlog on the listen socket.

        * ace/Svc_Handler.cpp (shutdown): Remove self from Reactor only
          when we have a valid handle.  Otherwise, we lose our current
          errno, since the failed remove_handler will set the errno to
          EINVAL.

Fri Jul  9 14:02:52 1999  Steve Huston  <shuston@riverace.com>

        * ace/config-aix-4.x.h: Re-enabled ACE_LACKS_SETSCHED for AIX 4.3.
          The OS defs are not aligned/matched correctly with what they mean
          in this area, but will need to wait til after ACE 5.0 is done
          before straightening it out.

        * ace/WFMO_Reactor.cpp (ACE_WFMO_Reactor_Handler_Repository::bind_i):
          Set errno to EMFILE if the max number of handles is registered,
          instead of leaving a stale errno for the user to figure out.

        * tests/MT_Reactor_Timer_Test.h (Dispatch_Count_Handler): Changed
          type of timers_fired_ from int to size_t so it matches type of
          ACE_MAX_TIMERS.

Fri Jul  9 14:27:10 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Service_Config.cpp (open_i): Be default, disable debugging
          messages.  Only reenable them if the -d option is given.  Thanks
          to Jerry De Master <jdemaste@ipdinc.com> for reporting this.

        * ace/Based_Pointer_T: Factored out all but the operator-> into
          a new class called ACE_Based_Pointer_Basic so that we can use
          this for "basic types" like char *.  Thanks to Irfan for
          pointing this out.

        * ace/Based_Pointer_Repository.cpp (unbind): Fixed a
          bug in the unbind() loop.  Thanks to David Levine and DEC UNIX
          C++ for noticing this!

        * ace/Reactor.i (schedule_wakeup): Fixed a misplaced assignment
          of Event_Handler->reator ().  Thanks to Carlos for reporting
          this.

Fri Jul 09 13:11:33 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tests/Conn_Test.cpp (spawn_threads): ACE_OS::perror takes a
          wchar_t string on CE.

        * tests/test_config.h (set_output): We should use non-unicode
          version of ACE_OS::getenv to initialize test_dir on "regular"
          UNICODE compilation.  Thanks to Steve for reporting this.

          Added more WinCE/UNICODE fixes.

Fri Jul  9 12:16:00 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * ace/Caching_Utility_T.cpp (minimum):
          Modified minimum () of ACE_Recyclable_Handler_Utility class so
          that the minimum value is also an entry which is purgable.

        * tests/Cache_Map_Manager_Test.cpp:
          SunC++4.0 compiler doesnt accept typedefs with templates and
          having ::, for example: HASH_MAP::iterator. One has to typedef
          HASH_MAP::iterator and use it to typedef something else. Fixed
          this problem in the above test.

Fri Jul  9 11:39:40 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Dirent.i: Added a pair of checks to open() and close()
          to avoid double deletes.  Thanks to Tom Arbuckle
          <arbuckle@uran.informatik.uni-bonn.de> for pointing this out.

        * ace/Reactor.i: For schedule_timer() and schedule_wakeup(),
          make sure that the Event_Handler is assigned "this" Reactor
          upon successful completion of the operation.  Thanks to
          Dirk Broer <Dirk.Broer@gsfc.nasa.gov> for suggesting this.

Fri Jul  9 11:10:23 1999  Steve Huston  <shuston@riverace.com>

        * include/makeinclude/platform_hpux_aCC.GNU: Re-suppress warning
          829 on 10.x because there's an offending system header file.

        * tests/test_config.h (ACE_Test_Output::set_output): Change test_dir
          to be const because it's initialized with a string literal.

Fri Jul  9 10:52:45 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * ace/Caching_Utility_T.cpp (minimum): Checked the state of the
          Refcounted_Hash_Address with ACE_Recyclable::IDLE_AND_PURGABLE.

Fri Jul 09 10:49:40 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Message_Queue_Test.cpp (main): changed success
          message from timed dequeue test to not contain "timedout",
          because that trips run_tests.check.

Fri Jul 09 10:25:42 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Shared_Memory_MM.h (ACE_Shared_Memory_MM): Changed the
          filename parameter from a non-const string to a const string.
          Thanks to Ulf Jaehrig <jaehrig@desys.com> for pointing out this
          problem.

Fri Jul 09 03:31:34 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Basic_Types.i: added const to each of the static casts.

Fri Jul 09 01:45:25 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * bin/auto_compile_win32.pl: A lot of projects changed names
          recently and thus the file was not working properly.

Thu Jul  8 23:15:06 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * Merging the "ami_phase3" branch on to the main branch. Change
          was done to the CDR_Stream{h,i} files  to add the method
          <byte_order> to the CDR class. Other than that, no change was
          done to ACE.

Thu Jul 08 22:15:50 1999  David L. Levine  <levine@cs.wustl.edu>

        * docs/ACE-guidelines.html: changed the perl magic that
          goes at the top of every perl script, to pick up perl
          from the users path.  This new version works on HP/UX.
          Thanks to Carlos for divining it.

Thu Jul 08 22:05:31 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-linux-common.h: added #define of
          ACE_DEFAULT_BASE_ADDR to 0x40000000 on __powerpc__
          only.

        * ace/config-linuxppcr5.h: removed.  LinuxPPC can
          now use config-linux-lxpthreads.h.

        * ACE-INSTALL.html:  added LinuxPPC info.

          Thanks to Andreas Tobler <a.tobler@schweiz.ch> for helping
          to factor out the code from config-linuxppcr5.h.

Thu Jul  8 21:57:17 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Malloc_T.h:
        * ace/Malloc_T.cpp:
          Changed the Cached_Allocator class to use a char* as the memory
          source.
          It was allocated as char* and deallocated as a char*, but casted
          to T* to use placement new; this was actually unneeded and
          actually an error: the memory does not become a T* until
          placement new is invoked on it. [BUGID:40]

Thu Jul 08 21:34:42 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-lynxos.h: on PowerPC, set
          ACE_NEEDS_HUGE_THREAD_STACKSIZE to 32000, instead of
          its apparent default of 15000.  On both x86 and ppc,
          #define ACE_MAP_FIXED to 0 and ACE_DEFAULT_BASE_ADDR to
          0 to try to get the OS to always pick shared memory addresses.

          Thanks to Dan Butler <daniel.g.butler@boeing.com> for
          suggesting the use of ACE_NEEDS_HUGE_THREAD_STACKSIZE here.

        * tests/Recursive_Mutex_Test.cpp (main): removed explicit
          stack size setting, now that we're using
          ACE_NEEDS_HUGE_THREAD_STACKSIZE on LynxOS/PPC.

Thu Jul 08 18:47:23 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * ace/Cached_Connect_Strategy_T.cpp:
          Changed:
          entry->ext_id_.state (ACE_Recyclable::IDLE);
          to
          entry->ext_id_.state (ACE_Recyclable::IDLE_AND_PURGABLE);

        * ace/Caching_Utility_T.{h,cpp}:
          Added ACE_Recyclable_Handler_Caching_Utility which takes care
          that the svc_handler to be purged is in the IDLE_AND_PURGABLE
          state.
          Made method minimum () virtual.

        * ace/Strategies.h:
          Added IDLE_AND_PURGABLE and IDLE_BUT_NOT_PURGABLE states and
          removed IDLE state  from the enum. This change was necessary to
          take care of AMI using the Mux Strategy.

        * ace/Strategies_T.cpp (cache_i):
          Made entry state ACE_Recyclable::IDLE_AND_PURGABLE.

        * ace/Startegies_T.i (operator==):
          Added checks for the ACE_Recyclable::IDLE_AND_PURGABLE and
          ACE_Recyclable::IDLE_BUT_NOT_PURGABLE states.

          Thanks to Irfan <irfan@cs.wustl.edu> of the DOC group for
          helping with this.

Thu Jul 08 18:47:23 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tests/Cache_Map_Manager_Test.cpp: Simplified code and output.

Thu Jul 08 14:56:22 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Basic_Types.{h,i} (ACE_U_LongLong): added operators
          that take ACE_UINT32 arguments corresponding to each of
          the operators that take ACE_U_LongLong & arguments.  This
          solves some more overload resolution ambiguities.

        * ace/Stats.cpp: changed comparisons of ACE_U_LongLong with
          ints to unsigned ints, to avoid overload resolution ambiguity.

Thu Jul 08 14:29:42 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.i (gethrtime): cast ts.tv_nsec explicitly to
          ACE_hrtime_t, instead of ACE_UINT32, to avoid overload
          resolution ambiguity now that we have that ACE_U_LongLong
          implicit conversion to ptr_arith_t.

Thu Jul  8 13:50:14 1999  Steve Huston  <shuston@riverace.com>

        * ace/Reactor_Impl.h (dispatch_notifications): Changed ACE_Handle_Set
          arg from const to non-const. Fix in ACE_Select_Reactor_Notify
          requires the ability to change the handle set.

        * ace/WFMO_Reactor.{h cpp}: Corresponding removal of 'const' from
          ACE_WFMO_Reactor_Notify::dispatch_notifications. Signature change
          only - the function is a no-op in this class.

        * ace/Select_Reactor_Base.{h cpp}: In ACE_Select_Reactor_Notify,
          dispatch_notifications(), remove the notify pipe's handle from the
          dispatch handle set when handling a notification. Else it remained
          set and dispatchng I/O handlers came back and ran through it
          again, which artificially increased the count of dispatched
          handlers, and left some input unhandled when it was ready.

        * tests/MT_Reactor_Timer_Test.cpp: Added some verification checks to
          be sure that timer, notify, and input events all are handled at the
          right time.

Thu Jul 08 12:35:23 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tests/test_config.h: Reorganized WinCE's macros and fix some
          minor unicode problems.

Thu Jul  8 11:33:50 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * Rebuilt the ACE+TAO.tar.gz file.  For some reason, there
          was a ^M at the end of each line!  Thanks to Bruce Edge
          <bedge@sattel.com> for reporting this.

        * ace/Based_Pointer_Repository.cpp (unbind): Rearranged the
          iterator code a bit to see if that'll make DEC C++ happy.

        * ace/OS.h: Moved the ACE_MALLOC_ALIGN macro into OS.h.

        * config-aix-4.x.h,
          config-lynxos.h,
          config-psos-diab-mips.h,
          config-psos-diab-ppc.h,
          config-psos-diab.h,
          config-psos-tm.h,
          config-psosim-g++.h,
          config-sunos5.5.h:
          Added the ACE_MALLOC_ALIGN macro back since it's used in
          an ACE test program.

        * ace/Malloc.cpp: Removed the trailing ';' on the #pragma
          instantiate.  Thanks to David Levine for reporting this.

Thu Jul 08 11:35:53 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE-INSTALL.html: added note about IP multicast support
          with Tornado II/VxWorks 5.4.  It's not enabled by default
          in ACE.

Thu Jul  8 11:31:13 1999  Steve Huston  <shuston@riverace.com>

        * tests/Message_Queue_Test.cpp: Added a test to see the correct errno
          is set for a timed-out dequeue operation.

Thu Jul 08 11:30:43 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE-INSTALL.html: added note about the uninitialized
          variable warnings from (the old) egcs that is
          distributed with Wind River's Tornado II.

Thu Jul 08 10:40:02 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-linuxppcr5.h: use config-linux-lxpthreads.h
          because thread support works.

        * ace/config-linuxppcr5.h, config-linux-common.h:  use an
          ACE_DEFAULT_BASE_ADDR of 0x40000000, because that allows
          Naming_Test to work.

          With these two changes, all ACE tests pass on LinuxPPC.
          Thanks to Andreas Tobler <a.tobler@schweiz.ch> for the
          fixes and testing.

Thu Jul 08 10:25:55 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.h,Basic_Types.h: added ACE_U_LongLong conversion operator
          to ptr_arith_t.  Moved ptr_arith_t typedef from OS.h to
          Basic_Types.h, so that it can be used by ACE_U_LongLong.
          Thanks to Chris for helping to figure this out.

Thu Jul  8 08:34:22 1999  Steve Huston  <shuston@riverace.com>

        * ace/Log_Msg.cpp (log): Don't special-case the %t handling on AIX
          4.3 - just 4.2 and earlier.

Thu Jul  8 00:23:02 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Malloc_T.cpp: Updated all the methods that check
          cp_ptr_ to return immediately if it's 0.  Thanks to Dieter for
          suggesting this.

        * ace/Malloc.cpp (dump): Added a cast to trigger operator void
          * for freep_ (which may be a smart pointer in some
          configurations).

        * ace/Based_Pointer_Repository: Revised the implementation of
          this class to use the "Cheshire-Cat" technique to hide the
          implementation to avoid circular #include dependencies.

        * ace/Token.h (ACE_Token): Clarified that the timeouts are in
          "absolute" time, not relative time.  Thanks to Everett Anderson
          <eea1@cs.wustl.edu> for reporting this.

        * ace/config-win32-borland.h: Only enable
          ACE_HAS_EXPLICIT_TEMPLATE_INSTANTIATION if we're running on
          older versions of Borland.  Thanks to Christopher Kohlhoff
          <chris@kohlhoff.com> for reporting this.

Wed Jul 07 22:44:22 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Recursive_Mutex_Test.cpp (main): added comment
          explaining why the stack size is now set.

        * tests/test_config.h: removed special ACE_MAX_PROCESSES
          and ACE_MAX_THREADS values for LynxOS, because most
          tests don't need them.

        * tests/Process_Mutex_Test.cpp: use only 4 processes
          instead of ACE_MAX_PROCESSES, on LynxOS only.  Otherwise,
          the test's ACE_LOG_MSG->op_status assertion fails.

        * ACE-INSTALL.html: removed statements about some tests
          failing on LynxOS/PPC.  Just Naming_Test and
          MM_Shared_Memory_Test fail now.

Wed Jul 07 19:51:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * ace/config-ghs-common.h: removed use of native auto_ptrs, as they
          implement an older specification which lacks the reset method.

Wed Jul  7 17:17:10 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/ARGV.cpp (ACE_ARGV):
        * ace/OS.cpp (ACE_OS_Recursive_Thread_Mutex_Guard):
        * ace/Sched_Params.i (ACE_Sched_Priority_Iterator):

          Added some class members to the member initializer lists to fix
          some "Effective C++" warnings from EGCS.

Wed Jul  7 16:33:29 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * tests/Cached_Conn_Test.cpp (main): Added default testing of LRU,
          LFU, FIFO caching strategies.

        * tests/Cached_Conn_Test.cpp (parse_args):
        * tests/Cache_Map_Manager_Test (parse_args):
          Runtime selection of different caching strategies
          (lru/lfu/fifo/null) made possible.

        * Caching_Strategies_T.{i,cpp}:
          Removed typos and also definied the virtual destructor for
          ACE_Caching_Strategy.

        * tests/Map_Manager_Test.cpp (test_cache_map_manager):
          Added <null_caching_strategy> to the construction of
          <cache_map_manager> and <hash_cache_map_manager> objects to make
          it in sync with the changes made below.

Wed Jul 07 16:06:45 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Recursive_Mutex_Test.cpp: explicitly set the
          stack size.  This solves the problem on LynxOS/PPC, below, so
          the 65-iteration workaround was removed.  Thanks to Doug for
          this suggestion.

Wed Jul  7 13:27:53 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/config-win32-borland.h,
          ace/config-win32.h: Added support for the ACE::major_versions(), etc.
          for PC versions of ACE, as well as UNIX.  Thanks to
          Jeff Hellzen <jhellzen@my-deja.com> for suggesting this.

        * ace: Added a new Based_Pointer_T.i file that inlines the
          small methods.

        * ace/Malloc[_T]: Cleaned up the code so that we can use the
          ACE_Based_Pointer<> consistently when
          ACE_HAS_POSITION_INDEPENDENT_MALLOC is enabled and disable.

        * ace/Malloc.h: By default, ACE_MALLOC_PADDING is set to 1 so that
          we don't get "divide by zero" errors.  However, it's only used
          in the computation of the ACE_Malloc_Header if it's > 1.

        * config-aix-4.x.h,
          config-lynxos.h,
          config-psos-diab-mips.h,
          config-psos-diab-ppc.h,
          config-psos-diab.h,
          config-psos-tm.h,
          config-psosim-g++.h,
          config-sunos5.5.h:
          Removed the ACE_MALLOC_ALIGN macro since it should no longer
          be necessary.

        * ace/Malloc.h: Changed the use of macro ACE_MALLOC_ALIGN to
          ACE_MALLOC_PADDING, which is more descriptive.

        * Fixed a typo in the TAO-mail.html program where ace-*
          should have been tao-*.  Thanks to Pedro Alves Ferreira
          <pedro.ferreira@inescn.pt> for reporting this.

        * Fixed all vestiages of "BUG-REPORT-FORM" to say
          "PROBLEM-REPORT-FORM."  Thanks to Neil B. Cohen <nbc@cisco.com>
          for reporting this.

Wed Jul 07 12:27:32 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-lynxos.h: added ACE_LACKS_FORK for PowerPC
          only.  This cleans up most of the remaining test problems
          on LynxOS/PPC.

Wed Jul 07 11:26:06 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/Malloc_T.cpp: Added ASYS_TEXT macros.

Wed Jul  7 09:05:32 1999  Steve Huston  <shuston@riverace.com>

        * ace/Caching_Strategies_T.i (ACE_Caching_Strategy_Adapter<>::purge_
          percent): Don't return a value from a void function.

Wed Jul 07 08:35:24 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * examples/Threads/future1.cpp
        * examples/Threads/future2.cpp
        * tests/Future_Set_Test.cpp
        * tests/Future_Test.cpp

          Fixed some template instantiations.

Wed Jul  7 03:27:16 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * examples/Shared_Malloc: Added a new file called
          test_position_independent_malloc.cpp that exercises the new
          "position-independent" features of the ACE_Malloc< class.

        * ace/Malloc_T.cpp: All the ACE_Malloc constructors were calling
          open() without checking the results.  Now, if failure occurs we
          print a message.  In addition, we weren't checking in
          shared_malloc() to make sure that we'd been properly initialized
          by the constructor.  Now, if we aren't initialized correctly we
          return 0.  Thanks to Dietrich Quehl
          <Dietrich.Quehl@med.siemens.de> for reporting these problems.

        * ace/Memory_Pool: Added a new feature to ACE_Shared_Memory_Pool
          and ACE_Shared_Memory_Pool_Options that makes it possible to
          tailor the size of System V shared memory segments without
          breaking any existing ACE code.  Thanks to Serge Kolgan
          <skolgan@cisco.com> for contributing this enhancement.

        * ace/Makefile.bor (OBJFILES): Updated this file to include
          the new Based_Pointer_Repository.obj entry.

        * ace/Makefile: Reran make depend.

        * ace/Makefile: Added the Based_Pointer_Repository.{h,cpp} and
          Based_Pointer_T.{h,cpp} files to the Makefile.

        * ace/Malloc.h: Added the first support for the new "Based Pointer
          Malloc" feature that's described below.

         * ace: Added the Based_Pointer_Repository.{h,cpp} and
          Based_Pointer_T.{h,cpp} files to the release.  These classes
          make it possible to transparently use "pointers" in shared
          memory without having to ensure that the base addresses of all
          the pointers are mapped into separate processes at the same
          absolute memory base address.  Thanks to Dietrich Quehl
          <Dietrich.Quehl@med.siemens.de> for contributing this software.

Wed Jul 07 01:28:40 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/ace_dll.dsp:
        * ace/ace_lib.dsp: Added the Based_Pointer_Repository.{h,cpp} and
          Based_Pointer_T.{h,cpp} files to the project files.

        * ace/Based_Pointer_Repository.cpp: Added define ACE_BUILD_DLL.

Tue Jul 06 22:47:04 1999  David L. Levine  <levine@cs.wustl.edu>

         * bin/check_build_logs: filter out Purify warning about
           non-pic R_SPARC_*.

         * ace/config-linuxppcr5.h: commented out #define __USE_XOPEN
           because it's not necessary with glibc 2.1.1.  Thanks to
           Andreas Tobler <toa@pop.agri.ch> for reporting this.

         * ace/OS.i (thr_kill, thr_setprio, sema_destroy, sema_wait, chdir,
           unlink, sema_post, thr_continue, thr_getprio, thr_suspend,
           ioctl): on VxWorks only, removed ACE_ADAPT_RETVAL wrapper from
           system call, because it returns OK/ERROR (except for ioctl,
           which returns driver number/ERROR).  Thanks to Elias Sreih
           <sealstd1@nortelnetworks.com> for reporting this.

         * tests/SOCK_Send_Recv_Test.cpp (server): added 5 second
           sleep so that the code agrees with the comments :-) It now
           passes on LynxOS.  Thanks to Steve Huston for the fix.  Also,
           changed an exit () call to ACE_OS::exit (), and changed a few
           C-style casts to ANSI-style casts.

Tue Jul  6 19:20:16 1999  Steve Huston  <shuston@riverace.com>

         * ace/Cache_Map_Manager_T.h: Removed extra "ace/" from #pragma
           implementation directive.

         * tests/Cache_Map_Manager_Test.cpp: Changed typedefs for KEY and
          VALUE from size_t to ACE_UINT32 to they always pick up the
          specializations for ACE_Hash, etc. On HP-UX and AIX, size_t is
          not the same as ACE_UINT32, and this caused build errors.

         * tests/Conn_Test.cpp: Restrict range of the test on PharLap ETS,
          else it runs out of resources with default configuration.

Tue Jul  6 18:21:37 1999  Everett Anderson  <eea1@cs.wustl.edu>

         * ace/Token_Request_Reply.{h,i,cpp}: Added
          ACE_TOKEN_REQUEST_HEADER_SIZE for the fixed-length portion of
          ACE_Token_Request's Transfer struct, changing length
          calculations accordingly.  Added two bytes to the buffer to
          accomodate '\0' values after the token name and client ID.

         * ace/Remote_Tokens.cpp: Changed the check for failure when
           receiving a reply in request_reply.

Tue Jul  6 18:21:36 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

         * ace/Map_Manager.cpp: Made this file conform to the ACE programming
           guidelines.

Tue Jul  6 18:31:34 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

         * include/makeinclude/platform_irix6.x_sgic++.GNU:
           Removed pesky warnings about functions to big to optimize
           because it would be slow.

Tue Jul  6 18:15:31 1999  Steve Huston  <shuston@riverace.com>

         * ACE_INSTALL.html: Added a further note re PharLap ETS builds.

         * ace/config-pharlap.h: Added ACE_TIMER_SKEW of 10ms.

         * tests/Atomic_Op_Test.dsp:
         * tests/Barrier_Test.dsp:
         * tests/Cache_Map_Manager_Test.dsp:
         * tests/Future_Set_Test.dsp:
           Changed PharLap ETS configurations to put intermediate files in
           ETS_LIB\Debug (like all the others), not in ETS_DLL\Debug.

         * tests/test_config.h: Set ACE_MAX_CLIENTS to 4 for PharLap ETS.

         * tests/run_pharlap_tests.bat: Disabled some tests of unsupported
           facilities.

         * tests/SOCK_Test.cpp: Replaced "localhost" with ACE_LOCALHOST.

Tue Jul  6 17:54:52 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu

        * ace/Caching_Strategies_T.{h,i,cpp}: Added Abstract Base class
          called ACE_Caching_Strategy and ACE_Caching_Strategy_Adaptor
          which facilitate changing of caching strategies at runtime using
          the External Polymorphism pattern.

        * ace/Cached_Connect_Strategy_T.{h, cpp}: Changed the signature of
          the constructor and also removed the <caching_strategy_> member.

        * ace/Cache_Map_Manager_T.{h, cpp}:
        * ace/Hash_Cache_Map_Manager_T.{h,cpp}:
          Changed the signature of the constructor.This was needed to be
          able to use the External Polymorphism pattern.

        * tests/Cache_Map_Manager_Test.cpp:
        * tests/Cached_Conn_Test.cpp:
          Made necessary changes to reflect the changes above.
          Thanks to Irfan of the DOC group for helping with this.

Tue Jul  6 17:34:52 1999  Steve Huston  <shuston@riverace.com>

        * ace/config-aix-4.x.h: Enabled ACE_HAS_PTHREADS_UNIX98_EXT and
          removed ACE_LACKS_RWLOCK_T for AIX 4.3. Moved some other
          ACE_LACKS settings to the pre-4.3 threads section to allow
          taking advantage of more capability on AIX 4.3.

Tue Jul 06 16:29:32 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/OS.h: Moved the string conversion macros before including
          OS.i because we also use them in the file.  Thanks to Carlos for
          reporting this.

        * OS.{h,i,cpp}:
        * Parse_Node.cpp: Windows CE fixes.

Tue Jul 06 15:56:19 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/ACE.h,Object_Manager.{h,cpp},OS.{h,cpp}
          (ACE_Object_Manager*::init () and fini ()): return 1 instead
          of -1 after the first call, per program invocation.  Thanks
          to Jody Hagins <jody@atdesk.com> for this suggestion.

Tue Jul  6 15:04:49 1999  Douglas C. Schmidt  <schmidt@ace.cs.wustl.edu>

        * ace/OS.i (sigwait): Fixed a problem with macro-itis and GCC.  The
          following macro

          # if (__FreeBSD__ < 3) || defined (CHORUS) || defined (ACE_PSOS)

          was always evaluating to true, even when we're not on FreeBSD!.
          The following macro works around this:

          # if (defined (__FreeBSD__) && (__FreeBSD__ < 3)) ||
            defined (CHORUS) || defined (ACE_PSOS)

          Thanks to Elias Sreih <sealstd1@nortelnetworks.com> for
          reporting this and Carlos for suggesting the workaround.

Tue Jul  6 11:39:59 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/OS.i: Updated the comment for ACE_ADAPT_RETVAL to
          clarify why it is needed.  Thanks to Elias Sreih
          <sealstd1@nortelnetworks.com> for motivating this clarification.

Tue Jul  6 10:42:02 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tests/test_config.h (ACE_INIT_LOG): Fixed a typo in VxWorks'
          definition of ACE_INIT_LOG.  Thanks to David for reporting
          this.

Tue Jul  6 10:17:19 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * include/makeinclude/ace_flags.bor: Removed an extraneous
          "\orbsvcs".  Thanks to Eugene Surovegin (surovegin@softlab.ru)
          for reporting this.

Tue Jul 06 10:17:12 1999  David L. Levine  <levine@cs.wustl.edu>

        * bin/check_build_logs: use mhmail instead of mailx on Suns.
          mailx loses the subject, when run from my cron job.  Thanks
          to Naga for reporting this.

Mon Jul  5 20:45:21 1999  Steve Huston  <shuston@riverace.com>

        * ace/OS.(h i): Added code for support of pthread suspend/resume and
          pthreads reader-writer locks. These features are enabled by setting
          the ACE_HAS_PTHREADS_UNIX98_EXT and removing ACE_LACKS_RWLOCK_T.

        * ace/config-hpux11.h: Added ACE_HAS_PTHREADS_UNIX98_EXT and removed
          ACE_LACKS_RWLOCK_T - this enables native reader/writer locks as well
          as thread suspend and reusme.

        * ace/README: Added ACE_HAS_PTHREADS_UNIX98_EXT.

        * apps/JAWS/server/HTTP_Config.(h cpp):
        * apps/JAWS/server/HTTP_Response.( h cpp): const-corrected char *.

Mon Jul  5 16:39:50 1999  Douglas C. Schmidt  <schmidt@mambo.cs.wustl.edu>

        * ACE-INSTALL.html: Updated the discussion to point out
          our support for KAI C++ 3.3, Borland C++ Builder 4.0, and the
          IBM VisualAge C++ compiler.

        * ace/Future.h: Moved the static methods until the bottom
          of the ACE_Future_Rep class to workaround a bug with Borland's
          C++ Builder.  Thanks to Christopher Kohlhoff
          <chris@kohlhoff.com> for testing this fix.

        * ace/Timer_Heap_T.cpp (grow_heap): Removed an extra memory
          allocation that snuck in whilst integrating the IBM VisualAge
          C++ compiler patches.  Thanks to David Levine for reporting
          this.

        * Added new Borland Makefiles.  Thanks to Christopher Kohlhoff
          <chris@kohlhoff.com> for these.

        * include/makeinclude: Added several new platform configuration
          files for Borland C++ Builder.  Thanks to Christopher Kohlhoff
          <chris@kohlhoff.com> for these.

Mon Jul  5 13:08:36 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * tests/Cache_Map_Manager_Test.cpp: Added ACE_UNUSED_ARG macros
          for <result> to ward off warnings.

Mon Jul 05 13:00:19 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Malloc.i (free): Fixed unused arg warning for <ptr>.

        * examples/Threads/future1.cpp:
        * examples/Threads/future2.cpp:

          Fixed template instantiations.

Mon Jul  5 12:25:11 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/OS.i (strspn):
          This function cannot return -1 to indicate errors, the function
          returns an unsigned integral type.

Mon Jul 05 12:14:56 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/OS.i: Wchat_t version of strenvdup should only be available
          on Win32.  Thanks to Bala, Carlos, and David for noticing this.
          (strspn): Ditto to this function.

Mon Jul 05 09:58:07 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE-INSTALL.html: in example config.h for VxWorks on NT,
          use "" style #includes instead of <>.  <> should only be
          used for system headers.

Mon Jul 05 04:11:05 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tests/version_tests/Future_Set_Test.dsp:
        * tests/version_tests/version_tests.dsw: Added Future_Set_Test
          into version tests workspace.

        * ace/ACE.cpp:
        * ace/ACE.h:
        * ace/DLL.cpp:
        * ace/DLL.h:
        * ace/Env_Value_T.h:
        * ace/Env_Value_T.i:
        * ace/FIFO.cpp:
        * ace/FIFO.h:
        * ace/FIFO.i:
        * ace/FIFO_Recv.cpp:
        * ace/FIFO_Recv.h:
        * ace/FIFO_Recv_Msg.cpp:
        * ace/FIFO_Recv_Msg.h:
        * ace/FIFO_Send.cpp:
        * ace/FIFO_Send.h:
        * ace/FIFO_Send_Msg.cpp:
        * ace/FIFO_Send_Msg.h:
        * ace/FILE_Connector.i:
        * ace/Filecache.cpp:
        * ace/Get_Opt.cpp:
        * ace/INET_Addr.cpp:
        * ace/Local_Name_Space_T.cpp:
        * ace/Log_Record.cpp:
        * ace/Message_Queue_T.cpp:
        * ace/Name_Proxy.cpp:
        * ace/Naming_Context.cpp:
        * ace/Naming_Context.h:
        * ace/OS.cpp:
        * ace/OS.h:
        * ace/OS.i:
        * ace/Parse_Node.cpp:
        * ace/Parse_Node.h:
        * ace/Proactor.cpp:
        * ace/Process.cpp:
        * ace/RB_Tree.cpp:
        * ace/Registry_Name_Space.cpp:
        * ace/Remote_Name_Space.cpp:
        * ace/Remote_Name_Space.h:
        * ace/Remote_Tokens.cpp:
        * ace/Remote_Tokens.h:
        * ace/Remote_Tokens.i:
        * ace/SOCK_Dgram_Mcast.cpp:
        * ace/SPIPE_Connector.cpp:
        * ace/SV_Message_Queue.cpp:
        * ace/SV_Semaphore_Simple.cpp:
        * ace/SV_Shared_Memory.cpp:
        * ace/Stats.cpp:
        * ace/Stats.h:
        * ace/Strategies_T.cpp:
        * ace/Strategies_T.i:
        * ace/Svc_Conf.h:
        * ace/Svc_Conf.y:
        * ace/Svc_Conf_y.cpp:
        * ace/Token_Collection.cpp:
        * ace/Token_Collection.h:
        * ace/Token_Collection.i:
        * ace/Token_Invariants.cpp:
        * ace/Token_Invariants.h:
        * ace/UPIPE_Acceptor.cpp:
        * ace/UPIPE_Connector.cpp:
        * ace/UPIPE_Connector.i:
        * ace/WFMO_Reactor.cpp:
        * ace/WIN32_Asynch_IO.cpp:
        * ace/WIN32_Proactor.cpp:
        * ace/config-win32-common.h:
        * tests/CDR_Test.cpp:
        * tests/Cache_Map_Manager_Test.cpp:
        * tests/Collection_Test.cpp:
        * tests/DLL_Test.cpp:
        * tests/DLL_Test.h:
        * tests/DLList_Test.cpp:
        * tests/Dynamic_Priority_Test.cpp:
        * tests/Env_Value_Test.cpp:
        * tests/Handle_Set_Test.cpp:
        * tests/High_Res_Timer_Test.cpp:
        * tests/IOStream_Test.cpp:
        * tests/MT_Reactor_Timer_Test.cpp:
        * tests/Map_Manager_Test.cpp:
        * tests/Map_Test.cpp:
        * tests/Message_Queue_Test.cpp:
        * tests/Naming_Test.cpp:
        * tests/New_Fail_Test.cpp:
        * tests/Pipe_Test.cpp:
        * tests/Priority_Reactor_Test.cpp:
        * tests/Process_Mutex_Test.cpp:
        * tests/Process_Strategy_Test.cpp:
        * tests/Process_Strategy_Test.h:
        * tests/Reactor_Performance_Test.cpp:
        * tests/SOCK_Connector_Test.cpp:
        * tests/SPIPE_Test.cpp:
        * tests/SV_Shared_Memory_Test.cpp:
        * tests/Service_Config_Test.cpp:
        * tests/Thread_Manager_Test.cpp:
        * tests/Time_Service_Test.cpp:
        * tests/Tokens_Test.cpp:
        * tests/UPIPE_SAP_Test.cpp:
        * tests/Upgradable_RW_Test.cpp:
        * tests/test_config.h: Changes to make it possible to write pure
          UNICODE programs on NT.  Now it is possible to compile ACE on NT
          with ACE_HAS_MOSTLY_UNICODE_APIS defined.  Most tests passed
          without trouble.  However, Future_Set_Test is not yet included
          in the version_tests and Dynamic_Priority_Test also
          failed. Thanks to Valery Arkhangorodsky
          <valerya@servicesoft.com> for providing a preliminary patch for
          ACE to motivate the change.

Sun Jul 04 18:57:13 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE-INSTALL.html: when building tao_idl on NT to be
          used for generating code for VxWorks, build without
          ACE_HAS_EXCEPTIONS.  Otherwise, TAO_IDLFLAGS must
          be overridden to be null instead of -Ge 1.  Thanks to
          Carlos for this suggestion.

Sun Jul  4 17:06:17 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * tests/Notify_Performance_Test.cpp,
          tests/Message_Block_Test.cpp,
          tests/Priority_Task_Test.cpp,
          tests/Thread_Pool_Reactor_Test.cpp: Fixed a couple of
          warnings related to initializing char *'s with const char *'s.
          Thanks to SunC++ 5.0 for reporting this.

Sun Jul 04 16:07:33 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE-INSTALL.html: updated instructions for building on
          NT host for VxWorks.

Sun Jul 04 15:41:34 1999  David L. Levine  <levine@cs.wustl.edu>

        * many Makefiles: call ace_components via sh, instead of
          directly in the make $(shell) command.  This allows it
          to work on platforms that don't have /bin/sh, such as NT.

Sun Jul  4 12:34:24 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Timer_Hash_T.cpp (cancel): Reversed a comparison from
          <= to > to make the ACE_ASSERT replacement work properly.
          Thanks to David Levine for reporting this.

        * tests/Thread_Pool_Test.cpp (open): We need to define 'int i'
          outside of the for loop to keep EGCS from complaining for some
          reason.

        * ace/Timer_Heap_T.cpp: Reformatted this code to conform to
          the ACE programming guidelines.

        * ace/Timer_Heap_T.cpp (schedule): Replaced an ad hoc check for
          allocator failure with the ACE_ALLOCATOR_RETURN macro.

        * ace/RB_Tree.cpp: Modified Carlo's change so that we add an
          extra set of parens in a special way, rather than using a new
          macro.  This is more consistent with how we deal with this
          problem in other parts of ACE.

        * ace/RB_Tree.cpp (insert_i): Removed an unreachable statement.
          Thanks to David Levine for reporting this.

Sat Jul  3 22:12:07 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Object_Manager.cpp (get_singleton_lock):
          Fixed one of the ACE_Thread_Mutex version of this method. One of
          the braces after an if() statement got "accidentaly" removed;
          binding the "else" part of the statement to the previous if()
          instead.

Sat Jul  3 18:54:18 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/RB_Tree.cpp:
          If the "constructor" parameter in an ACE_NEW_RETURN macro has a
          comma in it (such as Foo(x,y,z)) we need to replace it with a
          macro, so it is seen as a single token by the pre-processor.
          Otherwise it (the pre-processor) gets confused and uses
          the comma as separator. Thanks to David for detecting this one.

Sat Jul  3 15:57:40 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/SOCK_Dgram_Mcast.cpp:
          Fixed error code return, it should be -1 not ACE_INVALID_HANDLE

        * ace/SOCK_Connector.cpp:
          Fixed stray comment characters.

Sat Jul 03 14:04:10 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Makefile: call ace_components via sh, and use single
          instead of double quotes, so that it works with Cygwin
          on NT host.

Sat Jul  3 12:05:46 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/SOCK_Dgram_Mcast: Modified the subscribe() method to return
          0 or -1 rather than ACE_HANDLE.  Thanks to Vidya Narayanan
          <CVN065@lmpsil02.comm.mot.com> for suggesting this.

        * ace/SOCK_Acceptor,
          ace/SOCK_Connector,
          ace/SOCK: Added the ACE_Protocol_Info *, ACE_SOCK_GROUP, and
          flags parameters to these classes so we can pass down the GQoS
          information.  Thanks to Vidya Narayanan
          <CVN065@lmpsil02.comm.mot.com> for suggesting this.

        * ace/SOCK.h: Added the reuse_addr parameter to open() and the
          ACE_SOCK constructor.

        * tests/Future_Set_Test.cpp (main): We were casting a
          const ASYS_TCHAR * to u_int, yikes!

        * ace/RB_Tree.cpp: Cleaned up the code so it's conformant with the
          ACE programming style, particularly for dynamic memory
          allocation (which wasn't using ACE_NEW).

        * ace/ACE.cpp (get_ip_interfaces): Cleaned up the code so it conforms
          to the ACE programming guidelines.

        * ace/Timer_Hash_T.cpp: Fixed a number mistakes where the return
          value of new wasn't being checked.

        * ace/Timer_Heap_T.cpp,
          ace/Timer_Wheel_T.cpp: Removed the apparently extraneous parens
          used in the ACE_NEW* macros in order to keep EGCS 2.95 happy.
          Thanks to Jody Hagins and Arturo Montes
          <mitosys@colomsat.com.co> for reporting this.  BTW, if this
          causes problems on any compilers please let me know.

        * ace: Reformatted all the ACE_NEW* macros so they conform to
          ACE programming style.

        * ace/Priority_Reactor.cpp: Cleaned up the code to conform to
          the ACE programming style.

        * ace/OS.cpp (tss_base): Cleaned up a loop a bit so it conforms
          to the ACE programming style.

Sat Jul  3 11:09:51 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * ace/WIN32_Asynch_IO.cpp
        * ace/WIN32_Proactor.cpp
          Addressed Doug's @@ Alex comments. It was simply making some
          debug statements conditional upon ACE::debug () flag.

Fri Jul  2 19:50:29 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/OS.h: There was a typo in the ACE_WIN32CALL_RETURN() macro
          for Borland C++.  Thanks to Jody Hagins <jody@atdesk.com> for
          reporting this.

        * ace/config-win32-borland.h: Clarified the fact that this file
          shouldn't be #included directly.  Thanks to Thaddeus Olczyk
          <olczyk@interaccess.com> for motivating this.

Fri Jul 02 22:22:12 1999  Steve Huston  <shuston@riverace.com>

        * ace/config-hpux-11.x-hpc++.h: Added
          ACE_HAS_STD_TEMPLATE_METHOD_SPECIALIZATION for aC++.

        * include/makeinclude/platform_hpux_aCC.GNU: Removed the suppression
          of warning 829 (auto convert of string literal to char * deprecated).
          With the exception of some JAWS code, all of ACE has been rid of the
          offenders.

        * websvcs/tests/Makefile: Replace VLDLIBS with correct LDLIBS. Now
          works on AIX.

Fri Jul  2 19:37:16 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tests/Future_Test.cpp:
          The timeout variable was declared in one scope but used in
          another one.  Added another timeout variable to keep it happy.

        * tests/Message_Queue_Test.cpp:
          A pointer was initialize using "0x" i think it was a typo and
          should be "0".

Fri Jul 02 18:28:31 1999  Steve Huston  <shuston@riverace.com>

        * ace/config-hpux11.h: Added ACE_HAS_BROKEN_T_ERROR.
          Enable threads by default, unless site config explicitly turns it
          off by setting ACE_HAS_THREADS to 0. Thanks to Brian Wallis
          <Brian.Wallis@sr.com.au> for motivating this change.

        * ace/config-hpux-11.x-hpc++.h: Added
          ACE_HAS_STD_TEMPLATE_SPECIALIZATION.

        * include/makeinclude/platform_hpux_aCC.GNU: If on 11.00 and the
          user requests a build w/o threads, set ACE_HAS_THREADS to 0 to
          override the config default (see config-hpux11.h, above).

Fri Jul  2 11:49:12 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * tests/Cached_Conn_Test.cpp: This is a test which shows how the
          Strategy Connector can automagically as well as explicitly cache
          and purge connection from its connection cache using different
          caching strategies.

        * ace/Cached_Connect_Strategy_T.{h, cpp}: Added a method
          "purge_connections ()" which allows explicit purging of
          connnections from the connection cache.

Fri Jul  2 13:54:14 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Future_Set.cpp,
          ace/Future.cpp: Added ACE_TYPENAME at a couple of places
          to make HP/UX aCC happy.  Thanks to Eric Mitchell
          <emitchell@altaira.com> for reporting this.

        * ace/SOCK_Dgram: Added send() and recv() methods that take
          ACE_OVERLAPPED structures.  Thanks to Vidya Narayanan
          <CVN065@lmpsil02.comm.mot.com> for suggesting this.

        * ace/OS.h: Added an ACE_OVERLAPPED_FLAG that's used to abstract
          away from the WSA_FLAG_OVERLAPPED macro on Win32.  Thanks to
          Vidya Narayanan <CVN065@lmpsil02.comm.mot.com> for suggesting
          this.

        * ace/OS.cpp: Removed unnecessary ';' after ACE_BEGINTHREADEX() and
          ACE_ENDTHREADEX().  Thanks to Kris Johnson
          <kjohnson@gardnersys.com> for reporting this.

        * ace/Service_Config.cpp (open_i): It appears that

          if (ACE::debug ())
            ACE_Log_Msg::disable_debug_messages ();

          should really be

          if (ACE::debug () == 0)
            ACE_Log_Msg::disable_debug_messages ();

          Thanks to Jonathan Reis <reis@minniemouse.cemax.com> for
          reporting this.

        * tests/Future_Test.cpp   (main): Make sure to use absolute time
          rather than relative time for the timeouts.  Thanks to Peter
          Brandstrom <peter.brandstrom@ericsson.com> for reporting this.

Fri Jul 02 13:44:17 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tests/Thread_Pool_Reactor_Test.cpp (worker): Added const fix to
          <msg> and <rendezvous>.

        * tests/Priority_Task_Test.cpp: Added const fix to <usage>.

        * tests/Notify_Performance_Test.cpp (print_results): Added const
          fix to <reactor_type>.

        * tests/Message_Block_Test.cpp: Added const fix to <name_>.

Fri Jul  2 11:49:12 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * Initialized some variables to zero to avoid some silly warnings
          from egcs (with exceptions):

          - ace/Free_List.cpp
          - ace/Malloc.i
          - tests/DLL_Test.cpp
          - tests/Mem_Map_Test.cpp
          - tests/Message_Queue_Test.cpp
          - tests/Reactor_Notify_Test.cpp

Fri Jul  2 11:49:12 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * ace/Strategies_T.h (ACE_Cached_Connect_Strategy): Made "virtual"
          methods which were getting overriden in the derived
          Cached_Connect_Strategy_Ex class.

        * ace/Cached_Connect_Strategy_T.{h, cpp}: Added a method
          "purge_connections ()" which allows explicit purging of
          connnections from the connection cache.

        * tests/Cached_Conn_Test.cpp: This is a test which shows how the
          Strategy Connector can automagically as well as explicitly cache
          and purge connection from its connection cache using different
          caching strategies.

Fri Jul  2 11:49:12 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * tests/Cached_Conn_Test.cpp: This is a test which shows how the
          Strategy Connector can automagically as well as explicitly cache
          and purge connection from its connection cache using different
          caching strategies.

        * ace/Cached_Connect_Strategy_T.{h, cpp}: Added a method
          "purge_connections ()" which allows explicit purging of
          connnections from the connection cache.

Fri Jul 02 11:50:21 1999  Steve Huston  <shuston@riverace.com>

        * ace/ace_lib.dsp: Added Pharlap ETS configurations for Debug and
          Release.

        * ace/config-pharlap.h: Added ACE_LACKS_* definitions to avoid some
          unimplemented memory mapped things. Added a definition for
          ACE_PAGE_SIZE because it's not obvious how to get it at run time.
          Include <embkern.h> because some of the OS functions call ETS
          kernel functions for low-level system info gathering.
          Set ACE_HAS_TSS_EMULATION. The PharLap TSS leaves some to be
          desired, according to TSS_Test.

        * ace/config-win32-common.h: In building for PharLap, don't bring in
          the OS-supplied wsock32.lib - need to use the PharLap one.

        * ace/ACE.cpp: PharLap ETS changes:
          ACE::ldfind: PharLap doesn't have expand environment strings.
          ACE::get_ip_interfaces: Use PharLap kernel functions to find
             interfaces and learn their addresses.
          ACE::terminate_process: Unsupported on PharLap.
          ACE::handle_timed_open: If the open times out, set errno to
             ETIMEDOUT, not ETIME.
          ACE::handle_timed_accept: If the select times out, set errno to
             ETIMEDOUT, not ETIME.
          ACE::sock_error: If not a known error, format a message with the
             error number in it - this is the only chance for a PharLap
             system error to indicate the error number.

        * ace/OS.h: Changed def of ACE_DEFAULT_SERVER_HOST to ACE_LOCALHOST.

        * ace/OS.cpp (ACE_OS::uname): PharLap: Use ETS kernel functions to get
          target processor class. PharLap doesn't do GetSystemInfo.

        * ace/OS.i (ACE_OS::hostname): PharLap: Attempt gethostname if using
          RT version, though this isn't too reliable (requires ethernet and
          BOOTP).
          (ACE_OS::dlerror): PharLap doesn't support FormatMessage,
          so format the error number.
          (ACE_OS::mmap, ACE_OS::mprotect, ACE_OS::msync): PharLap doesn't
          do memory-mapped files.
          (ACE_OS::getpagesize): PharLap - use page size set from config.h.
          Don't know a way to get this info at run time.
          (ACE_OS::hostname (whar_t *, size_t)): PharLap - no wide chars.

        * ace/Log_Msg.cpp (log): PharLap doesn't do FormatMessage, so print
          <unknown error> = %d for %p.

        * ace/Pipe.cpp (open): The protocol level for TCP_NODELAY on PharLap
          is SOL_SOCKET, as opposed to Win32, where it's IPPROTO_TCP.

        * ace/SPIPE_Connector.cpp (connect): PharLap doesn't have the
          SetNamedPipeHandleState function.

        * ace/WFMO_Reactor.cpp: PharLap ETS changes, because PharLap doesn't
          implement async I/O, or WaitForMultipleObjectsEx.
          register_handler_i: (This is a general Winsock 1.1 change) Creating
              an event handle for a socket is not supported.
          ok_to_wait, wait_for_multiple_events: Use WaitForMultipleObjects,
              not WaitForMultipleObjectsEx. Should be fine since the big
              difference is alertable, and that's not supported on ETS anyway.

        * tests/test_config.h: On PharLap, direct all logging to host console.

        * tests/tests_pharlap_msvc.lnk: Cleaned things up; extended stack size
          from 8K to 32K. Change the starting load offset to
          0x100000 - the tests don't all fit in the default range.
          Disabled the target screen driver to make all the test output from
          all threads go to the host, thereby getting saved in the log files.

        * tests/run_pharlap_tests.bat: Fixed names of the executables.

        * tests/Atomic_Op_Test.dsp:
        * tests/Barrier_Test.dsp:
        * tests/Basic_Types_Test.dsp:
        * tests/Buffer_Stream_Test.dsp:
        * tests/CDR_Test_Test.dsp:
        * tests/Collection_Test.dsp:
        * tests/Conn_Test.dsp:
        * tests/DLList_Test.dsp:
        * tests/Dynamic_Priority_Test.dsp:
        * tests/Enum_Interfaces_Test.dsp:
        * tests/Env_Value_Test.dsp:
        * tests/Future_Test.dsp:
        * tests/Handle_Set_Test.dsp:
        * tests/Hash_Map_Manager_Test.dsp:
        * tests/High_Res_Timer_Test.dsp:
        * tests/IOStream_Test.dsp:
        * tests/Map_Manager_Test.dsp:
        * tests/Map_Test.dsp:
        * tests/Mem_Map_Test.dsp:
        * tests/Message_Block_Test.dsp:
        * tests/Message_Queue_Notifications_Test.dsp:
        * tests/Message_Queue_Test.dsp:
        * tests/MM_Shared_Memory_Test.dsp:
        * tests/MT_Reactor_Timer_Test.dsp:
        * tests/MT_SOCK_Test.dsp:
        * tests/Naming_Test.dsp:
        * tests/New_Fail_Test.dsp:
        * tests/Notify_Performance_Test.dsp:
        * tests/OrdMultiSet_Test.dsp:
        * tests/Pipe_Test.dsp:
        * tests/Priority_Buffer_Test.dsp:
        * tests/Priority_Reactor_Test.dsp:
        * tests/Priority_Task_Test.dsp:
        * tests/Process_Mutex_Test.dsp:
        * tests/Process_Strategy_Test.dsp:
        * tests/RB_Tree_Test.dsp:
        * tests/Reactor_Exceptions_Test.dsp:
        * tests/Reactor_Notify_Test.dsp:
        * tests/Reactor_Performance_Test.dsp:
        * tests/Reactor_Timer_Test.dsp:
        * tests/Reactors_Test.dsp:
        * tests/Reader_Writer_Test.dsp:
        * tests/Recursive_Mutex_Test.dsp:
        * tests/Reverse_Lock_Test.dsp:
        * tests/Semaphore_Test.dsp:
        * tests/Service_Config_Test.dsp:
        * tests/Sigset_Ops_Test.dsp:
        * tests/Simple_Message_Block_Test.dsp:
        * tests/SOCK_Connector_Test.dsp:
        * tests/SOCK_Send_Recv_Test.dsp:
        * tests/SOCK_Test.dsp:
        * tests/SPIPE_Test.dsp:
        * tests/SString_Test.dsp:
        * tests/SV_Shared_Memory_Test.dsp:
        * tests/Svc_Handler_Test.dsp:
        * tests/Task_Test.dsp:
        * tests/Thread_Manager_Test.dsp:
        * tests/Thread_Mutex_Test.dsp:
        * tests/Thread_Pool_Reactor_Test.dsp:
        * tests/Thread_Pool_Test.dsp:
        * tests/Time_Service_Test.dsp:
        * tests/Time_Value_Test.dsp:
        * tests/Timeprobe_Test.dsp:
        * tests/Timer_Queue_Test.dsp:
        * tests/Tokens_Test.dsp:
        * tests/TSS_Test.dsp:
        * tests/Upgradeable_RW_Test.dsp:
        * tests/UPIPE_SAP_Test.dsp:
          Fixed settings for PharLap ETS configurations.

        * tests/Conn_Test.cpp (server): If the acceptor fails, do not try to
          close the svc_handler - the failed ACE_Oneshot_Acceptor already
          closed it.

        * tests/SOCK_Send_Recv_Test.cpp: Use ACE_LOCALHOST, not "localhost".

Thu Jul  1 21:49:39 1999  Matthew J Braun  <mjb2@cs.wustl.edu>

        * ace/Containers_T.i,h,cpp
          Added reset () methods to the derived classes of
          ACE_Double_Linked_List_Iterator because the behavior of the base
          class's version was not sufficient (and would cause way fun
          segfaults when used).

        * tests/Map_Manager_Test.cpp
        * tests/DLList_Test.cpp
          ACE_const_cast'ed some string literals to char *'s to appease
          the evil monstrosity that is SC 5.0.

Wed Jun 30 18:11:41 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/OS.i (strncasecmp):

          Corrected ACE_TRACE statement to contain "strncasecmp" instead
          of "strcasecmp."

Thu Jul 01 21:07:22 1999  Douglas C. Schmidt  <schmidt@cs.wustl.edu>

        * ACE version 4.6.43 released.

Thu Jul 01 10:53:33 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_vxworks5.x_ghs.GNU:
          set INCLDIRS, so that wrapper_macros.GNU doesn't insert -I.
          Otherwise, with GHS on NT host, ACE's Signal.h gets #included
          instead of VxWorks' signal.h by target/h/private/sigLibP.h.
          Thanks to Dale Wood <dale_wood@Mitel.com> and
          Dave Steele <Dave_Steele@Mitel.COM> for helping to figure
          this out.

        * include/makeinclude/platform_vxworks5.x_g++.GNU,
          bin/ace_ld: changed -c option to -C [...] --, so
          that its arguments don't need to be quoted.  I
          couldn't figure out a way to quote on NT host.  Thanks
          to Dale Wood <dale_wood@Mitel.com> for enlightening me
          on some of the intricacies of NT.

Thu Jul 01 10:47:41 1999  David L. Levine  <levine@cs.wustl.edu>

        * bin/libsize.pl: always use `pwd`, because the PWD environment
          variable doesn't appear to get updated by recursive makes.

Thu Jul 01 08:46:10 1999  David L. Levine  <levine@cs.wustl.edu>

        * bin/check_build_logs: filter out lines from IDL_Cubit
          that contain "0 errors".

Thu Jul 01 00:24:52 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * docs/ACE-guidelines.html: Added a table explaining how to use
          all the different ACE_*_STRING macros.

        * tests/DLList_Test.cpp:
        * tests/Hash_Map_Manager_Test.cpp:
        * tests/Map_Manager_Test.cpp:
        * tests/Message_Block_Test.cpp:
        * tests/Notify_Performance_Test.cpp:
        * tests/Priority_Task_Test.cpp:
        * tests/Thread_Pool_Reactor_Test.cpp:
        * tests/test_config.h: UNICODE fixes.  The usage of ASYS_TCHAR and
          LPCTSTR were mistaken in many places.

Wed Jun 30 16:13:58 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tests/Future_Set_Test.cpp: Added missing template instantiation
          for ACE_Hash_Map_Reverse_Iterator_Ex.  Also, added some fixes
          from John Tucker <jtucker@infoglide.com>.

Wed Jun 30 12:09:22 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/ace_bcc.ide:
        * tests/tests_bcc.ide:
        * *.{bpr,bpg}: Removed unused BCB project files.

Tue Jun 29 23:12:58 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/OS.i:
          Use ACE_CAST_CONST to keep the silly Sun/CC 4.2 from
          complaining.

Tue Jun 29 22:48:43 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/OS.i (strncasecmp): Changed <n> to <len>.

Tue Jun 29 22:33:55 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/OS.i:
          Fixed warnings in green hills and possibly othre EDG-based
          compilers.

        * tests/run_tests.sh:
        * tests/run_tests.vxworks:
          Take Future_Set_Test out, it does not work in too many
          platforms.

Tue Jun 29 21:24:13 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/SOCK.cpp (open): Removed an unused variable.  Thanks
          to Carlos for reporting this.

Tue Jun 29 20:53:41 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/config-irix5.3-g++.h:
          IRIX 5.3 (!) has a DIRENT structure, thanks to Isaac Stoddard
          <i_stoddard@hso.link.com> for providing this fix.

Tue Jun 28 20:19:11 1999  Darrell Brunsch  <brunsch@cs.wustl.edu>

        * ace/ace_dll.dsp:
        * ace/ace_lib.dsp:
          Manually cleaned up these projects and fixed them so they should
          work on NT Alpha again.

Tue Jun 29 18:48:22 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Functor_T.h (class ACE_Pointer_Hash): Added new class for
          hashing pointers on their values.

        * ace/Future_Set: Restored future map to be a
          ACE_Hash_Map_Manager_Ex.

Tue Jun 29 14:45:38 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tests/run_tests.bat: Removed New_Fail_Test from the
          run_tests.bat (the script for NT).  This tests takes too long to
          run and swaps out the entire machine making is impossible to do
          useful things while the test is running.  Note that the test is
          still there and can be run by hand (i.e., on its own, without
          the run_tests.bat script).

        * ace/Future: Changed the observer collection to be an unbounded
          set and changed the future map to map manager.  These are
          temporary changes to get things compiling again.  Once we figure
          out the correct hashing functions, we can restore the original
          code.

Tue Jun 29 13:38:52 1999  Ossama Othman  <othman@cs.wustl.edu>

        * AUTHORS:

          Added an AUTHORS file to bring ACE closer to recent software
          distribution conventions.

        * Makefile:

          Added Carlos' websvcs directory to the release, in addition to
          the missing top-level ACE Configuration project files and
          directories.

        * config.guess:
        * config.sub:
        * ltconfig:
        * ltmain.sh:
        * missing:
        * mkinstalldirs:

          Updated from latest GNU libtool and GNU automake.

Tue Jun 29 12:07:08 1999  Ossama Othman  <othman@cs.wustl.edu>

        * README:
        * THANKS:

          Moved list of contributors to the file `THANKS' to bring the
          distribution closer to conventional distribution standards.

        * Makefile:

          Added the THANKS file to the list of controlled files so that it
          gets distributed with ACE.

Tue Jun 29 11:27:23 1999  Matthew J Braun  <mjb2@cs.wustl.edu>

        * ace/Containers_T.i: Modified next method in ACE_DLList_Iterator
          to avoid segfaults (a bad thing).

Tue Jun 29 10:54:15 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/OS.i:
          Sun/CC was not pleased with a cast from "void* const" to "const
          char*", and rightly so.

Tue Jun 29 09:21:06 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/OS.h:
        * ace/OS.i:
        * ace/SOCK_Dgram.h:
        * ace/SOCK_Dgram.i:
          Fixed the unix version ACE_OS::sendto() call.
          Also fixed the Win32 version and the Win32 version of
          ACE_OS::recvfrom, had to change the signatures to make them safe
          and fit the WinSock2 interfaces.

Tue Jun 29 07:07:30 1999  David L. Levine  <levine@cs.wustl.edu>

        * bin/check_build_logs: allow _ with -l and -m options, and
          @ and . with -m option.

Mon Jun 28 21:31:58 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/OS: Added a constructor to ACE_Flow_Spec to initialize
          its various fields wholesale.  Thanks to Kumar Surender
          <csk037@lmpsil02.comm.mot.com> for this suggestion.

        * ace/SOCK: Added a new constructor and a new open() method
          that pass through the QoS information required by WSASocket().

        * ace/{OS,SOCK_Connector,SOCK_Dgram,SOCK_Dgram_Mcast}: Renamed
          ACE_Connect_QoS_Params to ACE_QoS_Params since (1) it's used in
          ACE_OS::connect() *and* ACE_OS::join_leaf() and (2) it's used
          for Dgrams, which aren't connection oriented.  Thanks to Kumar
          Surender <csk037@lmpsil02.comm.mot.com> for this suggestion.

        * ace/OS: Added set/get methods for time-to-live on the
          ACE_Flow_Spec classes.  This is necessary since RAPI defines
          this.

        * ace/OS: Added a new ACE_OS::recvfrom() method that's a wrapper
          for the WSARecvFrom() on Win32 and (will be) an "emulation" on
          non-Win32 platforms.

        * ace/OS: Added a new ACE_OS::sendto() method that's a wrapper
          for the WSASendTo() on Win32 and an "emulation" on non-Win32
          platforms.

        * ace/OS.h: Updated the QoS documentation to clarify that these
          features are appropriate for IntServ (RSVP) *and* DiffServ.
          Thanks to Kumar Surender <csk037@lmpsil02.comm.mot.com>, Vidya
          Narayanan <CVN065@lmpsil02.comm.mot.com> and Pradeep Avasthi
          <Pradeep.Avasthi@motorola.com> suggesting this.

        * ace/SOCK_Dgram.h: Added send() and recv() methods for
          ACE_SOCK_Dgram that take overlapped I/O parameters.  This is
          needed for the GQoS WinSock API.

Mon Jun 28 21:53:06 1999  David L. Levine  <levine@cs.wustl.edu>

        * bin/libsize.pl: added support for liborbsvcs, and
          for shared libs (with -s option).

        * bin/check_build_logs: fixed command-line argument processing.

Mon Jun 28 17:30:08 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/OS.i (recvv): We must not passed a null pointer to <flags>
          but a pointer pointing to a real flag.  This fixed the
          SOCK_Send_Recv_Test failing on NT problem.  Thanks to Jody
          Hagins <jody@atdesk.com> for reporting this.

Mon Jun 28 15:10:50 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Strategies_T: Removed ACE_Hash_Addr which was no longer used
          in ACE and is not necessary given the new
          ACE_Hash_Map_Manager_Ex class.

Mon Jun 28 15:00:01 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/CDR_Stream.h:
        * ace/CDR_Stream.cpp:
          Added new method to reset the state of a CDR stream without need
          for any memory allocations.

Mon Jun 28 12:48:35 1999  David L. Levine  <levine@cs.wustl.edu>

        * bin/check_build_logs: added this script, which checks build
          logs named *.log, of current day.

Mon Jun 28 09:32:59 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/{Future_Set,Future}: Integrated new enhancements to use
          the ACE_Hash_Map_Manager rather than the ACE_DLL_Linked_List to
          speed up notifications for the Future Set.  Thanks to John
          Tucker <jtucker@infoglide.com> for this enhancement.

        * tests: Integrated the Future_Set_Test into this directory and the
          various batch files.  Thanks to John Tucker
          <jtucker@infoglide.com> for this test.

        * ace/Map_Manager.i: Added an ACE_const_cast to the lock_ used
          in the newly const total_size() and current_size() methods.

        * ace/Map_T,
        * ace/Map_Manager,
        * ace/Cache_Map_Manager_T,
        * ace/Active_Map_Manager_T,
        * ace/Hash_Map_Manager_T: The current_size() and total_size() methods
          must be const.

        * ace/OS.i: Fixed a type inconsistency where wchar_t should have been
          char and added a missing ';'.

        * ace/OS.i: Fixed a typo where last_error should have been
          lerror.  Thanks to Chris Gill for reporting this.

        * ace/OS.cpp (ACE_BEGINTHREADEX): Oops, mistyped "_beginthreadex()"
          as "_beingthreadex()".  I must be going through an existential
          phase ;-).  Thanks to Chris Gill for reporting this.

        * ace/OS.i: Fixed a typo where last_error should have been
          lerror.  Thanks to Chris Gill for reporting this.

        * ace/OS.cpp (ACE_BEGINTHREADEX): Oops, mistyped "_beginthreadex()"
          as "_beingthreadex()".  I must be going through an existential
          phase ;-).  Thanks to Chris Gill for reporting this.

Sun Jun 27 18:03:24 1999  Douglas C. Schmidt  <schmidt@danzon.cs.wustl.edu>

        * ACE-INSTALL.html: Updated the discussion for Borland C++
          Building 4.0 and IBM's VisualAge C++ compiler to reference the
          appropriate maintainers.

        * ace/WIN32_Proactor.cpp, ace/WIN32_Asynch_IO.cpp: Added back some
          initializers to keep EGCS happy.

        * ace/config-g++-common.h: Added ACE_LACKS_AUTO_PTR to work around
          an omission within the EGCS standard library.

        * ace/Auto_Ptr.h: If ACE_LACKS_AUTO_PTR is enabled then use our
          version of auto_ptr.  This is necessary to work around problems
          with EGCS.

        * ace/config-g++-common.h: Define ACE_HAS_STANDARD_CPP_LIBRARY so
          that #include <exception> will work properly.  However, this
          required that we also set ACE_USES_OLD_IOSTREAMS, as well.
          Thanks to Carlos for help with this.

        * ace/config-g++-common.h: The EGCS 1.1.1 compiler supports the
          template<> syntax.  If this breaks older EGCS or GCC compilers
          we'll have to handle each of those cases.

        * ace/config-win32-borland.h:
          Added ACE_HAS_STD_TEMPLATE_METHOD_SPECIALIZATION.

        * ace/OS.h: Replaced the const's for ACE_DEFAULT_SHLIB_MODE and
          ACE_SHLIB_INVALID_HANDLE with #defines since it's more portable.

        * ace/OS.i: All the strcasecmp() and strncasecmp() methods were
          broken.  Thanks to David Levine for reporting this.

        * ace/WFMO_Reactor.cpp: Updated the programming style a bit to
          conform to the ACE guidelines.

Sun Jun 27 20:50:02 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        Added support for IBM's VisualAge C++ compiler.

        * ace: Added a new config-visualage.h file that automatically
          includes the proper configurations for IBM's VisualAge C++
          compiler on Win32 and AIX.

        * ace/OS.i: The IBM VisualAge C++ compiler's prototypes for _chdir(),
          _mkdir(), and _tempnam() are broken, so we must add a cast to
          char *.

        * ace/OS.cpp: Added new macros ACE_ENDTHREADEX and
          ACE_BEGINTHREADEX to work around a bugs with _endthreadex() and
          _beginthreadex() on IBM's VisualAge C++ compiler.

        * ace/OS.cpp (ACE_Time_Value::set): Replaced this expression:

          this->tv_.tv_usec = long ((_100ns.QuadPart % (10000 * 1000)) / 10);

          with this expression:

          this->tv_.tv_usec = long ((long (_100ns.QuadPart) % long (10000 * 1000)) / 10);

          to work around a bug with IBM's VisualAge C++ compiler.

        * ace/OS.cpp: Replaced a hard-coded MSVC++'ism for signed long long
          with a use of the ACE_UINT64_LITERAL macro, which works for all
          Win32 C++ compilers.

        * ace/config-win32-visualage.h,
          ace/config-aix-4.x.h: Added a workaround for an IBM VisualAge
          C++ bug with the WIFEXITED and WEXITSTATUS macro.

        * ace/OS.h: Added workarounds for bugs with IBM's VisualAge C++ compiler
          as it pertains to the ACE_DES_FREE_TEMPLATE and
          ACE_DES_FREE_TEMPLATE2 macros.

        * ace/Map_T.h: Added a workaround for a bug with IBM's VisualAge C++
          compiler.  I think this workaround should help with other C++
          compilers, as well.  Also reformated the code to make it
          consistent with the ACE programming guidelines.

        * ace/Hash_Purgable_Map_Manager_T.cpp: Added a workaround for a
          VisualAge C++ bug.

        * ace/config-aix-4.x.h: Added VisualAge C++ compiler support.

        * ace/Timer_Heap_T.cpp: We must hard code numbers like
          1024 for an array size to workaround bugs with the IBM VisualAge
          C++ compiler.

        * ace/Basic_Types.h: Added #defines for ACE_INT64_LITERAL.

        * ace/config-win32-common.h: #include the
          config-win32-visualage.h file.

        * ace: Added the following files for the IBM VisualAge C++ compiler:

          ace-lib.icc - WinNT configuration file to create a static library
          ace-dll.icc - WinNT configuration file to create a dynamic library
          config-win32-visualage.h  - VisualAge C++ defines

        * tests: Added the icc.bat and makeicc.pl files, which build the
          tests for the IBM VisualAge C++ compiler.

        * tests: Added the *.icc project files for the IBM VisualAge C++ compiler.

Sun Jun 27 18:17:43 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/CORBA_macros.h:
          On platforms with native C++ exceptions we use ACE_UNUSED_ARG()
          in the throw macros to avoid warnings about the unused
          ACE_TRY_ENV variable.

Sun Jun 27 14:56:16 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tests/run_tests.bat: Added the patch for running tests compiled
          with Borland C++.  Thanks to Jody Hagins <jody@atdesk.com> for
          the patch.

        * tests/Cache_Map_Manager_Test.dsp: The project file was
          mis-configured.

        * tests/version_tests/version_tests.dsw:
        * tests/version_tests/Cache_Map_Manager_Test.dsp: Added this new
          project file.

Sun Jun 27 12:36:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * ace/RB_Tree.{h, i}: Moved non-deprecated iterator base class
          method next (RB_Tree_Node<...>) down into derived forward and
          reverse iterator classes due to method resolution conflict
          with deprecated next (void) method in forward iterator class.
          When the deprecated next method is removed, these will be
          moved out of the derived classes and into the base class.
          Thanks to Matt Braun and Carlos O'Ryan for pointing out
          this problem.

Sat Jun 26 16:22:07 1999  Marina Spivak  <marina@cs.wustl.edu>

        * ace/ace_lib.dsp
        * ace/ace_dll.dsp:
          Updated to include Hash_Map_With_Allocator_T.* files.

Sat Jun 26 16:05:29 1999  Ossama Othman  <othman@cs.wustl.edu>

        * acconfig.h:
        * configure.in:

          Added support/test for ACE_HAS_MEMCHR macro.

        * ace/Makefile.am:
        * tests/Makefile.am:

          Synchronized with latest version of ACE.

        * m4/features.m4:

          Updated asynchronous IO tests.

Sat Jun 26 14:41:31 1999  Marina Spivak  <marina@cs.wustl.edu>

        * ace/Event_Handler_T.h
          Removed "ACE_Export" - it is not necessary for a template class.

        * ace/Hash_Map_With_Allocator.{h,i,cpp}:
          Added these files to ACE.  These files contain a thin wrapper
          around ACE_Hash_Map_Manager, which is useful when
          ACE_Hash_Map_Manager is used with a shared memory (or memory
          mapped file) allocator (e.g., ACE Naming Service, and TAO Naming
          Service are example use cases).  Please see header file for more
          details.

Sat Jun 26 12:45:26 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * tests/Cache_Map_Manager_Test.cpp: Fixed this test so that it
          compiles with SunC++ 4.2 and its broken C++ templates...  Thanks
          to David Levine for reporting this.

        * ace/Malloc_T.i: Make sure to put ACE_INLINE on all the methods
          in the .i files.  Thank to Marina for reporting this.

        * ace/Hash_Map_Manager_T.h: Fixed the programming style a bit.

        * ace/Arg_Shifter.cpp (ACE_Arg_Shifter): Reformatted this
          stuff a bit.

Sat Jun 26 12:45:26 1999  Jody Hagins <jody@atdesk.com>

        This is a change log for the modifications made to support
        Borland C++Builder 4.0, Patch 1.  Thanks to
        Christopher Kohlhoff <chris@kohlhoff.com> and Chris Uzdavinis
        <chris@uzdavinis.com> for helping with this.

        First, I did not get integrate the makefiles to the BCB environment
        as it requires alot of tools and more time.  I hope to fet to this
        in the somewhat near future.  However, each directory that has stuff
        that I built and tested has a Makefile.bor, which will make whatever
        is there with BCB4.  Note that the makefiles do not, at present,
        have a clean or anything except the default make.

        To build, make sure config.h points to, or simply includes
        ace/config-win32.h.

        Finally, not all the programs and exampales have BCB makefiles.
        However, it should not be too difficult to adapt the ones that are
        there.  In addition, the .bpr files should NOT be used to build
        the libraries, or any examples.  If you want to build examples,
        you will need to start with a fresh project in BCB.

        At present (4.6.42) all tests, except SOCK_Send_Recv_Test run
        successfully, and some of my own tests run.  Also, the TAO services
        and programs seem to be operating as well.

        * ace/Asynch_Acceptor.cpp: Need CancelIO for BCB as well

        * ace/Atomic_Op.i: Need ACE_TEMPLATE_SPECIALIZE on specializations.

        * ace/CDR_Stream.h: Need LongLong for BCB as well

        * ace/Functor.i: Need ACE_TEMPLATE_SPECIALIZE on specializations.

        * ace/Future.h: Work around a BCB4 bug which causes the create()
          method from being seen.

        * ace/IOStream.h: Only want CString stuff for MSC.

        * ace/IOStream_T.cpp: Only want CString stuff for MSC.

        * ace/OS.cpp: _fdopen, in BCB, takes a non-const pointer

        * ace/OS.h: Differentiate between mode masks and user mode masks.

          BCB doesn't like initialized data in precompiled header files so
          define certain constants instead.  A bug in BCB prevents calling
          a destructor explicitly on a typedef declared inside a class.
          So, TEMPLATE3 and TEMPLATE4 versions of ACE_DES_FREE are
          necessary for destruction of templates with more parameters.

          BCB4 has a bug in the RTL that resets the GetLastError() value
          to zero when errno is accessed.  Thus, setting errno to
          ::GetLastError requires a copy.  To keep from having the code
          everywhere, I added ACE_OS::set_errno_to_last_error () and
          ACE_OS::set_errno_to_wsa_last_error (), and used it everywhere
          errno was being set to GetLastError() or WSAGetLastError().

          BCB4 has a bug in the optimizer that screws up the return from
          certain expressions when a variable is set on both sides of an
          assignment.  Thus, the definition of ACE_WIN32CALL_RETURN needed
          to change.

        * ace/OS.i: Use ACE_set_errno_to_last_error where appropriate.
          BCB4 bug requires splitting FILETIME dummy_1, dummy_2; into
          separate declarations.

        * ace/Select_Reactor.h: Need ACE_TEMPLATE_SPECIALIZE on
          specializations.

        * ace/WFMO_Reactor.cpp: Use ACE_set_errno_to_last_error where
          appropriate.  Likewise, fix the use of auto_ptr copy ctor, which
          can not take a const ref.

        * ace/WIN32_Asynch_IO.cpp: Use ACE_set_errno_to_last_error
          where appropriate.  Need CancelIo for BCB as well.

        * ace/WIN32_Proactor.cpp: Use ACE_set_errno_to_last_error
          where appropriate.

        * ace/config-win32-borland.h: Specific build stuff for BCB

        * ace/config-win32-common.h: Differences between BCB and MSC

        * apps/JAWS/PROTOTYPE/JAWS/Cache_Hash_T.cpp: BCB4 bug prevents
          using typedef inside class for explicit dextructor.

        * apps/JAWS/PROTOTYPE/JAWS/Cache_List_T.cpp:
          BCB4 bug prevents using typedef inside class for explicit
          dextructor.

        * apps/JAWS/PROTOTYPE/JAWS/Cache_Manager_T.cpp: BCB4 bug prevents
          using typedef inside class for explicit dextructor.

        * apps/JAWS/PROTOTYPE/JAWS/IO.cpp: Get rid of const warning

        * tests/DLL_Test.cpp: The get_hello function has calling
          convention __cdecl (by default since the calling convention is
          not mentioned).  However, BCB decorates __cdecl with a leading
          underscore (and doesn't decorate __stdcall). Thus, we needed to
          add some decoration to find the function.  Also, added prefix to
          find the executable.

        * tests/Message_Queue_Test.cpp: BCB4 defines a "messages" and by
          default sucks that namespace into the global namespace, so a new
          variable name was needed.

        * tests/Reactor_Exceptions_Test.cpp: The test throws a structured
          exception.  The ISO does not require non C++ exceptions to be
          caught by catch (...).  MSVC catches it but BCB4 does not.  So,
          the code needed to be changed to catch a structured exception as
          well.

        * tests/run_tests.bat: Changed to allow running the BCB tests,
          when in another directory.

Sat Jun 26 08:40:01 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Proactor.cpp: fixed template instantiation pragmas
          (to match explicit template instantiation directives).

Sat Jun 26 08:21:52 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Signal.h: reordered #includes to avoid warning about
          #pragma once.

Fri Jun 25 22:30:24 1999  David L. Levine  <levine@cs.wustl.edu>

        * docs/ACE-guidelines.html: always test on egcs before
          commiting.  It catches real problems that are missed
          by some of the other compilers we (well, some of us :-)
          use.

Fri Jun 25 22:20:16 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Future.cpp (detach): changed equality comparison of
          curr_observer from itself to the observer argument.
          Thanks to egcs -W for snagging this.

Fri Jun 25 21:46:46 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.h,ace/Signal.h,ace/config-psos-tm.h
          (ACE_DONT_INCLUDE_ACE_SIGNAL_H): added this interlock
          diagnostic to inform the user when ace/Signal.h gets #included
          instead of signal.h.  Thanks to Dale Wood <Dale_Wood@Mitel.com>
          and Timothy Canham <Timothy.Canham@jpl.nasa.gov> for tripping
          over it, on the same day, and reporting it.

Fri Jun 25 17:22:02 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/Select_Reactor_T.cpp (close): Don't call close() on the
          <notify_handler_> if there isn't one.

        * ace/SOCK_Acceptor.cpp (open): The error status was not set
          correctly if listen() failed.

        Thanks to Irfan for helping with this.

Fri Jun 25 16:48:17 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.h: don't #include <signal.h> directly on VxWorks.
          When cross-compiling on NT host, the GreenHills compiler
          #includes ace's Signal.h instead of VxWorks' signal.h.
          No comment.  OS.h doesn't need to #include signal.h directly,
          because it gets indirectly #included through sigLib.h.  Thanks
          to Dale Wood <Dale_Wood@Mitel.com> for reporting this.

Fri Jun 25 16:03:59 1999  Douglas C. Schmidt  <schmidt@ace.cs.wustl.edu>

        * ace/Future.cpp: Fixed a couple of places where the set() method
          didn't have the new *this parameter added.

        * ace: Added Future_Set.{h,cpp} and Future_Node.{h,cpp}, as well
          as the new Future.{h,cpp} files to the ACE release.  Thanks to
          John Tucker <jtucker@infoglide.com> for contributing these.

        * ace/Synch.h: Added a comment pointing out that Solaris
          threads do not support timed acquire().  Thanks to Darren
          DeRidder <darren.deridder@bridgewatersys.com> for reporting
          this.

Fri Jun 25 15:07:00 1999  John Tucker <jtucker@infoglide.com>

        The following describes the changes to ACE_Future_Set:

        * I followed the Observer Pattern where the ACE_Future_Set is the
          "Observer" and the ACE_Future_Rep is the "Subject".

        * I created an abstract base class called ACE_Future_Observer<T>
          which contains a single pure virtual member function "update()".

        * The ACE_Future_Rep is modified so that it contains a list of
          ACE_Future_Observer<T> pointers and an interface for attaching
          and detaching ACE_Future_Observer<T> Observer objects.  The
          "attach(...)" member function allows objects which implement the
          ACE_Future_Observer<T> interface to attach themselves to
          ACE_Future_Rep<T> objects so that they will be notified of
          changes to the ACE_Future_Rep<T> Subject.  The "detach(...)"
          member function allows objects which implement the
          ACE_Future_Observer<T> interface to detach themselves from
          ACE_Future_Rep<T> objects so that they will no longer be
          notified of changes to the ACE_Future_Rep<T> Subject.

        * The ACE_Future_Rep::set() method is modified so that it invokes the
          "update()" method of each ACE_Future_Observer<T> object stored
          in its list of attached ACE_Future_Observer<T> Observer
          objects. It also removes each ACE_Future_Observer<T> Observer
          object from its list.

        * The ACE_Future_Set<T> class derives from the ACE_Future_Observer<T>
          class.

        * The ACE_Future_Set<T> class contains its own ACE_Message_Queue
          attribute which will be used by writer threads to notify reader
          threads that an ACE_Future is readable.

        * The ACE_Future_Set<T> class contains a list of ACE_Future<T>
          Subject objects which clients in the reader threads insert into
          it.  When an ACE_Future<T> is inserted into an
          ACE_Future_Set<T>, the ACE_Future_Set<T> attaches itself to the
          specified ACE_Future<T>, keeping in mind the ACE_Future_Set<T>
          implements the ACE_Future_Observer<T> interface, and also
          inserts the specified ACE_Future<T> object into its list of
          ACE_Future<T> objects.

        * The ACE_Future_Set<T> class implements its "update()" method to
          just enqueue an ACE_Message_Block with Null data onto its
          ACE_Message_Queue.  Since this "ACE_Future_Set<T>::update()"
          method will be invoked by the ACE_Future_Rep::set() method in
          the writer thread, it will allow the ACE_Future_Set<T> in the
          writer thread to signal itself that an ACE_Future has become
          readable.

        * The "int ACE_Future_Set<T>::next_readable(ACE_Future<T> &future,
          ACE_Time_Value *)" method in the reader thread will block via a
          call to "dequeue()" on its ACE_Message_Queue until is awakened
          by a call to "ACE_Future_Set<T>::update()" in the writer thread.
          Once awakened, the ACE_Future_Set<T> object iterates through its
          list of ACE_Future<T> objects until it encounters a readable
          one.  This readable ACE_Future<T> will be removed from its list
          and assigned to the specified "future" parameter".

        * The ACE_Future_Set<T> destructor detaches itself from all
          ACE_Future<T> objects remaining in its list.

        * I did not use the ACE_Reactor since I could foresee the
          ACE_Future_Set being used by applications which did not run,or
          want to run, the event loop.

Fri Jun 25 14:28:05 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/UNIX_Addr.cpp (ACE_UNIX_Addr): Moved base_set() call in
          constructor to member initializer list.  This is cleaner coding
          style.  The original code, before a bug fix was made, was like
          that.  I just forgot to put it back in the member initializer
          list after the fix.

Fri Jun 25 15:15:32 1999  Steve Huston  <shuston@riverace.com>

        * performance-tests/Misc/Makefile: set static_libs_only so the library
          selection gets done right on AIX. Clean out the tempinc dir
          between binaries on AIX.

        * performance-tests/Misc/test_singleton.cpp: Moved def of DC_Singleton
          to new file, test_singleton.h so it works on AIX w/ xlC.

        * ace/Hash_Cache_Map_Manager_T.h: Removed the "ace/" from the
          #pragma implementation line. The compiler remembers the directory
          it came from.

        * examples/ASX/UPIPE_Event_Server/Peer_Router.h:
        * examples/Connection/non_blocking/CPP-connector.h:
        * examples/Connection/non_blocking/CPP-acceptor.h:
          Added #pragma implementation, for AIX IBM C++.

        * examples/IPC_SAP/SOCK_SAP/CPP-inclient.cpp:
        * examples/IPC_SAP/SOCK_SAP/CPP-inserver-fancy.cpp:
          Split the Options class to a new file, CPP-inclient.h, to make
          IBM C++ (xlC) like it.

        * examples/IOStream/server/iostream_server.cpp: Split the Handler
          class off to new iostream_server.h file, to make IBM C++ (xlC)
          like it.

        * examples/Logger/Acceptor-server/server_loggerd.cpp: Moved the
          Options and handler classes' definitions to new server_loggerd.h
          file to build with AIX IBM C++.

        * examples/Misc/testr_dump.cpp: Moved the program's classes'
          definitions to new server_loggerd.h file to build with AIX IBM
          C++.

        * examples/IPC_SAP/SOCK_SAP/Makefile:
        * examples/Connection/non_blocking/Makefile:
        * examples/Misc/Makefile:
          On AIX w/ IBM C++, delete the tempinc directory before compiling
          each new program. Keeps the template instantiations from one
          program from conflicting with the others.

        * include/makeinclude/rules.lib.GNU: On AIX using IBM C++ only, don't
          try to link in the auto-instantiated template object modules if
          there aren't any.

        * include/platform_aix4_cset++.GNU: Removed TMPL_OBJS - not needed now.
        * examples/Misc/Makefile: On AIX w/ IBM C++, delete the tempinc
          directory before compiling each new program. Keeps the template
          instantiations from one program from conflicting with the
          others.

Fri Jun 25 12:40:29 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE-INSTALL.html: added/expanded/moved discussions of
          enabling/increasing virtual memory on Linux and LynxOS.  Thanks
          to Fabrice Podlyski <podlyski@clrhp04.in2p3.fr> for providing
          detailed information for LynxOS.

Fri Jun 25 11:16:32 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * tests/Makefile: Updated dependencies for Cache_Map_Manager_Test
          and Map_Manager_Test.

Fri Jun 25 07:41:05 1999  David L. Levine  <levine@cs.wustl.edu>

        * docs/ACE-guidelines.html: added guideline to include
          directories containing files with template definitions in a -I.

Thu Jun 24 22:42:44 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/SOCK_Dgram_Mcast.cpp (subscribe): fixed UNICOS
          preprocessor usage so that it's not in the middle of the
          ACE_reintepret_cast.

Thu Jun 24 22:18:52 1999  Doug Anderson  <dla@home.com>

        * ace/CDR_Stream.*,ace/SOCK_Dgram_Mcast.cpp,ace/config-cray.h:
          updates for Cray UNICOS port.

Thu Jun 24 21:33:11 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * ace/Caching_Strategies_T.{h, cpp} (class ACE_FIFO_Caching_Strategy):
        * ace/Caching_Strategies_T.{h, cpp} (class ACE_LRU_Caching_Strategy):
        * ace/Caching_Strategies_T.{h, cpp} (class ACE_LFU_Caching_Strategy):
          Removed the overloaded clear_cache () method with entries as an
          formal argument.

        * ace/Caching_Strategy_Utility_T.{h,i,cpp}: Renamed as
          Caching_Utiltity.{h, i, cpp}. Also, removed <entries> formal
          argument from the clear_cache() method, and made purge_percent
          of type double instead of unsigned int.

        * tests/Cache_Map_Manager_Test.cpp: Changed the purge_test and
          added a test for the Cache_Map_Manager using the Map_Manager.

        * tests/Map_Manager_Test.cpp: Changed the template instantiation
          in vein with the changes to the names of the Caching_Utility
          classes.

        * tests/Cache_Map_Manager_test.dsp:
        * tests/tests.dsw:
          Made NT project for the test and added it to the tests workspace.

Thu Jun 24 20:43:54 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * examples/Reactor/WFMO_Reactor/test_multithreading.cpp
          (Task_Handler): Change loop to go from 1 to number_of_handles
          instead of 0 to number_of_handles - 1.

Thu Jun 24 18:36:22 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Signal.h: Removed the still-born
          ACE_Sig_Action (struct sigaction *) method.  Thanks to Umar
          Syyid for reporting this.

Thu Jun 24 15:47:32 1999  Steve Huston  <shuston@riverace.com>

        * tests/run_pharlap_tests.bat: One-button script for running the tests
          built for PharLap ETS.

        * tests/tests_pharlap_msvc.lnk: PharLap ETS LinkLoc input file for
          building test for ETS. Very possible that local sites will need to
          adjust this for the target environment.

        * tests/Atomic_Op_Test.dsp:
        * tests/Barrier_Test.dsp:
        * tests/Basic_Types_Test.dsp:
        * tests/Buffer_Stream_Test.dsp:
        * tests/CDR_Test_Test.dsp:
        * tests/Collection_Test.dsp:
        * tests/Conn_Test.dsp:
        * tests/DLList_Test.dsp:
        * tests/Dynamic_Priority_Test.dsp:
        * tests/Enum_Interfaces_Test.dsp:
        * tests/Env_Value_Test.dsp:
        * tests/Future_Test.dsp:
        * tests/Handle_Set_Test.dsp:
        * tests/Hash_Map_Manager_Test.dsp:
        * tests/High_Res_Timer_Test.dsp:
        * tests/IOStream_Test.dsp:
        * tests/Map_Manager_Test.dsp:
        * tests/Map_Test.dsp:
        * tests/Mem_Map_Test.dsp:
        * tests/Message_Block_Test.dsp:
        * tests/Message_Queue_Notifications_Test.dsp:
        * tests/Message_Queue_Test.dsp:
        * tests/MM_Shared_Memory_Test.dsp:
        * tests/MT_Reactor_Timer_Test.dsp:
        * tests/MT_SOCK_Test.dsp:
        * tests/Naming_Test.dsp:
        * tests/New_Fail_Test.dsp:
        * tests/Notify_Performance_Test.dsp:
        * tests/OrdMultiSet_Test.dsp:
        * tests/Pipe_Test.dsp:
        * tests/Priority_Buffer_Test.dsp:
        * tests/Priority_Reactor_Test.dsp:
        * tests/Priority_Task_Test.dsp:
        * tests/Process_Mutex_Test.dsp:
        * tests/Process_Strategy_Test.dsp:
        * tests/RB_Tree_Test.dsp:
        * tests/Reactor_Exceptions_Test.dsp:
        * tests/Reactor_Notify_Test.dsp:
        * tests/Reactor_Performance_Test.dsp:
        * tests/Reactor_Timer_Test.dsp:
        * tests/Reactors_Test.dsp:
        * tests/Reader_Writer_Test.dsp:
        * tests/Recursive_Mutex_Test.dsp:
        * tests/Reverse_Lock_Test.dsp:
        * tests/Semaphore_Test.dsp:
        * tests/Service_Config_Test.dsp:
        * tests/Sigset_Ops_Test.dsp:
        * tests/Simple_Message_Block_Test.dsp:
        * tests/SOCK_Connector_Test.dsp:
        * tests/SOCK_Send_Recv_Test.dsp:
        * tests/SOCK_Test.dsp:
        * tests/SPIPE_Test.dsp:
        * tests/SString_Test.dsp:
        * tests/SV_Shared_Memory_Test.dsp:
        * tests/Svc_Handler_Test.dsp:
        * tests/Task_Test.dsp:
        * tests/Thread_Manager_Test.dsp:
        * tests/Thread_Mutex_Test.dsp:
        * tests/Thread_Pool_Reactor_Test.dsp:
        * tests/Thread_Pool_Test.dsp:
        * tests/Time_Service_Test.dsp:
        * tests/Time_Value_Test.dsp:
        * tests/Timeprobe_Test.dsp:
        * tests/Timer_Queue_Test.dsp:
        * tests/Tokens_Test.dsp:
        * tests/TSS_Test.dsp:
        * tests/Upgradeable_RW_Test.dsp:
        * tests/UPIPE_SAP_Test.dsp:
          Added "PharLap ETS Debug" configurations.

        * ACE-INSTALL.html: Added some info about the PharLap TNT ETS port.

Thu Jun 24 14:10:20 1999  David L. Levine  <levine@cs.wustl.edu>

        * bin/libsize.pl: use appropriate size command for all of
          our cross-compile platforms.

Thu Jun 24 14:00:27 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-sunos5.7.h: with ghs only, undef ACE_HAS_PROC_FS
          and ACE_HAS_PRUSAGE_T because the Sun's sys/procfs_isa
          requires 64-bit ints.

Thu Jun 24 13:53:53 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Proactor.cpp: added missing backslash to one of
          the instantiation pragmas.

Thu Jun 24 12:53:22 1999  Steve Huston  <shuston@riverace.com>

        * ace/OS.(h i): Added check for ACE_HAS_WINSOCK2 != 0 wherever
          the check was only for ifdef ACE_HAS_WINSOCK2. Allows building on
          Winsock 1.1.

        * ace/config-pharlap.h: New config file for use with PharLap TNT
          Embedded ToolSuite. This is not really tested yet - that activity
          continues.

Thu Jun 24 07:05:17 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-osf1-4.0.h,include/makeinclude/platform_osf1_4.0.GNU,
          include/makeinclude/platform_osf1_cxx.GNU: use pragmas instead of
          command line arguments to disable specific warning messages.
          This cleans up the command line, and makes it easier to control
          warning message suppression (because the compiler version is
          available in __DECCXX_VER to the preprocessor.)

Wed Jun 23 21:27:45 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE-INSTALL.html: removed space from "resource requirements"
          tag to avoid problems with web browers.

Wed Jun 23 20:18:42 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/WFMO_Reactor: Added a no-op work_pending()
          implementation until we figure out how to implement this.

        * ace/Reactor_Impl.h,
        * ace/Reactor.{cpp,h},
        * ace/Select_Reactor_T.{h,cpp}: Added a work_pending() method
          that just checks if there are I/O events "ready" for
          dispatching, but doesn't actually dispatch event handlers.  This
          is needed for TAO's work_pending() API.  Thanks to Irfan for
          suggesting this.

Wed Jun 23 15:27:48 1999  David L. Levine  <levine@cs.wustl.edu>

        * bin/libsize.pl: added this script, which provide a size
          breakdown of either the ACE or TAO libraries.

Wed Jun 23 14:34:27 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE-INSTALL.html: added link to ACE Library Size Breakdown
          in System Resource Requirements discussion.

Wed Jun 23 14:09:27 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * ace/Caching_Strategies_T.cpp (ACE_LRU_Caching_Strategy):
          Checked and modified the creation and deletion logic of the
          caching utility object.
        * ace/Cache_Map_Manager_T.cpp (~Cache_Map_Manager):
          Added the close method call to avoid memory leaks.
        * tests/run_test.pl:
        * tests/run_test.bat:
          Added Cache_Map_Manager_Test.
        * tests/Cache_Map_Manager_Test: Removed extra comma.
        * ace/Caching_Strategies_T.{h, i, cpp}
        * ace/Cache_Map_Manager_T.{i,h,cpp}
        * ace/Caching_Strategy_Utility_T.{h,i,cpp}
        * ace/Cleanup_Strategies_T.{h, i,cpp}
        * ace/Hash_Cache_Map_Manager_T.{h, i,cpp}
        * ace/ace_dll.dsp:
          Added above caching related files into the NT ace workspace.

Wed Jun 23 10:09:06 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE-INSTALL.html: updated System Resource requirements discussion.
          All of ACE+TAO requires well over 1 Gb of disk now :-/.

Wed Jun 23 00:03:31 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/SOCK_Dgram.cpp (ACE_SOCK_Dgram): Fixed an unused args
          warning.  Thanks to David for reporting this.

        * ace/Service_Config.h (ACE_Service_Config): Moved the
          documentation for the open() method's "argv" parameters *to* the
          open() method.  Also clarified that by default we don't install
          the "statically configured services" (such as ACE_Svc_Manager).
          Thanks to Ian MacDonald <ianmacd@bg.com> for motivating this.

        * ace/OS.i (accept): Added a new workaround for platforms
          like VxWorks that can't handle NULL addrs to accept().  Thanks
          to James Hu <jhx@entera.com> and John Weald
          <John.Weald@sylantro.com> for this fix.

        * ace/config-vxworks5.x.h: Added a new macro
          ACE_HAS_BROKEN_ACCEPT_ADDR to work around VxWorks problems
          with NULL addrs to accept().

Tue Jun 22 21:17:49 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * tests/Cache_Map_Manager_Test.cpp: Tests the Cache_Map_Manager
          as well as the Hash_Cache_Map_Manager which has additional
          features of caching and purging of entries along with the map
          properties.
        * tests/Makefile: Added Cache_Map_Manager_Test.cpp

Tue Jun 22 15:20:53 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Thread_Manager_Test.cpp (main): removed THR_DETACHED.
          That seems to solve the libthread panic problem on Solaris,
          even with group signalling enabled.  Thanks to Carlos for
          suggesting this.

Tue Jun 22 15:11:34 1999  Matthew J Braun  <mjb2@cs.wustl.edu>

        * ace/Containers_T.h,i
          Added new next(T *&) methods to the ACE_DLList_Iterator
          classes and marked the old versions as DEPRECATED.

Tue Jun 22 13:40:22 1999  David L. Levine  <levine@cs.wustl.edu>

        * docs/tutorials/*/Makefile: replace rm -f with $(RM).

Tue Jun 22 13:07:19 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tests/Message_Block_Test.cpp:
        * websvcs/lib/URL_Addr.i:
        * websvcs/lib/URL_Addr.cpp:
          Removed more g++ -W warnings

Tue Jun 22 11:12:42 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE-INSTALL.html: added System Resource Requirements
          section.  Thanks to Hakan Kallberg <hk@simulina.se>
          and Eric Mitchell <emitchell@altaira.com> for the
          Linux swap space and -pipe removal suggestions.

Tue Jun 22 07:45:59 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Event_Handler_T.i: fixed some occurrences of
          ACE_INLINE that were after the function return type.

Tue Jun 22 07:30:12 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Stats.cpp: fixed for ACE_LACKS_LONGLONG_T platforms.
          (sample): replace return statement with an else branch, to
          make it easier to see what the code is doing.

Mon Jun 21 23:36:02 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * websvcs/lib/URL_Addr.cpp:
          Fixed warnings about unused variables.

Mon Jun 21 23:27:01 1999  Darrell Brunsch  <brunsch@cs.wustl.edu>

        * ace/SString.h: Added ACE_TString typdef that is either a
          ACE_CString or ACE_WString, depending on whether UNICODE
          is defined.

Mon Jun 21 23:22:46 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * examples/Misc/test_trace.cpp: Improved this test so it will
          work more effectively on single-threaded *and* multi-threaded
          platforms.  Thanks to Hao Ruan <hruan@lucent.com> for reporting
          this.  Also fixed a warnng in this test caused by failure to
          return a value on every return path.  Thanks to David Levine for
          reporting this.

Mon Jun 21 14:17:22 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Stats.h:
        * ace/Stats.cpp:
          Added new class to keep latency and throughput statistics.

Mon Jun 21 13:24:41 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_freebsd.GNU,platform_linux.GNU,
          platform_linux_lxpthread.GNU,platform_psosim_g++.GNU,
          platform_qnx_neutrino.GNU,platform_sunos5_g++.GNU,
          platform_vxworks5.x_g++.GNU: added -W to CFLAGS.  -Wall
          doesn't include the -W checks, at least with egcs 1.1.2.

Mon Jun 21 10:18:01 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Makefile: moved FlReactor, Msg_WFMO_Reactor, TkReactor,
          and XtReactor from OTHER to DEMUX_FILES because TAO uses
          them in some configurations.  They add negligible size
          overhead when not used.  Thanks to Nanbor for pointing this
          out.

Mon Jun 21 10:11:15 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Makefile:
          The TP_Reactor is used by TAO, but was listed in the OTHER
          component. Moved to the DEMUX component to make it always
          available.  Thanks to David Levine for pointing this out.

Mon Jun 21 09:58:42 1999  Joe Hoffert  <joeh@cs.wustl.edu>

        * ace/QoS.{h,cpp}: Removed these files from ACE since they have a
          lot of problems. Will add back later when they compile and are
          tested.

Mon Jun 21 08:40:14 1999  Steve Huston  <shuston@riverace.com>

        * examples/Connection/misc/Connection_Handler.cpp (handle_input):
          Corrected signed/unsigned mismatch I accidentally put in last week.

        * ace/CORBA_macros.h: Added __HP_aCC to the compilers that need
          special handling for throwing an exception from a value-returning
          function.

        * include/makeinclude/platform_hpux_aCC.GNU: Added +DAportable
          to CCFLAGS if no architecture specified.  Added -z to LDFLAGS
          to force SEGV on dereference 0 pointer. Added definition for
          CPP_LOCATION to not use aCC - it displays warnings for unrecognized
          #pragmas and this dirties the TAO builds. Thanks to Brian Wallis
          <Brian.Wallis@sr.com.au> for these ideas.

Sat Jun 19 22:28:35 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * bin/auto_compile:
          Updated the list of tests run every night.

Sat Jun 19 18:15:48 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/OS.h:
        * ace/CORBA_macros.h:
          The ACE_GUARD macros needed some blanks to work with a template
          as the lock type parameter.

Sat Jun 19 10:34:55 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Acceptor.cpp,
          ace/Connector.cpp: Modified the make_svc_handler() hook method
          in these classes to set the Reactor of the newly created
          SVC_HANDLER to the same reactor that the Acceptor or Connector
          is using.  Thanks to John Aughey <jha@FreeBSD.ORG> for
          this suggestion.

        * man/{html,man3}: Zapped the Ace_Export.* files since
          they don't belong here.  Thanks to Zoran Ivanovic
          <zorani@pathcom.com> for reporting this.

Fri Jun 18 20:49:09 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Synch.cpp: Added template instantiations for
          ACE_Write_Guard<ACE_Thread_Mutex>.

Fri Jun 18 19:30:09 1999  Douglas C. Schmidt  <schmidt@cs.wustl.edu>

        * ACE version 4.6.42 released.

Fri Jun 18 18:49:39 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tests/Makefile:
        * tests/run_tests.psosim:
        * tests/run_tests.sh:
        * tests/run_tests.vxworks:
          Disabled Map_Manager_Test, it does not work with too many
          platforms and the features it tests are not used (yet).

Fri Jun 18 16:54:43 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tests/Message_Queue_Test.cpp:
        * tests/Message_Block_Test.cpp:
          Removed template instantiations for ACE_Message_Queue_Iterator
          and ACE_Message_Queue_Reverse_Iterator.  They are already
          available in the ace library.

        * ace/Service_Types.cpp: Added explicit instantiations for
          ACE_Message_Queue_Reverse_Iterator.  ACE_Message_Queue and
          ACE_Message_Queue_Iterator were already there.  This addition
          will complete the set.

Fri Jun 18 12:12:59 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/SOCK_Dgram: Added the first set of hooks to support
          QoS-enabled data grams for Win2K GQoS.

Fri Jun 18 11:37:31 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * *.{mdp,mak}: Removed all MSVC++ 4.x workspaces and makefiles.
          We are no longer supporting this version of MSVC++.  If you need
          support for MSVC++ 4.x please contact Steve Huston
          <shuston@riverace.com> of Riverace to arrange a support
          contract.

Fri Jun 18 12:19:42 1999  Matthew J Braun  <mjb2@cs.wustl.edu>

        * tests/DLList_Test.cpp: Removeed unnecessary explicit template
          instantiation that mirrored ones in ace/Containers.cpp to fix
          compile errors on VxWorks. Why this _ever_ worked, I don't
          know...

Fri Jun 18 11:37:31 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/Service_Config.h (class ACE_Static_Svc_Descriptor): Changed
          the type of <name_> from LPTCSTR to 'const ASYS_TCHAR*'.

Thu Jun 17 12:46:30 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * tests/Conn_Test.cpp: Fixed a problem with explicit template
          instantiations so that this test will compile even if ACE isn't
          built with threads.

        * netsvcs/lib/Server_Logging_Handler.cpp: Fixed the explicit
          template instantiations so hopefully they'll work when ACE is
          compiled without threads.  Thanks to Carlos for reporting this.

        * ace/SOCK_Dgram_Mcast.cpp: We needed to modify the return values
          of subscribe_i() so that we'd have the ability to differentiate
          a "short-circuit" return on NT.  Thanks to Marina for reporting
          this.

        * ace/OS.h: Added an automatic test to check if we're running on
          an EBCDIC character set, and if so, set
          ACE_STANDARD_CHARACTER_SET_SIZE to 256 rather than 128.  Thanks
          to Jim Rogers for this suggestion.

        * performance-tests/TTCP/Makefile: Zapped the Orbix and ORBeline
          directories from the Makefile.  These are *way* out of date and
          have been superceeded by the versions in
          $TAO_ROOT/performance-tests/Thruput/.  Thanks to Youzhong Liu
          <yoliu@cise.ufl.edu> for reporting this.

Thu Jun 17 12:59:24 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/CDR_Stream.h:
        * ace/CDR_Stream.i:
          Added accessors for the codeset translators.

Thu Jun 17 00:33:57 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * include/makeinclude/platform_freebsd.GNU (VERSION): Applied the
          patch to automatically detect FreeBSD version.  Thanks to
          Goldshtain Dmitry <goldshtain@bank.gov.ua> for providing the
          patch.

        * bin/Process_Win32.pm (TimedWait):
          Get and return the exit status from the waited process.

Wed Jun 16 22:03:29 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/OS.h (ACE_OS): Removed ACE_WIDE_DL_TYPE and the wide char
          versions of dlopen(), dlsym(), and dlerror().  Even Win32
          doesn't support them.

          Also changed the argument type of ACE_OS::dlopen(),
          ACE_OS::dlsym(), ACE_DLL::ACE_DLL(), ACE_DLL::open(), and
          ACE_DLL::symbol() from ACE_DL_TYPE to const char *.  Now the
          ACE_OS wrappers do the correct const cast before calling the OS
          function.  Note that since this change is only adding constness
          to the argument, the change is backward compatible.

Wed Jun 16 20:47:27 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * bin/Process_Win32.pm:
          The wait time for a process seems to be in milliseconds.

Wed Jun 16 20:03:41 1999  Steve Huston  <shuston@riverace.com>

        * ace/Containers_T.cpp: Qualify dllist_ with 'this->' to get the
          template types looked up correctly. This is what fixes the pesky
          future error 641 on HP-UX aC++.

        * ace/RB_Tree.i: Qualify node_ and tree_ with 'this->' to get the
          template types looked up correctly. aC++ is really happy now,
          and so is Steve :-)

Wed Jun 16 18:50:38 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/OS.i:
          Fixed typos in single threaded code.

Wed Jun 16 18:14:45 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * ace/Cached_Connect_Strategy_T.{h, cpp}: Added ATTRIBUTES to
          the template list for the Cached_Connect_Strategy_Ex class to
          ward off g++ compiler errors.

Wed Jun 16 15:54:08 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

	* ace/OS.h:
	* ace/OS.i:
	* ace/config-win32.h:
	  Auto-detect if we are using MSVC5.0 or MSVC6.0 and define the
	  ACE_HAS_WINSOCK_GQOS macro in that case. This macro is used in
	  the places where the QoS data structure of both compilers are
	  different.

Mon Jun 14 22:52:48 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * tests/Map_Manager_Test.cpp: Removed template instantiation
          regarding ACE_Read_Mutex<Thread_Mutex>. Added template
          instantiations for ACE_Pair<VALUE, int> and
          ACE_Reference_Pair<TYPE, VALUE> to make sunc++5.0 happy.

        * ace/Caching_Strategy_Utility_T.{h.cpp}: Removed math.h from the
          include list since it caused problems when native exceptions were
          enabled.

Mon Jun 14 21:41:40 1999  Douglas C. Schmidt  <schmidt@mambo.cs.wustl.edu>

        * ace/Connector.h: Added a comment to clarify that if
          Connector::connect() fails the close() hook of the Svc_Handler
          is called to prevent resource leaks.  Thanks to V. Lakshmanan
          <lakshman@doplight.nssl.noaa.gov> for motivating this.

Mon Jun 14 20:54:09 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * ace/Synch.cpp: Declared template definitions for
          ACE_Read_Mutex<ACE_Thread_Mutex> to get around compiler errors
          while building $ACE_ROOT/tests. Thanks to Dr.Schmidt for
          suggesting this.

Mon Jun 14 19:33:04 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/SOCK_Acceptor.cpp (accept): Fixed a bizarre problem with
          Win32 where it's imperative that the third parameter to <accept>
          must be a NULL pointer if we want to ignore the client address.

        * ace/OS.i: Cleaned up warnings in join_leaf() and ioctl() due to
          unused args.  Thanks to Marina for reporting this.

Mon Jun 14 15:56:27 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-qnx-neutrino.h,
          include/makeinclude/platform_qnx_neutrino.GNU: added config
          files for QNX Neutrino.  They support cross-compiling on a
          QNX4 host for Neutrino target.  Builds are almost (but not
          completely) clean.

        * include/makeinclude/platform_qnx_neutrino.GNU: only
          build static libs, because they seem to work better.  Many
          of the ACE tests pass with this configuration!  (Some of
          the usual suspects, such as Conn_Test, don't.)

        * ace/config-qnx-neutrino.h: don't need ACE_HAS_PENTIUM here,
          because it's in config-g++-common.h.  Removed
          ACE_HAS_USING_KEYWORD, because g++ 2.8.1 doesn't support
          namespaces.

Mon Jun 14 14:33:29 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Reactor_Performance_Test.cpp (handle_input): removed
          printout when result == 0.  It happens when the client finishes
          first, which I think is OK.

Mon Jun 14 11:55:31 1999  Steve Huston  <shuston@riverace.com>

        * include/makeinclude/platform_aix4_g++.GNU: New platform file for AIX
          4.x using GNU compiler. Been tested w/ egcs 1.1.2.

        * include/makeinclude/platform_aix4_cset++.GNU: Make shared libs
          correctly and without building the static one first.
          Also, for cset++, disable warnings on AIX 4.3 to shut up the
          0-valued preprocessor warnings. This is not a great
          long-term general solution, but it'll do the job.

        * include/makeinclude/wrapper_macros.GNU:
        * include/makeinclude/rules.lib.GNU: On AIX, build shared lib w/o
          requiring static one first. When building shared libs, also link
          against them and install the proper files when done. The correct
          files built for libfoo are:
             libfoo.a: archive/static library
             libfoo.so: shared library, but not set up for run-time linker.
                        This is the one loaded by ACE dynamic loading.
             libfooshr.a: an archive library with libfoo.so as its only
                        member. This is what to link against when building
                        a program/library that uses libfoo.

          Silly?  Uh-huh. But that's life in AIX land. I tried to get things
          building/running clean using the run-time linker (-brtl) but had
          no end of trouble. And, since no other libs in /usr/lib want to
          do it that way either, it's like this.

Mon Jun 14 09:58:02 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/OS.i: Added ACE_UNUSED_ARG() macros for all the non-WINSOCK2
          cases in the ACE_Flow_Spec and ACE_QoS methods.  Thanks to David
          for reporting this.

        * ace/OS.i: Moved the definition of ACE_Errno_Guard's methods to
          earlier in the file to avoid problems with inline ordering.
          Thanks to David for reporting this.

        * ACE-INSTALL.html: Updated Barry Hoggard's CORBA page URL.

Mon Jun 14 07:17:23 1999  David L. Levine  <levine@cs.wustl.edu>

        * docs/ACE-guidelines.html: fixed typo: exceptions.

Sun Jun 13 14:22:54 1999  Douglas C. Schmidt  <schmidt@maxixe.cs.wustl.edu>

        * ace/LSOCK_Acceptor.cpp: Rewrote the accept() method to use the
          same new technique that's used in ACE_SOCK_Acceptor::accept().
          This is necessary since there's no longer a shared_accept().

        * ace/SOCK_Acceptor: Removed shared_accept() since it's been split
          into two parts to make the QoS features easier to maintain.

        * ace/SOCK_Acceptor: Added the new ACE_Accept_QoS_Params parameter
          to the ACE_SOCK_Acceptor::accept().  Also created two new
          private methods, shared_accept_start() and
          shared_accept_finish(), that factor out common code.

        * ace/SOCK_Connector: Added the new ACE_Connect_QoS_Params
          parameter to ACE_SOCK_Connector::connect().  Also created two
          new private methods, shared_connect_start() and
          shared_connect_finish(), that factor out common code.

        * ace/SOCK_Connector.cpp: Cleaned up the logic that checks for
          various types of errors and updated the code to use the new
          ACE_Errno_Guard features.

        * ace/OS.h: Added an equality and in-equality operator for
          ACE_Errno_Guard and moved all the methods into OS.i rather than
          OS.h.  Also added an ACE_Export to the ACE_Errno_Guard class so
          that it can be used outside of the ACE library.

        * ace/OS.h: For Win32, added support for the WinSock2 QoS
          functions WSAAccept(), WSAConnect(), WSAJoinLeaf(), and
          WSAIoctl().

        * ace/OS.h: For Win32, added thin wrappers ACE_Flow_Spec and
          ACE_QoS that encapsulate the WinSock2 FLOWSPEC and QOS structs,
          respectively.

        * ace/OS.h: For Win32, added an implicit conversion operator from
          iovec to WSABUF since they are structurally equivalent.

Sun Jun 13 14:22:54 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * bin/README.html: Updated the information about the ACE
          documentation tools to be more helpful.

Fri Jun 11 20:04:37 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * bin/Process_Unix.pm:
          Fixed problems on TimedWait().

Fri Jun 11 15:28:44 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/OS.h: Need to add #include <signal.h> before <pthread.h>
          since pthread.h doesn't include signal.h on SunOS 5.7.  Thanks
          to Rick Weisner <rick.weisner@east.sun.com> for reporting this.

        * ace/OS: ACE_OS::memchr() should return a const void * rather
          than a void *.  Thanks to Rick Weisner
          <rick.weisner@east.sun.com> for reporting this.

        * ace/Dirent.i: Don't call closedir() on a NULL dirp because some
          platforms (such as SunOS 5.7) will segfault!  Thanks to Tom
          Arbuckle <arbuckle@uran.informatik.uni-bonn.de> for pointing
          this out.

Fri Jun 11 14:47:47 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * bin/auto_compile: Does not compile all the directories in TAO,
          because it takes too much space (and time).  Run several more
          tests in TAO that are stable.  Improve output.

        * ace/Log_Msg.cpp: Use ACE_HAS_THR_C_DEST for TSS "destructors",
          not ACE_HAS_THR_C_FUNC.

        * bin/ACEutils.pm:
        * bin/Process_Unix.pm:
        * bin/Process_Win32.pm: Added new routines to wait for a process
          with a timeout, ditto for the ACE::waitforfile() routine.  They
          can be used to write more reliable test drivers.

Fri Jun 11 14:40:49 1999  David L. Levine  <levine@cs.wustl.edu>

        * bin/create_ace_build: run the directory mode value through eval,
          to convert it from octal to decimal, if necessary.  Thanks to
          Russ Noseworthy for providing the patch.

        * include/makeinclude/platform_sunos5_sunc++.GNU: only set
          TEMPLATE_REPOSITORY for Sun C++ 4.2.  5.0 doesn't need it.
          Thanks to Dennis C. De Mars <demars@mminternet.com> for
          reporting this.

        * tests/Reactor_Performance_Test.cpp (main): return error status
          from run_event_loop () call.  And, added a few ACE_ERROR
          printouts.  Thanks to Steve for mentioned this.

        * ace/config-sunos5.5.h: properly reverted all the changes of
          today.  The comments are more helpful this way.

        * include/makeinclude/platform_linux_lxpthread.GNU: changed
          PLATFORM_AIO_SUPPORT to use := instead of =, so that it only
          invokes the shell once.  Thanks to Lothar Werzinger
          <lwerzinger@krones.de> for suggesting this.

Fri Jun 11 12:10:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * tests/RB_Tree_Test.{cpp, h (new)}: factored out class template
          declaration into a .h file to make AIX C++ happy.

Thu Jun 10 23:11:36 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * ace/Cache_Map_Manager_T.{h, i, cpp}: Added Iterator
          implementations to the template parameters to be able to build
          using the g++ compiler. Also removed unnecessary HASH_KEY and
          COMPARE_KEYS from the template list.

        * ace/Hash_Cache_Map_Manager_T.{h, i, cpp}: Made appropriate
          changes to support changes made to Cache_Map_Manager.

        * ace/Caching_Strategies_T.{h, i, cpp}: Added an overloaded
          clear_cache method which allows the user to specify the total
          number of entries in the cache. Also added the
          Caching_Strategy_Utility parameter which decouples the actual
          purging from the caching strategy.

        * ace/Caching_Strategy_Utility.{h,i,cpp}: Added a Null version of
          the utility to be used with the Null strategy.

        * ace/Cleanup_Strategies_T.{h,i,cpp}: Added the ACE_UNSED_ARGS
          macro to ward of g++ warnings.

        * tests/Map_Manager_Test.cpp: Added performance tests for the
          Cache_Map_Manager and the Hash_Cache_Map_Manager.

Thu Jun 10 20:29:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * ace/RB_Tree.h: Made constructors for iterator base class
          protected instead of protected, so the the base class can only
          be constructed by the derived forward and reverse iterator
          classes.  Thanks to Matt Braun for pointing this out.

        * tests/RB_Tree_Test.cpp: Major overhaul of the test to use a test
          class template that encapsulates the test details and makes the
          code much more readable.  Then, the main program merely
          instantiates a test for each of the four possible combinations
          of key/item type parameterization over int and const char *, and
          calls the run_test () method of each test instance.

Thu Jun 10 12:44:22 1999  Steve Huston  <shuston@riverace.com>

        * tests/UPIPE_SAP_Test.cpp: Disable for Win32 if !ACE_HAS_WINNT4.
          The test relies on ACE_SPIPE_Acceptor which requires NT4 to
          work.

Thu Jun 10 12:47:52 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-linux-lxpthreads.h: removed ACE_HAS_AIO_CALLS.  It's
          now enabled in the platform_macros.GNU file:

        * include/makeinclude/platform_linux_lxpthread.GNU: added
          automatic detection of AIO support, based on existence of
          /usr/lib/librt.so.

        * include/makeinclude/platform_linux_lxpthread.GNU: add -lrt to
          LIBS only if $(PLATFORM_AIO_SUPPORT) is equal to
          -DACE_HAS_AIO_CALLS.

        Thanks to Jake Hamby <jehamby@anobject.com> for reporting that not
        all Linux platforms have AIO support.

Thu Jun 10 10:17:08 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-sunos5.5.h: with Sun C++ 5.0, #define
          _RWSTD_NO_EXCEPTIONS 1 if exceptions are not enabled.  This
          avoids a warning about throw expressions being ignored with
          -noex.  See /opt/SUNWspro_5.0/SC5.0/include/CC/stdcomp.h for
          more information.

        * ace/os-patches/vxworks-5.1.txt,ACE-INSTALL.html: added these
          notes for using ACE with VxWorks 5.1.

        * docs/ACE-guidelines.html: avoid source code filenames that
          include "Error".  Avoid #include <math.h>.

Wed Jun  9 21:45:24 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * tests/Svc_Handler_Test.cpp (main): Revised the test a bit to
          make it more clear what's going on.

        * ace/Svc_Handler.cpp: Fixed a typo in flush() -- we need to
          update the temp pointer with temp->cont() *not* entry->cont().

        * ace/Svc_Handler.cpp (dump): Fixed a typo -- I wasn't comparing
          the pointer to 0, I was comparing the ACE_Time_Value!

Wed Jun  9 21:10:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * ace/config-psos-diab-ppc.h: added
          ACE_HAS_NONCONST_SELECT_TIMEVAL

        * tests/RB_Tree_Test.cpp: fixed constness issues revealed by
          SunC++ 5.0, added return value assertions for insert calls,
          added typedefs.

Wed Jun  9 20:40:50 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/CDR_Stream.h:
        * ace/CDR_Stream.cpp: Added new methods to support message
          reassembly in GIOP 1.1

Wed Jun  9 15:32:37 1999  Douglas C. Schmidt  <schmidt@mambo.cs.wustl.edu>

        * ace/Message_Queue_T: Added a lock() accessor method so that
          other components can access the lock used by a Message Queue.

        * ace/Svc_Handler.cpp: Added better support for timeout handling
          for the ACE_Buffered_Svc_Handler.

        * ace/Svc_Handler: Split the buffering portion of ACE_Svc_Handler
          off into a separate class called ACE_Buffered_Svc_Handler to
          avoid adding extra space and complexity to the existing
          ACE_Svc_Handler.  Thanks to Irfan for suggesting this, as well
          as also suggesting ways to improve the performance by caching
          the current size of the buffer.

        * ace/OS.h: Added a patch to work around some problems with macros
          for USYNCH_THREAD.  Thanks to David Levine and Russ Noseworthy
          for this.

        * examples/Threads/task_five.cpp (main): Improved the form and
          content of this example a bit.

        * include/makeinclude/platform_sunos5_sunc++.GNU,
        * include/makeinclude/platform_sunos5_g++.GNU,
        * include/makeinclude/platform_irix6.x_g++.GNU,
        * include/makeinclude/platform_linux_lxpthread.GNU,
        * include/makeinclude/platform_irix6.x_sgic++.GNU:
          Added support to make it easier to override various settings
          in platform_macros files.  Thanks to Dave Meyer
          <dmeyer@lima.arl.std.saic.com> for contributing this.

        * ace/SPIPE_Stream: Added sendv(), sendv_n(), and recvv_n()
          methods to SPIPE_Stream.  Thank to Carlos for pointing this out.

        * ace/config-mvs.h: Changed the size of the ACE_SIZEOF_DOUBLE and
          ACE_SIZEOF_LONG_DOUBLE from 4 and to 8 and 16, respectively.
          Thanks to Jim Rogers for reporting this.

        * ace/config-mvs.h: Added ACE_HAS_NONCONST_SELECT_TIMEVAL on the
          advice of Jim Rogers <jrogers@viasoft.com>.

        * ace/OS.h (class ACE_Errno_Guard): Propagate the return value of
          the assignment operator to allow chaining.  Thanks to Jeff for
          reporting this.

        * ace/OS.i: Fixed a bizzarre problem with lower-case ace_os::.
          Thanks to Andy for pointing this out.

        * ace/Svc_Conf.y: Don't enable YYDEBUG by default so that we can
          save some space in the generated code.

        * ace/OS: Added several more uses of ACE_Errno_Guard, which has
          been enhanced to support assignment.  Thanks to Irfan for
          suggesting this.

        * tests/Svc_Handler_Test.cpp: Added a simple test for the new
          buffering feature in ACE_Svc_Handler.

        * ace/Strategies.cpp: Added an explicit template instantiation for
          ACE_Message_Queue_Iterator <ACE_NULL_SYNCH> since this is now
          used in ACE_Svc_Handler.

        * ace/Svc_Handler: Added a "buffering" feature to the
          ACE_Svc_Handler.  This feature makes it possible to queue up
          ACE_Message_Blocks in an ACE_Message_Queue until (1) the queue
          is "full" or (2) a period of time elapses, at which point the
          queue is "flushed" via sendv_n() to the peer.

Wed Jun  9 12:23:30 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tests/version_tests/version_tests.dsw:
        * tests/run_tests.bat:
        * tests/run_tests.psosim:
        * tests/run_tests.vxworks:
          Added Svc_Handler_Test to these.

        * tests/tests.dsw:
          Added Svc_Handler_Test.dsp (created and checked in by
          Nanbor) to the workspace.

Wed Jun  9 10:46:07 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Strategies.cpp:
          Moved template instantiations to ace/Service_Types.cpp

        * ace/Service_Types.cpp:
          Added missing template instantiations for
          ACE_Message_Queue_Iterator<>

        * ace/Svc_Handler.cpp (flush):
          Removed extra characters and the end of a #endif
          Fixed warning about unused variable
          Use right iterator for the Message_Queue

Wed Jun 09 10:11:29 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-g++-common.h: added #define of
          ACE_NEW_THROWS_EXCEPTIONS, with egcs if ACE_HAS_EXCEPTIONS is
          #defined.  That allows ACE's New_Fail_Test to pass.  Thanks
          to Jake Hamby <jehamby@anobject.com> for providing the fix.

Tue Jun  8 22:44:18 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * Hacked BYACC to generate a parser that doesn't have any
          incorrect const char *'s.  This clears the last major const
          issue in libACE.

Tue Jun  8 20:46:05 1999  Matthew J Braun  <mjb2@cs.wustl.edu>

        * ace/Functor.i,h: Migrated ACE_Hash template specializations
          from native types to ACE types (ACE_UINT16, etc).  This was
          necessary since native types are not portable.

Tue Jun  8 15:47:06 1999  Douglas C. Schmidt  <schmidt@danzon.cs.wustl.edu>

        * ace: Updated most of the places in ACE that can benefit from the
          new ACE_Errno_Guard class.

        * ace/OS.h: Added a new ACE_Errno_Guard class that improves
          performance when thread-specific errno must be saved/restored in
          a block of code.  Thanks to Serge Kolgan <skolgan@cisco.com> for
          motivating this and to Rick Weisner <Rick.Weisner@East.Sun.COM>
          for explaining the technique to Serge.

        * ace/Env_Value_T.h: Added a new ACE_Convert() function that works
          for const char *'s.  Thanks to David for reporting this.

Tue Jun 08 18:08:41 1999  Steve Huston  <shuston@riverace.com>

        * ace/OS.h: Added new overridable macro, ACE_LOCALHOST. This allows
          overriding of the string used to do a loopback IP socket to the
          local host. Some systems (e.g. PharLap ETS) don't have a host table
          out of the box, and require an IP address string.

        * ace/Pipe.cpp: Use the new ACE_LOCALHOST macro instead of a hard
          "localhost" when using a socket to emulate a pipe.  Thanks to
          Bruce Trask <BTRASK@contactsystems.com> for working to get this
          ironed out for PharLap ETS.

        * README: Added Bruce Trask to the Hall of Fame ;-)

        * tests/SOCK_Connector_Test.cpp: Check for failed host lookup
          before trying to connect.  Changed the way sethostent is done on
          AIX 4.3 to work around an apparent bug in AIX 4.3.

Tue Jun 08 13:46:38 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/OS.h (wmain): Added a new macro to tweak the wchat_t version
          of main program entry point to create the non-static
          Object_Manager.  This is only enabled if UNICODE and ACE_WIN32
          is defined (although you can also use wmain under non-UNICODE
          environment).

Mon Jun 07 14:34:53 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/CORBA_macros.h: The member function for dumping
          TAO_Exception is changed to _tao_print_exception.

Tue Jun 08 14:44:07 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Thread_Manager_Test.cpp (main): on Sun only, added 5
          second sleep before the "main thread finished" printout.  It
          might help (but certainly doesn't prevent) avoid an occasional
          thread lib panic on SunOS 5.5 through 5.7.

Tue Jun 08 14:01:51 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE version 4.6.41 released.

Tue Jun  8 12:42:56 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * Fixed lots of brokens URL links.  Thanks to Eric S Rosenthal
          <esr@netcom.com> for reporting these.

Mon Jun  7 17:09:56 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * examples/Naming/test_multiple_contexts.cpp (main): Added a cast
          to resolve const problems.  Thanks to David for reporting this.

        * examples/Naming/test_writers.cpp (main): Fixed a typo.  Thanks
          to David for reporting this.

Mon Jun  7 14:21:48 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * tests/DLL_Test.cpp (main): ANSI C++ spec doesnt allow void * to
          be typecasted to a function_pointer. Hence made changes to
          remove the warning due to this.  Thanks to Nanbor
          <nanbor@cs.wustl.edu> for pointing it out.

Mon Jun  7 14:12:02 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ACE-INSTALL.html: Added a general section explaining the order
          of user defined macros and platform config file.  Thanks to
          Stephen E Blake <stephen_e_blake@email.moore.com> for pointing
          this out.

Mon Jun 07 10:55:12 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-osf1-4.0.h: added #define ACE_HAS_BROKEN_T_ERROR
          to permit building again.  Thanks to Doug for this fix.

Mon Jun  7 12:35:17 1999  Douglas C. Schmidt  <schmidt@danzon.cs.wustl.edu>

        * examples/Service_Configurator/IPC-tests/client: Fixed some more
          warnings related to const-correctness.  I believe that ACE is
          now just about completely const-correct.

        * examples/Service_Configurator/Misc/main.cpp (main): Cast to
          (ASYS_TCHAR **) rather than (ASYS_THCAR *[]).  Thanks to David
          for reporting this.

        * examples/IPC_SAP/DEV_SAP/writer/writer.cpp (main): Fixed a stray
          comma.  Thanks to David for reporting this.

        * tests/Hash_Map_Manager_Test.cpp: Changed the use of ASYS_TCHAR *
          to LPCTSTR to ensure const-correctness.

        * netsvcs/lib: Reformatted all the *.h files to conform to the ACE
          programming guidelines.

Sun Jun  6 22:02:43 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/OS.i (t_error): Fixed the broken t_error() usage on SunOS
          5.5 and 5.6...

        * ace/README: Added a new macro called ACE_HAS_BROKEN_T_ERROR to
          workaround the frigging broken prototype for t_error() on
          Solaris 2.5.  Note that this macro is required for SunOS 2.5 and
          2.6, but not SunOS 2.7 (thank goodness).

        * Fixed gazillions of incorrect usages of char * (which should
          have been const char *) throughout ACE.

        * netsvcs/clients/Tokens: Fixed some const char * inconsistencies.

        * netsvcs/lib/Name_Handler.h: Fixed another inconsistent use of
          char * that should have been const char *.

        * ace/Service_Config.h: Fixed a const incorrectness in the
          ACE_Static_Svc_Descriptor.

        * ace/Process.h (ACE_Process_Options): The parameter type of
          command_line() should be LPCTSTR argv[] *not* LPTSTR argv[].
          This fix should be ok as a further extension to what Carlos did
          below.

Sun Jun 06 20:33:00 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/SString.h:
          Added missing ACE_Export macro

Sun Jun  6 20:34:40 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Synch.h:
        * ace/Timer_Queue_T.h:
        * ace/Timer_Queue.cpp:
        * ace/Select_Reactor.cpp:
          Moved explicit template instantiations around, now ACE compiles
          and links with Sun/CC and inlining enabled.  TAO does not.

Sun Jun  6 18:05:48 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Process.h:
        * ace/Process.cpp:
          Added const-correct version of the command_line() method, in the
          future we should remove the non-const version, but I don't feel
          like breaking an interface today.


Sun Jun 06 09:08:48 1999  David L. Levine  <levine@cs.wustl.edu>

        * PROBLEM-REPORT-FORM: added requests to not send
          as attachment, or tar'red, compressed, and/or
          uuencoded, or with line lengths >= 80 characters.

Sun Jun 06 08:08:11 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Functor.{h,i} (ACE_Hash<ACE_UINT64>::operator ()):
          conditionally compile only if ACE_SIZEOF_LONG is not 8,
          to avoid conflict with ACE_HASH<unsigned long> on 64-bit
          platforms (alphas).

Sat Jun  5 23:34:21 1999  Douglas C. Schmidt  <schmidt@danzon.cs.wustl.edu>

        * ace/Containers_T: Changed all uses of "index" to "slot" to avoid
          conflicts with broken C++ compilers that define macros named
          "index."

Sat Jun  5 22:57:31 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/OS.h:
          Added new macro (ACE_TEMPLATE_SPECIALIZATION) to handle the
          differences between compilers supporting the standard way to
          specialize a template (i.e. template<> class Foo<int>) vs. the
          old style (just saying class Foo<int>).
          Also added new macro ACE_HAS_STD_TEMPLATE_SPECIALIZATION that
          platforms must define if they want the new style.

        * ace/Filecache.cpp:
        * ace/Functor.h:
          Use the new ACE_TEMPLATE_SPECIALIZATION macro

        * ace/config-sunos5.5.h:
          Define the new ACE_HAS_STD_TEMPLATE_SPECIALIZATION for Sun/CC
          5.0

        * ACE-INSTALL.html:
          Added some notes about our success with Sun/CC 5.0

Sat Jun  5 16:48:47 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/config-irix6.x-common.h
        * ace/config-irix6.x-sgic++-nothreads.h
        * ace/config-irix6.x-sgic++.h
        * include/makeinclude/platform_irix6.x-sgic++.GNU
        * include/makeinclude/platform_irix6.x_common.GNU
        * include/makeinclude/platform_irix6.x_g++.GNU
        * include/makeinclude/platform_irix6.x_kcc.GNU
        * include/makeinclude/platform_irix6.x_sgic++.GNU: On IRIX 6.5 we
          must not define ACE_LACKS_NETDB_REENTRANT_FUNCTIONS, thanks to
          Bob Laferriere <laferrie@gsao.med.ge.com> for pointing this out.
          Created a new platform_*.GNU file that auto detects the IRIX
          version (couldn't find a pre-processor macro to do it); also
          renamed the platform_irix6.x-sgic++.GNU file to use underscore
          instead of '-'; that way it is more consistent with the other
          files.

Sat Jun  5 13:29:07 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Codeset_IBM1047: Minor reformatting to conform to ACE
          programming guidelines.

Sat Jun  5 13:00:46 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/CDR_Stream.h:
        * ace/CDR_Stream.i:
        * ace/CDR_Stream.cpp:
          New methods added to the InputCDR class to simplify the process
          of reading a buffer from a socket or file.

Fri Jun  4 23:52:19 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/CDR_Stream.h:
        * ace/CDR_Stream.i:
        * ace/CDR_Stream.cpp:
          Added support for codeset translators.
          Many thanks to Jim Rogers <jrogers@viasoft.com> for providing
          these fixes.

        * ace/Makefile:
        * ace/Codeset_IBM1047.h:
        * ace/Codeset_IBM1047.cpp:
          A pair of codeset translators between IBM1047 (aka EBCDIC) and
          ISO8859-1 (aka ISO-Latin-1)

        * ace/config-mvs.h:
          Define an ACE_MVS macro

Fri Jun  4 15:23:18 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * ace/Cached_Connect_Strategy_T.{h,i,cpp}: Removed common code by
          making Cached_Connect_Strategy_Ex derive from
          Cached_Connect_Strategy class.

Fri Jun 04 09:59:58 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * docs/tutorials/tutorials.dsw: Fixed "_" to "-". Thanks to Tom
          Bradley <thomas.bradley@maisel-gw.enst-bretagne.fr> for pointing
          out this problem.

Fri Jun  4 09:02:35 1999  Aniruddha Gokhale  <gokhale@sahyadri.research.bell-labs.com>

        * ace/POSIX_Asynch_IO.cpp: Fixed a syntax error. There were two
        consecutive commas in the ACE_DEBUG statement which were causing
        syntax errors while compiling.

Fri Jun  4 00:28:07 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * ace/POSIX_Asynch_IO.cpp: Fixed the Linux egcs warning.

Thu Jun  3 17:05:36 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * ace/Cached_Connect_Strategy_T.h
        * ace/Cached_Connect_Strategy_T.i
        * ace/Cached_Connect_Strategy_T.cpp

          Caching connection strategy used by the Strategy Connector.

        * ace/Cache_Map_Manager_T.h
        * ace/Cache_Map_Manager_T.i
        * ace/Cache_Map_Manager_T.cpp

          Map Manager which performs caching depending on the caching
          strategy used.

        * ace/Hash_Cache_Map_Manager_T.h
        * ace/Hash_Cache_Map_Manager_T.i
        * ace/Hash_Cache_Map_Manager_T.cpp

          Hash_Map used as a specialised form of the Cache Map.

        * ace/Caching_Strategies_T.h
        * ace/Caching_Strategies_T.i
        * ace/Caching_Strategies_T.cpp

          Strategies used for caching purposes, example: Least Recently
          Used.

        * ace/Caching_Strategy_Utility_T.h
        * ace/Caching_Strategy_Utility_T.i
        * ace/Caching_Strategy_Utility_T.cpp

          Helper class for the caching strategy classes which does the
          purging of entries.

        * ace/Cleanup_Strategies_T.h
        * ace/Cleanup_Strategies_T.i
        * ace/Cleanup_Strategies_T.cpp

          Strategy which deals with destruction and cleanup in general.

        * ace/Makefile

          Added the above under the TEMPLATE_FILES.

        * examples/Web_Crawler/Optimal_Cache_Map_Manager_T.h
        * examples/Web_Crawler/Optimal_Cache_Map_Manager_T.i
        * examples/Web_Crawler/Optimal_Cache_Map_Manager_T.cpp
        * examples/Web_Crawler/Cached_Connect_Strategy_T.h
        * examples/Web_Crawler/Cached_Connect_Strategy_T.i
        * examples/Web_Crawler/Cached_Connect_Strategy_T.cpp
        * examples/Web_Crawler/Caching_Strategies_T.h
        * examples/Web_Crawler/Caching_Strategies_T.i
        * examples/Web_Crawler/Caching_Strategies_T.cpp

          Removed these files and added them to the ace library itself.

        * examples/Web_Crawler/Command_Processor.cpp
        * examples/Web_Crawler/Command_Processor.h
        * examples/Web_Crawler/HTTP_URL.cpp
        * examples/Web_Crawler/HTTP_URL.h
        * examples/Web_Crawler/Iterators.h
        * examples/Web_Crawler/Makefile
        * examples/Web_Crawler/Mem_Map_Stream.cpp
        * examples/Web_Crawler/Mem_Map_Stream.h
        * examples/Web_Crawler/Options.h
        * examples/Web_Crawler/URL.h
        * examples/Web_Crawler/URL_Addr.h
        * examples/Web_Crawler/URL_Status.h
        * examples/Web_Crawler/URL_Visitor.cpp
        * examples/Web_Crawler/URL_Visitor.h
        * examples/Web_Crawler/URL_Visitor_Factory.h
        * examples/Web_Crawler/Web_Crawler.h
        * examples/Web_Crawler/main.cpp

          Changed to include files pertaining to Caching and Connection
          management from ace library.

Thu Jun 03 15:57:43 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Strategies_T (ACE_Cached_Connect_Strategy): Allowed the user
          to pass in a mutex.  This allows the user to pass in a
          preconfigured mutex of his/her liking. Since the parameters
          default appropriately, no existing code should break.

        * ace/Functor: Changed ACE_Hash<unsigned long long> specialization
          to ACE_Hash<ACE_UINT64>.

Thu Jun  3 10:36:35  Matthew J Braun  <mjb2@cs.wustl.edu>

        * ace/Functor.i
        * ace/Functor.h:
          Added ACE_Hash <unsigned long long>. It truncates the ULongLong
          to a ULong and returns it. Nothing major...

Wed Jun  2 17:50:23 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * include/makeinclude/platform_mvs.GNU:
          Debugging info was not generated on the C++ files.
          The -+ flag should be added to CPPFLAGS using +=
          Thanks to Jim Rogers <jrogers@viasoft.com> for these fixes.

Wed Jun 02 16:11:34 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/TTY_IO.cpp (control): Commented out odd baud rates (56000,
          128000, 256000) which don't seem to be supported on FreeBSD.

Wed Jun 02 00:07:44 1999    <alex@cs.wustl.edu>

       * tao/test_cancel.dsp
       * tao/post_completions.
       * tao/test_end_event_lo
       * tao/test_multiple_loo
       * tao/test_proactor.dsp
       * tao/test_proactor.dsw
       * tao/test_timeout.dsp

       * examples/Reactor/Proactor/test_cancel.cpp:
       * examples/Reactor/Proactor/README:
       * examples/Reactor/Proactor/Makefile:

        Related to ChangeLog : Tue Jun  1 16:48:58 1999  Alexander Babu
        Arulanthu  <alex@cs.wustl.edu>

Tue Jun  1 21:44:05 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * include/makeinclude/platform_linux_lxpthread.GNU:
          Added the rt library to the command line, ACE uses aynchronous
          I/O by default on linux.

Tue Jun  1 16:48:58 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

           Ported <ACE_Asynch_Operation::cancel> to POSIX platforms based
           on <aio_cancel> API. Made the return values  consistent in both
           WIN32 and POSIX platforms as follows.

         All completion notifications for the I/O operations will occur
         normally.

         = Return Values:

         -1 : Operation failed. (can get only in POSIX).
          0 : All the operations were cancelled.
          1 : All the operations were already finished in this
              handle. Unable to cancel them.
          2 : Atleast one of the requested operations cannot be
              cancelled.

        * ace/Asynch_IO.cpp
        * ace/Asynch_IO.h
        * ace/POSIX_Asynch_IO.cpp
        * ace/POSIX_Asynch_IO.h
        * ace/POSIX_Proactor.h
        * ace/WIN32_Asynch_IO.cpp:
        * ace/POSIX_Proactor.cpp:

        * ace/config-linux-lxpthreads.h: Enabled the ACE_HAS_AIO_CALLS
        flag for this platform.


Tue Jun  1 15:02:34 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Connector.h:
          Documented the new connect() method

Tue Jun 01 11:18:03 1999    <alex@cs.wustl.edu>

        * examples/Reactor/Proactor/test_end_event_loop.cpp:
        * tao/post_completions.cpp
        * tao/test_end_event_loop.cpp
        * tao/test_end_event_loop.dsp
        * tao/test_proactor.dsw
        Fixed the link problems.

Tue Jun  1 09:57:42 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/TTY_IO.cpp (control),
        * ace/config-freebsd.h,
          ace/config-freebsd-pthread.h: Attached is a patch that will
          allow the ACE_TTY_IO class to work with FreeBSD tty devices.
          Thanks to John Aughey <jha@FreeBSD.ORG> for contributing these.

        * ACE-INSTALL.html: Updated the list of platforms that ACE is
          supported on.

Tue Jun 01 10:00:29 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE-INSTALL.html: updated Sun C++ and DU versions in fully
          supported platforms list.

Mon May 31 22:45:18 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-lynxos.h: added ACE_HAS_GPERF.

Mon May 31 16:28:27 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * ace/CDR_Stream.h:
          Added and updated some comments.

Mon May 31 16:13:21 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Makefile: if ACE_COMPONENTS is equal to FOR_TAO,
          override it with the proper component values.  The
          override allows it to be set on the command line, e.g.,
          make ACE_COMPONENTS=FOR_TAO.  Thanks to Carlos for
          reporting this.

Mon May 31 14:00:21 1999  Steve Huston  <shuston@riverace.com>

        * ace/RB_Tree.i: Reverted changes from May 21.  It broke the LynxOS
          build of tests/RB_Tree_Test.

Mon May 31 11:51:03 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/CORBA_Handler.h: Updated the comments to clarify how to use
          this class.  Thanks to Ram Vishnuvajjala
          <rvishnuvajjala@lucent.com> for motivating this.

        * ace/Service_Config: Added a static variable called is_initialized
          that keeps track of whether the <ACE_Service_Config> is already
          initialized.  If it is, we can't allow <yyparse> to be called
          since it's not reentrant...

Sun May 30 14:08:48 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/Makefile:
        * ace/Vector.{h,i,cpp}:
        * tests/Makefile:
        * tests/Vector_Test.cpp: Removed the ACE_Vector implementation
          from the distribution.

Sat May 29 14:14:37 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/Vector.{h,i,cpp}: Added STL Vector-style insert() and
          erase() methods.  Also added a new constructor that creates an
          ACE_Vector from a specified range of iterators.  ACE_Vector
          class is now Purify clean (i.e. fixed any and all memory leaks).

        * tests/Vector_Test.cpp: Added tests for the newly added
          ACE_Vector<T>::insert() and ACE_Vector<T>::erase() methods.

Fri May 28 20:19:50 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/Vector.{h,i,cpp},
          tests/Vector_Test.cpp: Implemented an ACE_Vector class based on
          the ACE_Array class.  It is not derived from it, however.  The
          ACE_Vector class provides an STL Vector-like interface.  The
          Vector_Test tests the important features of the ACE_Vector class
          and sends output to `logs/Vector_Test.log'.

        * ace/Makefile,
          tests/Makefile: Added ACE_Vector related files to the makefiles
          and updated the dependencies.

Thu May 27 15:50:17 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/UNIX_Addr.cpp (set), Explicitly set the sun_family to
          AF_UNIX, otherwise it will be zero by a previous call to
          memset().  AF_UNSPEC, which is zero, is what the call to
          memset() cause the sun_family to be.

Wed May 26 01:46:27 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * include/makeinclude/platform_freebsd.GNU:
        * include/makeinclude/platform_freebsd_pthread.GNU: Consolidated
          platform macro files for FreeBSD.

        * ace/config-freebsd-pthread.h:
        * ace/config-freebsd.h: Added ACE_HAS_NONCONST_SELECT_TIMEVAL.

Tue May 25 21:38:40 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/UNIX_Addr.cpp: The default constructor was not setting the
          address family to AF_UNIX.  Now that we do so we can let the OS
          select a ephemeral UNIX domain endpoint for us.

Tue May 25 19:20:15 1999  Steve Huston  <shuston@riverace.com>

        * tests/run_tests.(sh bat): Added SOCK_Send_Recv_Test.

Tue May 25 16:54:41 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * tests/SOCK_Send_Recv_Test.cpp:
          Fixed a signed/unsigned mismatch warning and
          changed several uses of static_cast to
          reinterpret_cast. This is a belated entry, I put it
          first in TAO/ChangeLog by mistake.

Tue May 25 15:19:06 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_sunos5_ghs.GNU: added
          -Xleaveg7 to CFLAGS with threads=1.  It's necessary
          to avoid execution problems in multithreaded programs.
          Thanks to Stefaan Kiebooms <stefaan@ghs.com> for providing
          this fix.

Tue May 25 13:40:10 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/LSOCK_Acceptor.cpp (get_local_addr):

          Only the base class members of ACE_UNIX_Addr were being copied
          since the assignment lacked a dynamic cast.  Thanks to Carlos and
          Irfan for clarifying this.

Tue May 25 11:41:28 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Timeprobe_T.h (class ACE_Timeprobe): Moved the default size
          from Timeprobe_T.h to OS.h, where it can easily be redefined by
          the user.

Tue May 25 07:37:47 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_osf1_4.0.GNU: removed suppression
          of warning 839: no_corresponding_delete.

Mon May 24 14:04:11 1999  Steve Huston  <shuston@riverace.com>

        * tests/SOCK_Send_Recv_Test.cpp: New test to exercise ACE_SOCK send
          and receive variations.  It concentrates on recvv/sendv-like things
          now in order to shake out Winsock 1.1 issues.  To be complete, it
          should be added to over time.

        * tests/Makefile:
        * tests/version_tests/{SOCK_Send_Recv_Test.dsp, version_tests.dsw}:
        * tests/{SOCK_Send_Recv_Test.dsp, tests.dsw}: Add new test.

Mon May 24 12:11:03 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/OS.i (ACE_SOCKCALL_RETURN): Fixed macro by comparing against
          FAILVALUE rather than SOCKET_ERROR.  Some winsock calls don't
          return SOCKET_ERROR.  Thanks to Christopher Kohlhoff
          <chris@kohlhoff.com> for reporting this problem.

Sun May 23 11:33:07 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

         Changes for the following enhancement in the Proactor
         implementation.  Enhanced the semantics of the <end_event_loop>,
         so that when it is called, it wakes up all the threads blocked on
         waiting for completions and end the event loop.  Thanks to Edwin
         D. Windes <ewindes@usa.net> for reporting the issue.

        * ace/Proactor.h:
        * ace/Proactor.cpp: Added static helper methods and states to post
          the wakeup completions to the CompletionPort.

        * ace/Asynch_IO.h:
        * ace/Asynch_IO.cpp: Added a method <handle_wakeup> to the
          ACE_Handler.

        * ace/Object_Manager.cpp
        * ace/Object_Manager.h: Added a new Thread_Mutex called
          <ACE_PROACTOR_EVENT_LOOP_LOCK> to protect the thread count in
          the event loop.

        * ace/POSIX_Asynch_IO.cpp
        * ace/POSIX_Proactor.cpp
        * ace/POSIX_Proactor.h
        * ace/Proactor.cpp
        * ace/Proactor.h
        * ace/Proactor_Impl.h
        * ace/WIN32_Proactor.cpp
        * ace/WIN32_Proactor.h:
          Changes for posting wakeup completions.

        * examples/Reactor/Proactor/test_end_event_loop.cpp:
        * examples/Reactor/Proactor/test_end_event_loop.dsp:
        * examples/Reactor/Proactor/post_completions.dsp:
        * examples/Reactor/Proactor/Makefile: Test file the
          <end_event_loop> enhancement.

Sat May 22 16:57:38 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/FlReactor.cpp: Sun/CC doesn't like reinterpret cast when
          converting from an int into an int; this is silly, but I cannot
          use static_cast because on NT reinterpret_cast is the right
          thing.  Use old-style casts for the moment.

        * tests/FlReactor_Test.cpp: Minor cosmetic fixes.

Sat May 22 16:36:14 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * ACE version 4.6.40 released.

Sat May 22 14:53:47 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Filecache.cpp: snagged another "template <>".  Thanks to
          Bala for reporting it.

Sat May 22 07:30:44 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-chorus.h,ace/config-lynxos.h: added
          ACE_HAS_NONCONST_SELECT_TIMEVAL.

        * ace/Filecache.cpp: commented out "template<>" for now.  Not all
          compilers can cope with it.

Fri May 21 21:12:37 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Map_Manager.i (operator==): Since <map_man_> is a pointer
          now, we must compare by value, rather than by address.

Fri May 21 12:56:38 1999  David L. Levine  <levine@cs.wustl.edu>

        * examples/IPC_SAP/SOCK_SAP/CPP-inclient.cpp: fixed to
          build without threads:  #ifdef ACE_MT_SAFE is insufficient.
          Must also check if it is 0.

Fri May 21 12:45:32 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Map_Manager.i:
          Fixed minor error in previous commit.  Thanks to Irfan for
          helping out with this.

Fri May 21 11:18:21 1999  Steve Huston  <shuston@riverace.com>

        * ace/config-hpux11.h: Added ACE_HAS_NONCONST_SELECT_TIMEVAL.

        * ace/RB_Tree.i: Fully template-qualified references to node_ and
          tree_ in iterators; makes HP aC++ happy.

Fri May 21 11:27:44 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Map_Manager.h (class ACE_Map_Iterator_Base): Changed the
          ACE_Map_Manager reference to a pointer.  This way there is no
          problem in reinitializing <map_man_>, and hence the compiler
          will not have a problem in providing us a default assignment
          operator.  Thanks to Knut Johannessen <knutj@funcom.com> for
          pointing out this problem.

        * ace/Process: A nifty ACE::fork was added several months ago
          which offers the option to avoid zombies, but it is not used in
          ACE_Process::spawn.

          Mark L. Boriack <mboriack@sito.saic.com> provided patches which
          adds an <avoid_zombies_> data member to ACE_Process_Options,
          appropriate accessor functions, and changes the ACE_OS::fork
          call to ACE::fork in ACE_Process::spawn, making use of the
          option.  The default behavior is left unchanged, i.e., you get
          zombies.  Thanks Mark.

Fri May 21 10:34:10 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/gethrtime.cpp,Makefile (gethrtime on Green
          Hills/VxWorks): reverted to building gethrtime.cpp with g++, because
          the ghs assembly code didn't work properly.

Fri May 21 10:10:13 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ACE-INSTALL.html: Updated information about building egcs' C++
          shared libraries with an example, and emphasized the fact that
          the `--enable-shared' configuration option is not an egcs
          run-time option.  Thanks to Wallace Owen <owen@visicom.com> for
          motivating this.

Fri May 21 09:15:08 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/config-sunos5.5.h:
          Added ACE_HAS_NONCONST_SELECT_TIMEVAL here too

Fri May 21 07:53:58 1999  Steve Huston  <shuston@riverace.com>

        * ace/config-vxworks5.x.h, config-osf1-4.0.h: Added
          ACE_HAS_NONCONST_SELECT_TIMEVAL.

Thu May 20 18:01:24 1999  Steve Huston  <shuston@riverace.com>

        * ace/Filecache.cpp: Added "template<>" to specializations.

        * ace/OS.i (ACE_OS::select, ACE_OS::sleep): Removed implicit
          dependency on binary object layout with regard to using an
          ACE_Time_Value object as a struct timeval; use the timeval*
          operator instead.  On platforms with ACE_HAS_NONCONST_SELECT_TIMEVAL
          don't just cast away const-ness of the ACE_Time_Value - modification
          of the timeval by select() is not consistent, and Linux is not the
          only one that modifies it (Solaris 7 does also, as well as AIX and
          possibly HP; Solaris 2.5/6 don't specify).  So, play it safe.
          Inlining and optimization should prevent this from having any
          affect on performance.

        * ace/config-sunos5.5.h, config-hpux-10.x.h, config-aix-4.x.h:
          Added #define ACE_HAS_NONCONST_SELECT_TIMEVAL.

Thu May 20 17:47:35 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/OS.h (ACE_DES_ARRAY_FREE_*): Added new macros to facilitate
          proper destruction of arrays.

        * ace/Containers_T.cpp (ACE_Array_Base): Changed ACE_Array_Base to
          use the new ACE_DES_ARRAY_FREE_* macros in order to prevent the
          memory leaks.

Thu May 20 17:46:02 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/ace_dll.dsp:
        * ace/ace_lib.dsp: Fixed Alpha configurations.  Thanks to
          Christian Schuderer <Christian.Schuderer@erl9.siemens.de> for
          reporting this.

Thu May 20 15:35:23 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * tests/TkReactor_Test.cpp:
          It was not compiling if ACE_HAS_TK was not defined.

Thu May 20 15:33:21 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_vxworks5.x_ghs.GNU:
          added (and default to) LIBS for Green Hills 1.8.9.

Thu May 20 14:34:59 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-sunos5.5.h: with Green Hills only, added
          ACE_LACKS_ACE_IOSTREAM.  ACE's IOStream_Test never halts
          when built with Green Hills 1.8.9.

Thu May 20 14:21:44 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.i: (t_getname): fixed comment after #endif, to
          agree with the #ifdef.

Thu May 20 13:51:20 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/config-win32-common.h: I forgot to put '/**/' between
          #include and <blah.h> which caused MSVC to generate warnings
          when checking file dependencies.  Thanks to Christian Schuderer
          <Christian.Schuderer@erl9.siemens.de> for reporting this.

Thu May 20 13:52:04 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-sunos5.5.h: build with threads if
          _POSIX_C_SOURCE >= 199506L or #ifdef _POSIX_PTHREAD_SEMANTICS.
          Added #define ACE_LACKS_RWLOCK_T if _POSIX_PTHREAD_SEMANTICS
          is #defined (and therefore ACE_HAS_STHREADS is not #defined).
          The rwlock functions are a Solaris threads interface, and
          are not POSIX.

        * include/makeinclude/platform_sunos5_ghs.GNU: default to
          building without threads support, because Green Hills 1.8.9
          is incompatible with the SunOS threads libraries.

Thu May 20 12:12:01 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.{h,cpp},Sched_Params.cpp: with ACE_HAS_PRIOCNTL,
          moved #include of sys/{rt,ts}priocntl.h from OS.cpp and
          Sched_Params.cpp to OS.h, so that USYNC_THREAD and USYNC_PROCESS
          #defines can be protected effectively.

Thu May 20 11:19:45 1999  Joe Hoffert <joeh@cs.wustl.edu>

        * ace/ATM_Addr.cpp: Added ACE_UNUSED_ARG for selector parameter
          when appropriate.

Thu May 20 09:57:57 1999  Bill Rizzi <rizzi@softserv.com>

        * ace/Log_Msg.{h,cpp},examples/Log_Msg/test_log_msg.cpp
          (priority_mask): added optional support for process priority
          mask, in addition to the (now default) thread priority mask.

Thu May 20 09:42:54 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.h (fcntl): changed type of last argument from int to
          long, to permit safer casting from pointer types.

        * ace/OS.i (flock_*): use ACE_OS::fcntl instead of ::fcntl.

        * ace/OS.cpp (ftruncate): use ACE_OS::fcntl instead of ::fcntl.

        Thanks to an anonymous ACE user for reporting that
        these functions weren't using ACE_OS::fcntl.

Wed May 19 23:50:18 1999  Nagarajan Surendran  <naga@cs.wustl.edu>

        * ace/TkReactor.{h,cpp}:
        * ace/Makefile:
          Added a new reactor implementation based on the Tcl/Tk Event
          loop and event handling mechanism.

        * ace/tests/TkReactor_Test.{cpp,tcl}:
        * ace/tests/Makefile:
          The Tk Reactor test and the tcl script for the GUI. This is
          similar to the XtReactor_Test.

        * ace/include/makeinclude/wrapper_macros.GNU:
        * ace/include/makeinclude/platform_sunos5_sunc++.GNU
          Added changes to Makefile flags for XtReactor.

Wed May 19 21:56:49 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Message_Queue.h: fixed typo in comment: interrupt.

Wed May 19 21:34:29 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_osf1_4.0.GNU:  removed these
          warning suppressions:
          174: expr_has_no_effect
          610: nonoverriding_function_decl
          They're certainly not needed with cxx 6.2-020, and
          hopefully not needed with earlier versions.

Wed May 19 10:52:15 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * examples/DLL/test_dll.cpp (main): Fixed auto pointer use.  It
          was causing "Temporary used for non-const reference" warnings.

Wed May 19 10:04:54 1999  Jeff Parsons  <parsons@cs.wustl.edu>

        * ace/SString.i:
          Changed the default constructor to set rep_ to the
          empty string instead of the null string. Thanks to
          Knut Johannessen <knutj@funcom.com> for pointing
          this out.

Wed May 19 06:34:58 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-minimal.h: added #define ACE_USE_THREAD_MANAGER_ADAPTER,
          so that ACE_Thread_Exit isn't needed in the ACE_OS layer.

Tue May 18 22:03:49 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_osf1_4.0.GNU,platform_osf1_cxx.GNU:
          removed suppression of warning 9 (nested comment not allowed) on
          Digital Unix 5.0 and later.

Tue May 18 15:01:39 1999  Steve Huston  <shuston@riverace.com>

        * ace/ACE.cpp: Added #include "ace/SString.h" to catch def for
          ACE_Tokenizer in Winsock 1.1 mode.

Tue May 18 13:30:55 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * include/makeinclude/rules.nested.GNU: FOR is not an excutable on
          Win32, therefore, we must bring in the command processor in to
          use FOR.  Thanks to David Hooker <DHooker@uniview.net> for
          reporting the bug.

Tue May 18 11:46:55 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/FILE_Connector.h: Changed the default perms from 0 to
          ACE_DEFAULT_FILE_PERMS.

Tue May 18 11:28:32 1999  Joe Hoffert  <joeh@cs.wustl.edu>

        * examples/IPC_SAP/TLI_SAP/CPP-ATM-server.cpp: forced
          ACE_TLI_Stream's recv method to call ACE_OS::t_rcv rather than
          ACE_OS::read to be compatible with XTI.

Tue May 18 11:00:15 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Task_T: Moved the ACE_Buffered_Task logic out of the Task
          abstraction since it doesn't belong there.

        * ace/Makefile: Regenerated the dependencies.

        * ace/FlReactor.cpp: We should be including <FL/Fl.h> rather than
          "FL/Fl.h".

Tue May 18 10:42:47 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_osf1_4.0.GNU: removed
          suppression of warning 1180, statement causes unreachable
          return, because it's no longer necessary.

Tue May 18 10:38:53 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Thread_Manager_Test.cpp: replaced Hash_Map_Manager
          with a simple array.  This avoids dynamic allocation in
          the signal handler.  And, it avoids having to specialize
          ACE_Hash<ACE_hthread_t> on platforms that have a pthread_t
          struct.

Tue May 18 09:33:46 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/FILE_IO: Added new sendv()/recvv() and sendv_n()/recvv_n()
          methods to be consistent with SOCK_IO and SOCK_Stream.

        * ace/SOCK_IO.cpp (recvv): Make sure to 0-out the iov_base so that
          it's always ok to delete it, even if any of the internal
          operations fail!

Tue May 18 10:14:47 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Makefile:
        * ace/FlReactor.h:
        * ace/FlReactor.i:
        * ace/FlReactor.cpp:
        * include/makeinclude/platform_linux_lxpthread.GNU:
        * include/makeinclude/wrapper_macros.GNU:
        * tests/Makefile:
        * tests/FlReactor_Test.cpp:
          Added new reactor implementation based on the event loop of the
          Fast-Light toolkit, similar to the XtReactor.
          FLTK is a GUI toolkit that works on UNIX/X-Windows and on Win32,
          it is integrated to OpenGL and is pure C++.
          Check http://fltk.easysw.org for more details.

Tue May 18 09:35:00 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Thread_Manager_Test.{h,cpp},Makefile:
          removed Thread_Manager_Test.h.

Mon May 17 22:39:06 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Thread_Manager_Test.cpp: added a couple more
          explicit template instantiations.  Thanks to Carlos
          for reporting that they're needed on Irix.  And,
          added an ACE_Hash<ACE_hthread_t> specialization to
          keep DU cxx happy.

Mon May 17 16:31:16 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Task_T.cpp,
          ace/OS.h: Removed ACE_DEFAULT_WRITEV_MAX and replaced it
          with IOV_MAX.

Mon May 17 15:49:48 1999  David L. Levine  <levine@cs.wustl.edu>

        * config-dgux-4.x-ghs.h,config-vxworks5.x.h,config-ghs-common.h:
          factored ACE_LACKS_SIGNED_CHAR to config-ghs-common.h.

        * config-dgux-4.x-ghs.h: removed ACE_LACKS_ACE_IOSTREAM.
          It should work now, though we don't have that platform
          to verify it.

Mon May 17 15:08:45 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/CORBA_macros.h:
          Fixed implementation of the ACE_READ_GUARD_THROW_EX and
          ACE_WRITE_GUARD_THROW_EX macros.

Mon May 17 15:12:54 1999  David L. Levine  <levine@cs.wustl.edu>

        * test/Thread_Manager_Test.cpp: use a hash map, instead of
          TSS, to store each thread's indication of whether it has
          been signalled.  That way, the signal handler doesn't have
          to access TSS.  Increased the delay from 1 to 2 seconds after
          the signal test, which also seems to help avoid thread lib
          panics on Solaris.

Mon May 17 14:02:01 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Conn_Test.cpp (handler): added comment saying that even
          the ACE_OS::exit () call isn't safe.

Mon May 17 10:31:04 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/Service_Repository.cpp (find_i): A missing pointer check was
          causing the remove method to segfault.  Thanks to Tom Arbuckle
          <arbuckle@uran.informatik.uni-bonn.de> for pointing this out.

Mon May 17 10:21:29 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/TSS_Test.cpp: removed the signal handler.  It
          wasn't used for the test, and contained an ACE_DEBUG.

Mon May 17 10:12:45 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-chorus.h,config-dgux-4.x-ghs.h,config-sunos5.5.h,
          config-vxworks5.x.h,config-ghs-common.h:
          factored out Green Hill-specific #defines to config-ghs-common.h.

Mon May 17 09:07:41 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Conn_Test.cpp (handler): commented out unused arg
          "signum".

Sun May 16 20:38:58 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/CDR_Stream.{h,i} (current): Added this accesor function for
          Flick IDL compiler.  Thanks to Tim Stack <stack@aros.net> for
          recommending this.

Sun May 16 20:08:41 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Thread_Manager_Test.cpp (handler,worker):
          moved ACE_DEBUG out of signal handler.  It was
          causing occasional lockups on SunOS.  Signal
          handlers must never do anything that could cause
          a lock to be acquired.

        * tests/Conn_Test.cpp (handler): removed ACE_DEBUG.

Sun May 16 20:04:09 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.h: moved #include of ace/Trace.h to before #include of
          ace/OS.i.

        * ace/OS.{i,cpp}: enabled ACE_TRACE for most functions (except
          those that are used by ACE_TRACE).

Sun May 16 19:54:10 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * ace/config-sunos5.7.h: Comments
        * ace/config-sunos5.6.h: Comments

        * ace/POSIX_Asynch_IO.cpp:
        * ace/POSIX_Proactor.h:
        * ace/POSIX_Proactor.cpp: - Using ACE_dynamic_cast to get
        <ACE_POSIX_Asynch_Result *> from <aiocb *> gives build errors on
        egcs. <ACE_reinterpret_cast> is not the correct solution for
        this. Solved this problem by having one more list of
        <ACE_POSIX_Asynch_Result *> so that we dont have to do any
        casting.
        * ace/Proactor.cpp (ACE_Proactor): Indentation.
        * examples/Reactor/Proactor/post_completions.cpp: Added template
        pragma's.

Sun May 16 18:35:59 1999  Douglas C. Schmidt  <schmidt@cs.wustl.edu>

        * ACE version 4.6.39 released.

Sun May 16 12:34:48 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Log_Msg.cpp (ACE_Log_Msg_Manager::lock_): changed
          the lock type from ACE_Thread_Mutex to
          ACE_Recursive_Thread_Mutex.  This allows ACE_Log_Msg's
          methods to be called after calling ACE_Log_Msg::acquire (),
          without deadlock.  Thanks to Bill Rizzi <rizzi@softserv.com>
          for suggesting this.

Sat May 15 08:30:43 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Containers.h: added #include of ace/Malloc_Base.h.
          It's needed for the definition of ACE_Allocator when
          instantiating container classes.

Sat May 15 03:32:02 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/CDR_Stream.h: Added #include of ace/SString.h.

Fri May 14 23:05:32 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Log_Record.h: removed unnecessary #include of ace/SString.h.

Fri May 14 21:11:46 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Task_T.h:
        * ace/Task_T.cpp:
          Fixed syntax errors in ACE_Buffered_Task

Fri May 14 21:03:30 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * netsvcs/lib/Log_Message_Receiver.cpp:
          Changed ACE_Guard instantiations with ACE_GUARD() macros to
          avoid some warnings with egcs, similar to the problem that David
          had with Message_Queue_T.cpp

Fri May 14 19:31:04 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/Message_Block.cpp (total_size):

          Corrected warning caused by assignment to non-const from const.

        * ace/Message_Queue_T.cpp (close):

          Temporary variable wasn't declared.

        * ace/Message_Queue_T.cpp (remove_messages):

          Removed unused variable.

Fri May 14 19:16:06 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/Task_T.cpp (put, flush):

          Corrected syntax errors where return type was placed before
          template keyword.

Fri May 14 16:46:42 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Task_T: Added a new class called ACE_Buffered_Task that
          buffers up its ACE_Message_Blocks until (1) the buffer is full
          or (2) a timeout elapses, at which point the buffers are written
          out using some type of writev()-like mechanism.

        * ace/OS.h: Added a new macro called ACE_DEFAULT_WRITEV_MAX, which
          defaults to the maximum value that writev() can have.

        * ace/Message_Block.cpp: Added a new method called total_size()
          that returns the total number of bytes in a composite
          Message_Block (i.e., a Message_Block that has a chain of
          Message_Blocks).

        * ace/Message_Queue_T.cpp: Reimplemented all the hand-coded loops
          to use the new ACE_Message_Block::total_size() method.

Fri May 14 16:17:27 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/Synch.h (ACE_Null_Mutex>): Conditionally compiles ~ACE_Guard()
          destructor.  Win32 needs this definition.

Fri May 14 16:10:29 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Message_Queue_T.cpp: replaced raw ACE_Read_Guards
          with ACE_READ_GUARD_RETURN macros.  That avoids a compiler
          warning (egcs 1.1.1/SunOS 5.7) now that the ACE_Guard<Null_Mutex>
          destructor has been removed.  Thanks to Irfan and Carlos
          for suggesting this fix.

Fri May 14 15:35:50 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/ACE.cpp (clr_flags and set_flags): We should use ioctl()
          calls to implement on vxworks this rather than fcntl().  Thanks
          to Joseph A. Condlin <jac@slpmbo.ed.ray.com> for reporting this.

Fri May 14 13:15:02 1999  Joe Hoffert  <joeh@cs.wustl.edu>

        * examples/IPC_SAP/TLI_SAP/Makefile: Took out FORE specific
          information. Somehow my local changes got checked in - this is
          to undo that.

Fri May 14 12:58:02 1999  Joe Hoffert  <joeh@cs.wustl.edu>

        * ace/ATM_Addr.h:
        * ace/ATM_Addr.i:
        * ace/ATM_Addr.cpp: Added accessor methods for the selector byte
          of an ATM address.

        * examples/IPC_SAP/TLI_SAP/CPP-ATM-client.cpp:
        * examples/IPC_SAP/TLI_SAP/CPP-ATM-server.cpp: Modify example code
          to have the user optionally specify the selector byte.

Fri May 14 12:47:38 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Addr.cpp,ace/Synch_Options.cpp: added comments about
          the static objects.

Fri May 14 11:36:05 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/SString.h:
        * ace/SString.i: Added new class to auto destroy dynamically
          allocated strings, sort of a mixing between auto_ptr and
          CString.  Auto_Ptr_Array was not useful because we need to free
          using ACE_OS::free() (and in the future allocators).

Fri May 14 10:37:49 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/OS.i: Fixed a deadlock in cond_timedwait()/cond_broadcast().
          Thanks to Brian C. Olson <bolson@rtlogic.com> for reporting
          this.

        * ace/Synch.h (ACE_Null_Mutex>): Commented out the ~ACE_Guard()
          destructor to prevent segfaults on certain versions of SunC++.
          Thanks to Russ Noseworthy for reporting this bizarre bug!

Fri May 14 09:51:55 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Message_Block.h:
        * ace/Message_Block.cpp:
          Modified default constructor and constructor taking a Data_Block
          to also take an Allocator.

Fri May 14 09:14:55 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_osf1_cxx.GNU:
          added $(ACELIB) to SOFLAGS for DU 5.x.  It should
          have been there all along.

Thu May 13 17:27:14 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * netsvcs/servers/svc.conf:
        * netsvcs/clients/Naming/Client/svc2.conf:
        * netsvcs/clients/Naming/Client/svc2.conf: Removed relative paths
          from all DLL's.  They were hard-coded which was not portable.
          ACE should figure out the correct path automatically.

        * netsvcs/lib/Name_Handler.cpp: Replaced several calls to
          ACE_WString::rep with ACE_WString::fast_rep to avoid memory
          leaks.  Thanks to Valery Arkhangorodsky
          <valerya@servicesoft.com> for reporting this.

        * ace/Registry.cpp (close): Only close <key_> when we do own a
          key.

        * netsvcs/lib/Name_Handler.cpp (resolve): The atype string needs
          to be delete[]'ed once we are done with it.  Thanks to Valery
          Arkhangorodsky <valerya@servicesoft.com> for pointing this out.

Thu May 13 09:39:17 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Makefile: added Tokens_Test to BIN2 if Tokens component
          is not configured in.  This ensures that Tokens_Test gets
          cleaned up, even if the ace directory was realcleaned first
          (and ACE_BUILD_COMPONENTS is therefore empty).

Thu May 13 07:24:41 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/POSIX_Proactor.cpp (handle_events): replaced
          incorrect dynamic_cast with a reinterpret cast.

Wed May 12 17:42:09 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Message_Block.h:
        * ace/Message_Block.cpp:
          The message blocks can be obtained from an allocator now. Thanks
          to John Aughey <Aughey@concentric.net> for this cool feature.

Wed May 12 16:24:17 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * examples/Reactor/Proactor/Makefile:
        * examples/Reactor/Proactor/test_proactor.cpp:
        * ace/POSIX_Proactor.cpp:
        * ace/POSIX_Proactor.h:
        * ace/Proactor.cpp :
        * ace/POSIX_Asynch_IO.cpp: Fixed the problem with terminating the
          Timer thread. Also, fixed the places where conversion between
          void * and ACE_POSIX_Asynch_Result. Used ACE_reinterpret_cast at
          these places.

Wed May 12 12:14:09 1999  Ossama Othman  <othman@cs.wustl.edu>

        * COPYING: Additional updates/clarifications suggested by Richard
          Stallman.

Wed May 12 00:25:57 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/Thread_Manager.h (ACE_Thread_Manager): Added clarification
          for the semantics differences among wait(), wait_grp() and
          wait_task().

Tue May 11 18:11:51 1999  James C. Hu <jxh@entera.com>

        * ace/config-sunos5.7.h: SunOS 5.7 (aka Solaris 7) does not have a
          limited select.

Tue May 11 17:11:51 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Conn_Test.cpp (spawn_threads): changed some ACE_NEW
          statements to ACE_NEW_RETURN.

Tue May 11 15:43:30 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.h: added ACE_THR_PRI_OTHER_DEF for NT, because MT_Cubit
          uses it.

Tue May 11 14:45:08 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Conn_Test.cpp: fixed use of status on platforms that lack
          fork.

Tue May 11 14:10:29 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-osf-4.0.h: added #define of
          ACE_NEW_THROWS_EXCEPTIONS, if exception handling is enabled.

        * tests/New_Fail_Test.cpp: removed workaround for DEC cxx, and
          modified error message to mention ACE_NEW_THROWS_EXCEPTIONS.

Tue May 11 12:02:03 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-win32-common.h: set __ACE_INLINE__ to 1 if not
          #defined.  It's scary when I trip over syntax errors on Win32
          :-)

Tue May 11 10:00:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * ace/OS.i: fixed name of unused argument for pSOS

        * ace/RB_Tree.{cpp, h}: moved enumerated type from template to
          non-templatized base class to make old g++ happy.

Mon May 10 22:59:46 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/wrapper_macros.GNU: don't set VDIR to
          .shobj/ for VxWorks, because it uses the same .o files for
          static and shared libs.

        * include/makeinclude/platform_vxworks5.x_g++.GNU: disable RTTI
          for egcs, because the Tornado 1.0.x libs don't support it.  No
          harm in disabling for old g++.

Mon May 10 15:33:56 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/INET_Addr.cpp (string_to_addr): Fixed a mistake that
          occurred when integrating Jerry D. De Master
          <jdemaste@ipdinc.com> fix.  Thanks to Zoran and Jerry for
          reporting this.

Mon May 10 15:00:31 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ACE-INSTALL.html: Changed to use ACE_NO_INLINE to supress
          inlining to match with the recent dsp file changes.  Added a
          link to Barry Hoggard's CORBA page which contains ACE related
          MSVC setting hints.

        * ace/Select_Reactor_Base.cpp (unbind): We need to make sure the
          reactor's suspend_set_ also gets cleaned up when unbinding a
          handler.  Thanks to Casey Lucas <clucas@sabre.com> for pointing
          this out.

Mon May 10 17:08:29 1999  James C. Hu <jxh@entera.com>

        * ace/ACE.cpp:
        * ace/config-sunos5.6.h:
        * ace/README: Added support to enter_recv_timedwait,
          enter_send_timedwait, handle_timed_complete, and
          handle_timed_accept to use poll() instead of select() if poll()
          is available and select() is known to have problems.  Created
          ACE_HAS_LIMITED_SELECT macro.  Certain versions of SunOS 5.6 do
          not correctly select on file descriptors that are larger than
          1023.

Mon May 10 13:32:11 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/Conn_Test.cpp (spawn_threads): wait a maximum of 200
          seconds.  Carlos reported that the test sometimes hangs on Irix.

Mon May 10 12:14:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * ace/RB_Tree.cpp: fixed a dangling pointer bug in
          RB_Tree::delete_fixup.  Added pointer tests to all dereferences
          in this piece of code.

Mon May 10 11:35:18 1999  Ossama Othman  <othman@cs.wustl.edu>

        * COPYING: Made some updates suggested by Richard Stallman
          <rms@gnu.org> of the Free Software Foundation
          (http://www.fsf.org/).

Mon May 10 11:01:58 1999  David L. Levine  <levine@cs.wustl.edu>

        * tests/New_Fail_Test.cpp: DEC cxx catches its default,
          NoNamedException.  OK, I guess.

        * tests/Upgradable_RW_Test.cpp: added -f option, which enables
          FIFO thread scheduling.  Some platforms require superuser
          privilege to use it.  Also, wait a maximum of 1 second per
          iteration.  And, replaced some u_longs with u_ints.

        * tests/Thread_Manager_Test.cpp (main): wait a maximum of 60
          seconds, because the test sometimes hangs on SunOS 5.5.1 and
          SunOS 5.7.

Mon May 10 08:26:44 1999  David L. Levine  <levine@cs.wustl.edu>

        * bin/g++dep: added support for our Solaris 7 machines.

Sun May  9 18:07:24 1999  Ossama Othman  <othman@cs.wustl.edu>

        * acconfig.h:
        * configure.in: Added support/tests for
          ACE_LACKS_CHAR_RIGHT_SHIFTS and
          ACE_LACKS_CHAR_STAR_RIGHT_SHIFTS.

        * ace/README: Fixed typo.  ACE_LACKS_LINEBUFFERED_STREAMBUF was
          used twice.  Corrected the appropriate one to
          ACE_LACKS_UNBUFFERED_STREAMBUF.

Sun May 09 11:45:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * ace/RB_Tree.cpp added explicit scoping to RB_SearchResult
          parameter in RB_Tree<...>::find_node ().

Sun May 09 11:30:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * ace/Makefile
          examples/Connection/non_blocking/Makefile
          examples/IPC_SAP/SPIPE_SAP/Makefile
          examples/IPC_SAP/TLI_SAP/Makefile
          examples/Reactor/Misc/Makefile
          examples/Service_Configurator/IPC-tests/client/Makefile
          examples/Service_Configurator/IPC-tests/server/Makefile
          netsvcs/lib/Makefile
          netsvcs/servers/Makefile
          tests/Makefile: ran make depend after adding new RB_Tree
          interface.

Sat May 08 19:30:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * ace/RB_Tree.{cpp, h, i}
          tests/RB_Tree_Test.cpp: finished implementing all methods for
          the ACE_Hash_Map_Manager_Ex compliant interface, fixed a bug in
          the internal tree search method (thanks to David Levine for
          pointing this out), and added a new section to the test that
          exercises the new bind and unbind methods.

Sat May 08 17:09:10 1999  David L. Levine  <levine@cs.wustl.edu>

        * apps/Gateway/Gateway/Event_Channel.cpp (bind_proxy,subscribe):
          wrapped final return statement with ACE_NOTREACHED, to please DU
          cxx 6.2.

Sat May 08 08:49:44 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/CDR_Stream.h: only use unsigned long for Boolean with Green
          Hills 1.8.8 on Chorus, not 1.8.9.

        * ace/IOStream.h,README: added ACE_LACKS_CHAR_STAR_RIGHT_SHIFTS
          and ACE_LACKS_CHAR_RIGHT_SHIFTS support.

        * ace/config-chorus.h: added ACE_LACKS_CHAR_STAR_RIGHT_SHIFTS
          #define for g++.

        * ace/config-vxworks5.x.h: added ACE_LACKS_CHAR_RIGHT_SHIFTS
          #define for Green Hills 1.8.9.

Sat May 08 08:44:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * ace/RB_Tree.{cpp, h, i}
          tests/RB_Tree_Test.cpp
          apps/JAWS/PROTOTYPE/HTTPU/http_headers.cpp: Added more
          implementation code and necessary template instantiations for
          migration of RB_Tree class templates to conform to the
          ACE_Hash_Map_Manager API.

Sat May 08 03:59:52 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/config-win32-common.h: Re-ordered __ACE_INLINE__ macro check
          and definition so users can turn of inlining correctly.
          However, the right thing to do is to define ACE_NO_INLINE macro.

        * ace/ace_{dll,lib}.dsp: Moved RB_Tree.cpp to template folder and
          excluded it from being built.

        * ace/ace_lib.dsp:
        * performance-tests/Misc/basic_perf.dsp:
        * performance-tests/Misc/context_switch_time.dsp:
        * tests/version_tests/*.dsp: We should have used ACE_NO_INLINE
          instead of defining __ACE_INLINE__=0 to supress the use of
          inlining.  Thanks to Nick Sawadsky
          <Nick_Sawadsky@BrooksSoftware.com> for reporting this.

Fri May 07 23:05:24 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/config-vxworks5.x.h: added ACE_LACKS_LINEBUFFERED_STREAMBUF
          for Green Hills 1.8.9.

        * ace/README: added ACE_LACKS_LINEBUFFERED_STREAMBUF.

Fri May  7 19:39:43 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Message_Block_T.i: Found little bug in
          ACE_Locked_Data_Block<> default constructor.

Fri May 07 16:54:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * ace/RB_Tree.{cpp, h, i}: Reorganized and optimized internal
          methods, added read and write guards, implemented all public
          find and unbind methods for the interface comparable to
          ACE_Hash_Map_Manager_Ex.

Fri May 07 14:40:12 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_osf1_cxx.GNU: added, to support
          uniform use of cxx across different OS versions.

        * ace/config-osf1-4.0.h: conditionally #define DIGITAL_UNIX, to
          support definition in CFLAGS.

        * ace/config-osf1.h: added, to support easy migration to DU 5.0.

Fri May 07 11:00:52 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE-INSTALL.html: OK on RedHat 6.0 Linux.

Fri May 07 08:58:47 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.{h,i}: added some QNX support.  In OS.i, this mostly
          consisted of adding a !defined (ACE_LACKS_MUTEXATTR_PSHARED)
          check to _POSIX_THREAD_PROCESS_SHARED.  Thanks to Alain Magloire
          <alain@qnx.com> for providing this support.

Thu May  6 21:48:26 1999  Ossama Othman  <othman@cs.wustl.edu>

        * acconfig.h:
        * configure.in:
        * ace/OS.h:
        * ace/README:
        * ace/config-hpux11.h:
        * ace/config-irix6.x-g++.h:
        * ace/config-irix6.x-kcc.h:
        * ace/config-irix6.x-sgic++.h:
        * ace/config-linux-lxpthreads.h:
        * ace/config-osf1-4.0.h:
        * ace/config-sco-5.0.0-mit-pthread.h:
        * ace/config-sunos5.5.h: Removed all references to
          ACE_HAS_PTHREAD_SIGMASK.  This macro has been deprecated.

Thu May  6 20:12:57 1999  Ossama Othman  <othman@cs.wustl.edu>

        * acconfig.h:
        * configure.in: Added tests/support for ACE_LACKS_PTHREAD_SIGMASK,
          ACE_LACKS_TCP_NODELAY and ACE_LACKS_NULL_PTHREAD_STATUS.  Thanks
          to David for providing a test for ACE_LACKS_NULL_PTHREAD_STATUS.

Thu May 06 14:26:54 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/README,ace/Pipe.cpp (open): added support for
          ACE_LACKS_TCP_NODELAY.  Thanks to Alain Magloire <alain@qnx.com>
          for providing the patch.

Thu May  6 14:23:14 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/Synch_T.cpp: Removed ACE_ALLOC_HOOK_DEFINE macros for the
          Guard<> objects, they don't need them (because they are
          allocated on the stack) and the HOOK_DECLARE macros where not
          used in the header file.

        * bin/count_lines: Several new file types, fixed computations when
          multiple modules are used.

Thu May 06 12:28:54 1999  David L. Levine  <levine@cs.wustl.edu>

        * docs/ACE-FMM.html: replaced a > with &gt; and added RCS Id
          string.

        * ACE-INSTALL.html: added link to docs/ACE-FMM.html.

Thu May 06 12:23:51 1999  Steve Huston  <shuston@riverace.com>

        * ace/OS.i (recvv, sendv): Added code to make these functions work
          on Win32 w/ Winsock 1.1.

Wed May 05 15:10:37 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.h: added ACE_U_ONE_SECOND_IN_*SECS.  They're typed and
          unsigned.  The old ACE_ONE_SECOND_IN_*SECS macros are retained
          for backward compatibility.

Wed May  5 13:58:25 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/OS.i: Don't use poll() for the implementation of
          ACE_OS::sleep(), it has bad resolution and it gives wrong
          results on Linux.

        * tests/High_Res_Timer_Test.cpp: Added new option to run several
          iterations of each interval.

Wed May 05 13:14:52 1999  Steve Huston  <shuston@riverace.com>

        * ace/ACE.cpp: Removed DllMain - Win32 does not have the gusto to
          handle the initialization/finalization in this way. It causes
          DLL dependency problems which result in early detachment of
          winsock, and possible network data loss in some cases.

        * ace/OS.cpp, Object_Manager.cpp: Clarified some comments
          regarding multiple ACE_OS_Object_Manager and ACE_Object_Manager
          objects in existence and how they're handled.

        * tests/ACE_Init_Test.cpp: Always does ACE::init and ACE::fini
          now.  This is one example of how to handle a non-console program
          in Win32.

Wed May 05 13:07:49 1999  David L. Levine  <levine@cs.wustl.edu>

        * bin/Makefile: replaced /bin/rm with $(RM) and removed clean
          pseudotarget.

Tue May 04 20:38:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * tests/RB_Tree_Test.cpp: Added missing explicit template
          instantiations for ACE_RB_Tree_Iterator_Base.  Thanks to Carlos
          O'Ryan for reporting this.

        * include/makeinclude/platform_psos_diab_ppc.GNU: added -g flag
          back into debug flags since it can easily be deactivated via
          make debug=0.

1999-05-04  Seth Widoff  <swidoff@cs.cmu.edu>

        * ace/Containers_T.cpp (ACE_Array_Base<T>::max_size): When
          resizing the array to be larger, the max_size method was copying
          in the contents of the older, smaller array, but not
          initializing the new elements.

Tue May  4 17:37:30 1999  Kirthika Parameswaran  <kirthika@cs.wustl.edu>

        * examples/Web_Crawler/Options.cpp (parse_args): Change the
          default options from "www.cs.wustl.edu" to "tao.cs.wustl.edu".

Tue May 04 16:24:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * ace/RB_Tree.{cpp, h, i}: Added deprecation comments to methods
          that are going to be replaced by the new Hash_Map_Manager
          compliant interface.  Factored out iterator base class, added
          reverse iterator.  Interim checkin since it all compiles and
          RB_Tree_Test runs clean.

Tue May 04 15:56:41 1999  Steve Huston  <shuston@riverace.com>

        * ace/ACE.cpp: Re-enabled DllMain (see Mon May 3 entry from Chris
          Gill).

        * ace/OS.cpp, Object_Manager.cpp: In ACE_OS_Object_Manager and
          ACE_Object_Manager, differentiate between The singleton instance
          and other instances when allocating and freeing per-process
          information.

        * tests/run_tests.bat: Added ACE_Init_Test.

Mon May  3 18:04:32 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * examples/Reactor/Proactor/test_aiocb_ace.cpp: Added this
          file. If this test is sucessful, ACE_POSIX_AIOCB_PROACTOR could
          be defined for a platform.

Mon May 03 09:35:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * ace/RB_Tree.cpp: fixed bug in ACE_RB_Tree::RB_delete_fixup in
          which a null pointer was dereferenced while trying to determine
          the color of the node that was being pointed to.  Per the RB
          Tree discussion in Cormen Lieserson and Rivest's "Introduction
          to Algorithms", after which this implementation is modeled, a
          nil node is implicity treated as having been colored BLACK.
          Thanks to Long Hoang <LHoang@hwdcsaws.cahwnet.gov> for reporting
          the problem and providing a test program that showed the bug.

Mon May 03 15:53:15 1999  David L. Levine  <levine@cs.wustl.edu>

        * include/makeinclude/platform_vxworks5.x_g++.GNU,
          tests/run_tests.vxworks,ACE-INSTALL.html: added support for
          shared lib builds.  Thanks to Ramiro Penataro Blanco
          <penataro@ll.iac.es> and James D. Rucker
          <jdrucker@huey.jpl.nasa.gov> for figuring this out, and
          providing detailed instructions for others to follow.

Mon May 03 15:20:00 1999 Kirthika Parameswaran  <kirthika@bambuca.cs.wustl.edu>

        * examples/Web_Crawler/main.cpp:
        * examples/Web_Crawler/Web_Crawler.{h,cpp}:
        * examples/Web_Crawler/Cached_Connect_Strategy_T.{h,i,cpp}:
        * examples/Web_Crawler/Caching_Strategies_T.{h,i,cpp}:
        * examples/Web_Crawler/Command_Processor.{h,cpp}:
        * examples/Web_Crawler/HTTP_URL.{h,cpp}:
        * examples/Web_Crawler/Iterators.{h,cpp}:
        * examples/Web_Crawler/Mem_Map_Stream.{h,cpp}:
        * examples/Web_Crawler/Optimal_Cache_Map_Manager_T.{h,i,cpp}:
        * examples/Web_Crawler/Options.{h,cpp}:
        * examples/Web_Crawler/URL.{h,cpp}:
        * examples/Web_Crawler/URL_Addr.{h,cpp}:
        * examples/Web_Crawler/URL_Status.{h,cpp}:
        * examples/Web_Crawler/URL_visitor.{h,cpp}:
        * examples/Web_Crawler/URL_Visitor_Factory.{h,cpp}:
        * examples/Web_Crawler/Makefile
        * examples/Web_Crawler/README

         This example is a HTTP client which crawls over the link provided
         and checks whether the links recusively are valid or not.
         This example was used to test teh auto-purging feature where the
         connections are removed from the connection cache when the process
         runs out of file descriptors.

Mon May 03 14:46:28 1999  Steve Huston  <shuston@riverace.com>

        * tests/ACE_Init_Test.dsp: Fixed to build on all configurations (for
          Intel anyway).

Mon May 03 10:30:37 1999  David L. Levine  <levine@cs.wustl.edu>

        * ACE version 4.6.38 released.

Mon May  3 09:56:06 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/INET_Addr.cpp (get_host_name): Make sure to check if
          get_host_name() fails and do something useful in this case.
          Thanks to Frank O'Dwyer <fod@brd.ie> for reporting this.

Mon May 03 09:35:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * ace/ACE.cpp: disabled BOOL APIENTRY DllMain(HANDLE hModule,
          DWORD ul_reason_for_call, LPVOID lpReserved) by having it
          just return TRUE.  This function is used only on NT.  This
          is a temporary workaround for the problem of tao_idl
          crashing on NT, and will be replaced ASAP with a more
          complete fix to Object Manager initialization/cleanup at
          DLL load/unload time on NT.  Thanks to David Levine for
          suggesting this fix.

Mon May 03 09:27:54 1999  David L. Levine  <levine@cs.wustl.edu>

        * docs/ACE-guidelines.html: added guideline to put
          spaces around comment delimiters.  Thanks to Chris
          Gill for suggesting this.

Sun May 02 14:36:43 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.h: Added ghs back to the list of compilers for which
          ACE_NOTREACHED disappears.  It was causing warnings for
          many ACE and TAO files.

Sun May 02 08:21:13 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.i (pthread_sigmask): added ACE_UNUSED_ARGs to
          NOTSUP case.

        * ace/OS.i (pthread_sigmask),ace/config-chorus.h,ace/README:
          added ACE_LACKS_PTHREAD_SIGMASK.

Sat May 01 17:33:04 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.cpp,Object_Manager.cpp: reverted this change because
          it causes a seg fault on NT:

        Thu Apr 29 13:41:52 1999  Steve Huston  <shuston@riverace.com>

        * ace/{OS.cpp Object_Manager.cpp}: Fixed leaking ACE_Object_Manager
          when config has #define ACE_HAS_NONSTATIC_OBJECT_MANAGER 0.

Sat May 01 12:06:57 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/ACE.cpp:
        * ace/config-win32.h:  Reverted my previous change.  I didn't
          notice David had already fixed it.  Thanks David.

Sat May 01 01:48:29 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/ACE.cpp (DllMain): Only use DllMain to control
          Object_Manager's lifecycle when
          ACE_USES_DLL_TO_MANAGE_THE_LIFECYCLE_OF_OBJECT_MANAGER is
          defined and we are building ACE as a DLL.

        * ace/config-win32.h: Defining
          ACE_USES_DLL_TO_MANAGE_THE_LIFECYCLE_OF_OBJECT_MANAGER =1, when
          compiling DLL version of ACE will cause then ACE::init/fini be
          called automatically for you in DllMain when ACE gets linked
          in/unlinked.

          Defining ACE_USES_DLL_TO_MANAGE_THE_LIFECYCLE_OF_OBJECT_MANAGER
          =1 automatically define ACE_HAS_NONSTATIC_OBJECT_MANAGER to 1
          and define ACE_DOESNT_INSTANTIATE_NONSTATIC_OBJECT_MANAGER.

Fri Apr 30 22:53:01 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/OS.h: put Object_Manager back on the stack of main,
          instead of using ACE::init () and ACE::fini ().  It
          should be functionally equivalent, and then some:  if
          the user's main () returns, the Object_Manager will get
          properly destroyed if it's on the stack.  And, it's better
          for subset support if we avoid class ACE calls from OS.h.

        * include/makeinclude/rules.lib.GNU: cleaned up a bit.

Fri Apr 30 17:42:11 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * ace/OS.i (pthread_sigmask):
        * ace/OS.h (ACE_OS): Added wrapper for <pthread_sigmask> to get
        the Proactor code compile on LynxOS.

        * ace/config-lynxos.h (ACE_HAS_AIO_CALLS):
         Enabled ACE_HAS_AIO_CALLS for LynxOS. Also enabled
         ACE_HAS_AIOCB_PROACTOR since LynxOS 3.0.0 has not got
         <pthread_sigmask> yet, so signal proactor cannot work correctly.

        * ace/POSIX_Proactor.cpp:
        * examples/Reactor/Proactor/test_aiosig_ace.cpp
        (setup_signal_delivery): Added ACE_OS:: scope to pthread_sigmask
        so that it works (fails!!) correctly on LynxOS.

        * examples/Reactor/Proactor/post_completions.cpp:
        * examples/Reactor/Proactor/test_timeout.cpp: Added 'main'
        function for platforms where only AIOCB_Proactor is enabled so
        that the test prints out a message.

        * examples/Reactor/Proactor/Makefile:

Fri Apr 30 14:44:12 1999  Darrell Brunsch <brunsch@cs.wustl.edu>

        * ACE-INSTALL.html: Added a note about manually cleaning out the
          ACE_wrappers directories on Win32, which could be required for a
          true start from scratch build.  Thanks to David Hooker
          <DHooker@uniview.net> for this insight.

Fri Apr 30 14:06:41 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * COPYING: Updated the COPYING file to reflect the use new of
          ACE(TM) and TAO(TM).

Fri Apr 30 13:23:22 1999  Steve Huston  <shuston@riverace.com>

        * docs/tutorials/017/Barrier_i.cpp:
        * docs/tutorials/018/token.cpp:  Added explicit template
          instantiations.

Fri Apr 30 12:11:36 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/OS.i (gethostbyname2):

          Added an IPv4-only implementation.  If ACE_HAS_IP6 is not defined,
          the IPv4-only implementation will be used.

Fri Apr 30 12:11:50 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * tests/Basic_Types_Test.cpp: Added checks for sizeof(long) ==
          sizeof(void*) and sizeof(long) >= sizeof (a_function_pointer).
          Certain code in ACE depends on the assumptions.

Fri Apr 30 11:24:26 1999  Steve Huston  <shuston@riverace.com>

        * tests/ACE_Init_Test.cpp: Added compile-time change to adapt to
          build w/ static ACE lib and ACE_HAS_NONSTATIC_OBJECT_MANAGER.
        * tests/version_tests/ACE_Init_Test.dsp: Changes to build clean on
          all configurations.

Fri Apr 30 02:06:53 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/Parse_Node.cpp (symbol): According to the new ANSI C++
          specification, casting a void* pointer to a function pointer is
          not allowed.  However, casting a void* pointer to an integer
          type that is large enough to hold the pointer value is legal.  I
          chose to cast the return value to long since it should be large
          enough to hold the void* pointer's value on most platforms. I am
          not sure if casting a long value to a function pointer is legal
          or not (can't find a good explanation in spec) but it prevent
          SunC++ 5.0 compilers from complaining about illegal pointer
          conversion.

        * ace/OS.h: Removed ACE_non_function_ptr_to_function_ptr_cast,
          it is no longer needed.

Fri Apr 30 00:36:23 1999  Ossama Othman  <othman@cs.wustl.edu>


        * ace/Get_Opt.cpp:
        * ace/TLI_Acceptor.cpp:
        * ace/TLI_Connector.cpp:

          Cast away const from string literals using ACE_const_cast to make
          Sun C++ 5.0 happier.

Thu Apr 29 18:32:43 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/OS.h: Removed ghs from the list of compilers for which
          ACE_NOTREACHED disappears.  It was causing warnings for
          TAO/orbsvcs/orbsvcs/Naming/Persistent_Context_Index_T.cpp.

Thu Apr 29 19:48:25 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/OS.{h,i} (ACE_OS):

          More IPv6 support.  Added support for the new IPv4/IPv6
          inet_ntop() and inet_pton() calls.  If ACE_HAS_IP6 is not
          defined, these calls will use IPv4 implementations (see
          Stevens' book "UNIX Network Programming - Volume I") and
          return an error if a family other than AF_INET is passed to
          them.

        * ace/OS.h:

          Define INET_ADDRSTRLEN and INET6_ADDRSTRLEN if they don't
          get defined after including <netinet/in.h>.

Thu Apr 29 18:32:43 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/README:
        * ace/OS.h (ACE_OS):
        * ace/OS.i (gethostbyname2):

          Added support for the gethostbyname2() system call.  It is only
          enabled if ACE_HAS_IP6 is defined.  When I have time, I'll add
          more IPv6 support.

Thu Apr 29 15:30:04 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/INET_Addr.cpp (string_to_addr): Added support to check for
          both "port numbers" and "port names".  Thanks to Jerry D. De
          Master <jdemaste@ipdinc.com> for suggesting this.

        * ace/Select_Reactor_T.h,
          ace/Reactor.h,
          ace/Select_Reactor_T.h,
          ace/TP_Reactor.h (ACE_TP_Reactor): Updated the documentation to
          clarify the purpose of the <restart> flag.  Thanks to Susan
          Liebeskind <shl@cc.gatech.edu> for reporting this.

Thu Apr 29 13:41:52 1999  Steve Huston  <shuston@riverace.com>

        * ace/{OS.cpp Object_Manager.cpp}: Fixed leaking ACE_Object_Manager
          when config has #define ACE_HAS_NONSTATIC_OBJECT_MANAGER 0.  Now
          both ACE_OS_Object_Manager and ACE_Object_Manager remember if they
          were dynamically allocated whether the above #define is used or not
          and correctly clean up and track the singleton properly.
          Thanks to David and Irfan for identifying this and helping with the
          solution.

Wed Apr 28 20:21:12 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Synch_T.h (class ACE_Anti_*_Guard): I had accidentally
          checked in the anti guard classes.  These are not needed since
          we decided to stick with the reverse lock class rather than the
          anti guard classes.

Wed Apr 28 18:02:36 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/OS.h: Added a new macro called
          ACE_non_function_ptr_to_function_ptr_cast to get around some
          compiler constrain.  In face, ANSI C++ standard prevents casting
          from a non-function pointer (e.g., void *) to a function
          pointer.  Currently, only egcs check for this condition.

        * ace/Parse_Node.cpp (symbol): Changed to use the new
          ACE_non_function_ptr_to_function_ptr_cast.

Wed Apr 28 16:53:16 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * examples/Reactor/Proactor/Aio_Platform_Test_C.cpp: Added this
        file, a simple C version of the
        $ACE_ROOT/tests/Aio_Platforms_Test.cpp. Useful for submitting bug
        reports etc.

        * ace/Proactor.cpp:
        * ace/POSIX_Asynch_IO.cpp: Fixed old g++ warnings

Wed Apr 28 15:39:14 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/Parse_Node.cpp (symbol): Use reinterpret_cast to cast
          dlsym's return value.

Wed Apr 28 12:40:26 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/Synch_T.{i,cpp} (~ACE_Reverse_Lock): uninlined destructor.
          See docs/ACE-guidelines.html for an explanation of why a
          class should have at least one non-inline, non-pure virtual
          function if it has any virtual functions.  egcs 1.1.1b
          needed this one.

Wed Apr 28 09:02:26 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/config-sunos5.5.h: It appears that SunC++ 5.0 wants
          ACE_HAS_THR_C_DEST to be defined.

        * ace/SString: Clarified the comments a bit to avoid confusion.
          Also, moved the definition of ACE_SString to AFTER ACE_CString
          and ACE_WString since they are more general.  Thanks to Kevin
          Lyda <kevin.lyda@trintech.com> for reporting this.

Tue Apr 27 20:59:52 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * netsvcs/clients/Naming: Moved the README file into the Client/
          directory since that's what it described.

        * netsvcs/clients/Naming/Client/Client_Test.cpp: Reformatted some
          code to conform to ACE programming guidelines.

        * ace/Naming_Context.cpp (parse_args): Oops, fixed a braino
          related to strcmp().  Thanks to Valery Arkhangorodsky
          <avalery@balisoft.com> for reporting this.

Tue Apr 27 18:00:31 1999  Steve Huston  <shuston@riverace.com>

        * ace/OS.cpp (ACE_OS_CString, ACE_OS_WString): Fixed one-off error
          in allocating new string's memory.

Tue Apr 27 17:36:28 1999  Ossama Othman  <othman@cs.wustl.edu>

        * m4/threads.m4:

          Restructured thread detection test so that it properly detects
          threads on platforms that provide PTHREADS backward compatibility
          macros, such as Digital Unix 4.0 and 5.0.

Tue Apr 27 18:56:00 1999  Chris Gill  <cdgill@cs.wustl.edu>

        * ace/Containers_T.{cpp, h}
          tests/OrdMultiSet_Test.cpp: added a workaround for a problem with
          implicit template instantiation and a do-nothing destructor
          definition.  Thanks to Sarmeesha Reddy <sreddy@tr.comm.mot.com> and
          Steven Tine <stevent@tr.comm.mot.com> for reporting this.

        * include/makeinclude/platform_psos_diab_ppc.GNU: changes to use
          the board support package linker file. Thanks to Sarmeesha
          Reddy <sreddy@tr.comm.mot.com> and Steven Tine
          <stevent@tr.comm.mot.com> for contributing this change.

Tue Apr 27 16:30:57 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/UNIX_Addr.h (ACE_UNIX_Addr):

          Corrected typographical error in comment.

Tue Apr 27 12:57:06 1999  Ossama Othman  <othman@cs.wustl.edu>

        * configure.in:

          Removed `tests/log/Makefile' from the list of files to
          generate (i.e. removed from AC_OUTPUT macro call).

        * tests/Makefile.am:

          Corrected a typo.  I neglected to add "_SOURCES" to the end
          of the Collection_Test source variable variable.  Also added
          more missing tests to the list of test programs.  Commented out
          Cache_Manager_Test.  It appears to need a header that doesn't
          exist.

        * ace/Makefile.am (pkginclude_HEADERS):

          Removed `Timer_Queue.i' from the list of headers.

        * bin/autogen:
        * bin/bootstrap:

          Renamed the `autogen' script to `bootstrap'.

Tue Apr 27 11:54:53 1999  Ossama Othman  <othman@cs.wustl.edu>

        * configure.in:

          Temorarily removed my experimental C++ libtool support so that
          I can get a semi-working test distribution out on the net.

        * ltconfig:
        * ltmain.sh:

          Reverted to more stable version, i.e. w/o my C++ support.

        * m4/threads.m4:

          Added KAI C++ thread flag check.

Tue Apr 27 11:45:40 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tests/Collection_Test.cpp (main): Added some additional array
          tests and fixed template instantiation errors.  Thanks to David
          Levine for pointing them out.

        * ace/OS.h (ACE_DES_FREE): Changed all the ACE_DES* macros to
          check for zero pointers.  Thanks to Torsten Kuepper
          <kuepper2@uni-wuppertal.de> for pointing this bug out.

Tue Apr 27 11:08:35 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/Basic_Types.h: Forced KAI compiler to use ACE_U_LongLong if
          ACE_LACKS_LONGLONG_T is defined.

        * ace/DLL.cpp:
        * ace/Service_Config.i:
        * ace/Service_Object.i:
        * ace/INET_Addr.cpp: Some CE related changes.

Tue Apr 27 00:03:16 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * tests/Collection_Test.cpp (main): Added test code for ACE_Array.

Mon Apr 26 23:55:43 1999  Irfan Pyarali  <irfan@cs.wustl.edu>

        * ace/Synch_T.h (class ACE_Reverse_Lock): Removed constructor that
          created the lock.  There were two reasons for this: (a) it was
          unrealistic that the reverse lock would own and create the
          regular lock and (b) this constructor made it impossible that
          ACE_Reverse_Lock can be used with ACE_Lock (the abstract
          class).  Thanks to Carlos for pointing this out.

Mon Apr 26 21:43:23 1999  Ossama Othman  <othman@cs.wustl.edu>

        * ace/Makefile.am (pkginclude_HEADERS, libACE_IPC_la_SOURCES):

          Added ATM_Addr sources to these variables.

        * ace/Makefile.am (EXTRA_libACE_la_SOURCES):

          Accidentally removed this variable.  It is needed for
          conditionally built sources, such as `gethrtime.cpp'.

        * tests/Makefile.am:

          Added newly added tests to the list of test programs to be built.
          Changed "noinst_PROGRAMS" variable to "check_PROGRAMS" so that
          tests only get built when a `make check' is issued by the user.

Mon Apr 26 19:29:25 1999  Ossama Othman  <othman@cs.wustl.edu>

        * tests/Reverse_Lock_Test.cpp (main):

          ACE_START_TEST macro had "Thread_Mutex_Test" instead of
          "Reverse_Lock_Test."

Mon Apr 26 17:01:22 1999  Steve Huston  <shuston@riverace.com>

        * ace/ACE.cpp (DllMain): Re-enabled this for use on Win32.

        * ace/OS.h (main): On non-pSoS, use ACE::init, ACE::fini rather than
          creating object manager instances on the stack.  Allows a single
          instance regardless of program type; especially helpful on Win32.

        * ace/OS.cpp (ACE_OS_Object_Manager ctor):
        * ace/Object_Manager.cpp (ACE_Object_Manager ctor):
          Don't set instance_ if it was already set.  So if two
          ACE_Object_Manager instances end up getting created, the first one
          stays The Instance, and the second gets used privately by its
          creator.  Previously, the original was forgotten.  Thanks to David
          Levine for working out this and the above details with me to get the
          Win32 crowd in business without platform-specific hacks.

Mon Apr 26 16:43:32 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/Asynch_IO_Impl.h (ACE_Asynch_[Read|Write]_File_Impl):
          Declared the read/write pure virtual methods of
          ACE_Asynch_[Read|Write]_Stream_Impl again in these class to
          avoid KAI compiler's overwriting pure virtual function
          warnings.

Mon Apr 26 10:54:23 1999  Carlos O'Ryan  <coryan@cs.wustl.edu>

        * ace/High_Res_Timer.h:
          Moved the static method hrtime_to_tv to the public section. It
          is useful outside this class.

        * ace/Synch_T.cpp:
          The default constructor for ACE_Reverse_Lock should not allocate
          the locking mechanism, otherwise it cannot work with ACE_Lock.

Mon Apr 26 07:30:51 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * ace/OS.i (fstat): Changed to use CE's implementation and added
          some features that're supported on other Win32 platforms.  The
          original implementation for Win32 closed down the file handle
          accidentally which is not a "Good Thing[TM]".  Thanks to Dominic
          Williams <dom@connected-place.co.uk> for pointing this out.

Sun Apr 25 21:35:37 1999  David L. Levine  <levine@cs.wustl.edu>

        * ace/ACE.{h,cpp},OS.{h,cpp},Object_Manager.{h,cpp} (init,fini):
          moved init_fini_count_ from ACE Object_Managers to ACE, so that
          it is only used via ACE::init () and ACE::fini ().  Thanks
          to Steve Huston for pointing out that the old way didin't work
          if an Object_Manager was created prior to starting main (),
          and there were ACE::init ()/ACE::fini () calls in main ().

Sun Apr 25 16:59:21 1999  Nanbor Wang  <nanbor@cs.wustl.edu>

        * include/makeinclude/platform_sunos5_kcc.GNU: Fixed incorrect
          compiler flags.

        * ace/config-sunos5.7.h: Added definition of uint64_t on KAI.

        * ace/config-kcc-common.h: Changed to use non-static object
          manager.
          Defined ACE_SIZEOF_LONGLONG.  KAI compiler has type long long.

        * ace/OS.h: ACE_NOTREACHED should expand to nothing on KAI
          compiler.

        * ace/CDR_Stream.h (ACE_CDR): KAI compiler doesn't have
          longlong_t.

        * ace/Basic_Types.h: KAI compiler should define ACE_UINT64 as
          unsigned long long.

Sun Apr 25 14:52:18 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * COPYING,
          TAO/COPYING: Updated the ACE+TAO COPYING information to
          emphasize the relationship to open source.  Thanks to Malcolm
          Spence <spence_m@ociweb.com> for suggesting the wording.

Sat Apr 24 23:03:31 1999  Alexander Babu Arulanthu  <alex@cs.wustl.edu>

        * ACE_wrappers/ace/POSIX_Asynch_IO.cpp
        * ACE_wrappers/ace/POSIX_Asynch_IO.h
        * ACE_wrappers/ace/POSIX_Proactor.cpp
        * ACE_wrappers/ace/POSIX_Proactor.h
        * ACE_wrappers/ace/Proactor.cpp
        * ACE_wrappers/ace/Proactor.h
        * ACE_wrappers/ace/Proactor_Impl.h

        * ACE_wrappers/examples/Reactor/Proactor/Makefile
        * ACE_wrappers/examples/Reactor/Proactor/README
        * ACE_wrappers/examples/Reactor/Proactor/test_aiocb.cpp
        * ACE_wrappers/examples/Reactor/Proactor/test_aiosig.cpp
        * ACE_wrappers/examples/Reactor/Proactor/test_aiosig_ace.cpp
        * ACE_wrappers/examples/Reactor/Proactor/test_proactor.cpp
        * ACE_wrappers/examples/Reactor/Proactor/test_timeout.cpp

        - Completed Multithreading of POSIX_SIG_Proactor.

        - Introduced another constructor for ACE_POSIX_SIG_Proactor for taking
          signal mask to be used with the Proactor.

        - Thanks to Dave Butenhof <butenhof@zko.dec.com> for helping a lot to
          understand the various things in the POSIX4 standard.

        - Thanks to Dave suggestion of keeping null_handler for the sigaction
          to real-time signals. With this and a couple of other correct POSIX
          things SIG proactor is now working with in Solaris 2.7.

        - Lynx OS doesnt support <pthread_sigmask>, so it couldnt be
          multithreaded. Enabled AIOCB_Proactor for this platform.

        - Added an example to make use of the real-time signal numbers for the
           asynchronous I/O calls.

        * examples/Reactor/Proactor/test_posix_sig_proactor.cpp: This
          program demonstrates how to post fake completions to The
          Proactor. It also shows the how to specify the particular
          real-time signals to post completions.

        * ace/config-lynxos.h: Enabled ACE_POSIX_AIOCB_PROACTOR for this
          platform, since <pthread_sigmask> was not available. Without
          <pthread_sigmask>, SIG_Proactor can not work correctly.

        * ace/config-linux-lxpthreads.h: Removed ACE_HAS_AIO_CALLS. Even
          simple aio calls test is hanging.

Sat Apr 24 13:09:27 1999  Douglas C. Schmidt  <schmidt@tango.cs.wustl.edu>

        * ace/Containers_T.h: Added allocator support to ACE_Array.
